//*************************************** Decodeur() ********************************************
class Decodeur {
    String    nom_fabricant;
    String    nom_famille;
    String    nom_modele;
    int       ligne            = 0;
    String    memo_depart      = ".";
    String    onglet_choisi;
    String    onglet_courant;
    int       courant_moteur_max = 0;
    int       courant_pic_moteur = 0;
    int       duree_pic_moteur   = 0;
    int       courant_total_max  = 0;
    int       courant_pic_total  = 0;
    String    connecteur;
    int       longueur         = 0;
    int       largeur          = 0;
    int       hauteur          = 0;
    int       v_reelle         = 0;
    float     frein            = 1F;
    float     elan             = 1F;
    int       NMRA             = 0;
    int       numero_version   = 0;
    int       CV1_             = 3;
    int       CV2_             = 0;
    int       CV3_             = 0;
    int       CV4_             = 0;
    int       CV5_             = 0;
    int       CV6_             = 0;
    int       CV7_             = 0;
    int       CV8_             = 0;
    int       CV17_            = 0;
    int       CV18_            = 0;
    int       CV28_            = 0;
    int       CV29_            = 0;
    int       CV66_            = 0;
    int       CV95_            = 0;            


    ArrayList<Zone>  toutes_zones    = new ArrayList<Zone>();
    StringList       reordonne       = new StringList();
    StringList       debut_ligne     = new StringList();
    Onglet[] Onglets;
    
    Decodeur(Onglet[] onglets1) {
       Onglets = onglets1;
    }  //  constructeur    
    
    //---------------------------- calcule_donnees() -----------------------------
    void calcule_donnees() {
        int   nb_onglets     = Onglets.length;
        reordonne.clear();
        for (int i = 0; i < nb_onglets; i++) {
            reordonne.append(Onglets[i].nom_onglet);
        }
        debut_ligne.clear();
        affiche_onglets();
        dessine_les_fabricants = false;
        dessine_les_familles   = false;
        dessine_les_modeles    = false;
        choix_onglet           = true;
    }
    //---------------------------- reordonne_onglets() ----------------------------
    void reordonne_onglets() {
        int   nb_onglets     = Onglets.length;
                                                                                   //println("-------------------------------------------------------");
        //-------------------------- reordonne les étiquettes d'onglets ----------
        boolean trouve  = false;
        boolean trouve1 = false;
        for (Zone zon0 : toutes_zones) {
            if (zon0.nom_zone.equals(onglet_choisi) && !trouve) {
                onglet_courant = zon0.debut[zon0.ligne];
                                                                                   //println("1 : onglet au bout de la ligne =", onglet_courant);
                trouve = true;
            }
            if (trouve) {
                if (!zon0.debut[zon0.ligne].equals(onglet_courant)) {
                    onglet_courant = zon0.debut[zon0.ligne];
                                                                                   //println("2 : onglet début de ligne suivante si trouvé à la fin =", onglet_courant);
                    trouve1 = true;
                    break;
                }
            }
        }
        for (Zone zon0 : toutes_zones) {
            if (!trouve1) {
                if (!zon0.debut[zon0.ligne].equals(onglet_courant)) {
                    onglet_courant = zon0.debut[zon0.ligne];
                    break;
                }
            }
        }
                                                                                   //println("3 : onglet début de ligne suivante si trouvé au début =", onglet_courant);
        reordonne.clear();
        trouve = false;
        for (int i = 0; i < nb_onglets; i++) {
            if (Onglets[i].nom_onglet.equals(onglet_courant) || trouve) {
                trouve = true;
                                                                                   //println(i, " ", Onglets[i].nom_onglet);
                reordonne.append(Onglets[i].nom_onglet);
            }
        }
                                                                                   //println("*************");
        for (int i = 0; i < nb_onglets; i++) {
            if (!Onglets[i].nom_onglet.equals(onglet_courant)) {
                                                                                   //println(i, " ", Onglets[i].nom_onglet);
                reordonne.append(Onglets[i].nom_onglet);
            } else {
                break;
            }
        }
                                                                                   //println();
                                                                                   //for (String ong0 : reordonne) {
                                                                                   //    println(ong0);
                                                                                   //}
        affiche_onglets();
    }
    //---------------------------- decoupe_modele() ----------------------------
    void decoupe_modele(String _reference_complete) {
        int fab       = _reference_complete.indexOf("/");
        int mod       = _reference_complete.indexOf("//");
        nom_fabricant = _reference_complete.substring(0, fab);
        nom_famille   = _reference_complete.substring(0, mod);
        nom_modele    = _reference_complete;
    }
    //----------------------------------- affiche_onglets() -------------------------------------
    void affiche_onglets() {
        int   numero_onglet  = 0;
        int   onglet_initial = 0;
        int   nb_onglets     = Onglets.length;
        ligne                = 0;
                                                                                   //println("-------------------------------------------------------");
        float longueur_ligne = 0F;
        toutes_zones.clear();
        while (numero_onglet < nb_onglets) {
                                                                                   //println("Avant : longueur_ligne =", longueur_ligne, "width =", width, "numero_onglet =", numero_onglet, "nb_onglets =", nb_onglets);
            while (longueur_ligne < width && numero_onglet < nb_onglets) {
                                                                                   //println("numero_onglet =", numero_onglet, "debut_ligne.hasValue(reordonne.get(numero_onglet)) =", debut_ligne.hasValue(reordonne.get(numero_onglet)),
                                                                                   //"longueur_ligne =", longueur_ligne);
                if (debut_ligne.hasValue(reordonne.get(numero_onglet)) && longueur_ligne > 0) {
                    break;
                } else {
                    longueur_ligne = longueur_ligne+reordonne.get(numero_onglet).length()*ZOOM;
                                                                                   //println("En cours : "+Onglets[numero_onglet], "longueur_ligne =", longueur_ligne, "width =", width, "numero_onglet =", numero_onglet);
                    numero_onglet++;
                }
            }
            if (longueur_ligne > width) {
                longueur_ligne = longueur_ligne-reordonne.get(numero_onglet-1).length()*ZOOM;
            }
            if (numero_onglet == nb_onglets) {
                                                                                   //println("fin : numero_onglet =", numero_onglet, "onglet_initial =", onglet_initial);
                blanc[ligne] = (width-2F*E-longueur_ligne)/2F/(nb_onglets-onglet_initial);
                                                                                   //println("fin : width =", width, "longueur_ligne =", longueur_ligne, "ligne =", ligne, "blanc[ligne] =", blanc[ligne]);
                debut_onglet[ligne] = 0F;
                memo_depart = ".";
                for (int i = onglet_initial; i < nb_onglets; i++) {
                    calcule_petit_onglet(reordonne.get(i), ligne);
                }
                break;
            } else {
                                                                                   //println("numero_onglet =", numero_onglet, "onglet_initial =", onglet_initial);
                if (gestion.one_shot) {
                    numero_onglet--;
                }
                blanc[ligne]        = (width-2F*E-longueur_ligne)/2F/(numero_onglet-onglet_initial);
                                                                                   //println("width =", width, "longueur_ligne =", longueur_ligne, "ligne =", ligne, "blanc[ligne] =", blanc[ligne]);
                debut_onglet[ligne] = 0F;
                memo_depart = ".";
                                                                                   //println("onglet initial avant =", onglet_initial, "one_shot =", gestion.one_shot);
                for (int i = onglet_initial; i < numero_onglet; i++) {
                    calcule_petit_onglet(reordonne.get(i), ligne);
                }
                onglet_initial = numero_onglet;
                                                                                   //println("onglet initial après =", onglet_initial);
                longueur_ligne = 0F;
                ligne++;
            }
        }
    }
    //---------------------------------- calcule_petit_onglet() ---------------------------------------
    void calcule_petit_onglet(String _texte, int _ligne) {
        float longueur_texte = _texte.length()*ZOOM;
                                                                                   //println("debut_onglet =", debut_onglet[_ligne], "texte =", _texte, "longueur_texte =", longueur_texte);
                                                                                   //println("CHOIX MODELE =", onglet_choisi);
        if (!_texte.equals(onglet_choisi)) {
            strokeWeight(1);
            stroke(NOIR);
            fill(AQUA);
            rect((E+debut_onglet[_ligne]), (30F+_ligne*H), (longueur_texte+2F*blanc[_ligne]), H, 7, 7, 0, 0);
            textFont(Courier14);
            textAlign(CENTER, CENTER);
            fill(NOIR);
            text(_texte, (E+debut_onglet[_ligne]), (30F-2F+_ligne*H), (longueur_texte+2F*blanc[_ligne]), H);
        }
        zone          = new Zone();
        zone.nom_zone = _texte;
        zone.x        = E+debut_onglet[_ligne];
        zone.l        = longueur_texte+2F*blanc[_ligne];
        zone.y        = 30F+_ligne*H;
        zone.h        = H;
        zone.ligne    = _ligne;
        if (debut_onglet[_ligne] == 0) {
            zone.debut[_ligne] = _texte;
                                                                                   //println("début =", zone.debut[_ligne], "ligne =", _ligne);            
            memo_depart        = _texte;
            if (gestion.one_shot) {
                debut_ligne.append(_texte);
            }
        } else {
            zone.debut[_ligne] = memo_depart;
        }
        toutes_zones.add(zone);
        debut_onglet[_ligne] = debut_onglet[_ligne]+longueur_texte+2*blanc[_ligne];
    }
    //---------------------------------- grand_onglet() ---------------------------------------
    void grand_onglet(String _texte) {
        for (Zone zon0 : toutes_zones) {
            if (zon0.nom_zone.equals(_texte)) {
                imageMode(CORNER);
                image(fond_alu, E, 30F+ligne*zon0.h, width-2F*E, height-30F-ligne*zon0.h-E);
                noFill();
                strokeWeight(3);
                stroke(NOIR);
                rect(E+2F, 30F+1F+(ligne+1)*zon0.h, width-2F*E-4F, height-30F-(ligne+1)*zon0.h-E-2F);
                stroke(FOND);
                strokeWeight(2);
                quad(E+2F, 30F+1F+(ligne+1)*zon0.h, width-2F*E, 30F+1F+(ligne+1)*zon0.h, width-2F*E-2F, 30F+2F+(ligne+1)*zon0.h, E+4F, 30F+2F+(ligne+1)*zon0.h);
                quad(E+2F, 30F+1F+(ligne+1)*zon0.h, E+2F, height-E-2F, E+3F, height-E-4F, E+3F, 30F+4F+(ligne+1)*zon0.h);
                affiche_onglets();
                noFill();
                stroke(NOIR);
                strokeWeight(1);
                rect(zon0.x, zon0.y, zon0.l, zon0.h, 7, 7, 0, 0);
                strokeWeight(2);
                textFont(Courier14);
                fill(BLANC);
                text(_texte, zon0.x, zon0.y-2F, zon0.l, zon0.h);
                break;
            }
        }
    }
    //----------------------------- Valeur_defaut1() -----------------------------
    void valeurs_defaut1() {
        CV1_             = 3;
        CV2_             = 3;
        CV3_             = 3;
        CV4_             = 5;
        CV5_             = 90;
        CV6_             = 40;
        CV17_            = 192;
        CV18_            = 0;
        CV28_            = 3;
        CV29_            = 6;
        CV66_            = 248;
        CV95_            = 248;            
    }
}
//***************************************************************************************************
//************************************* Decodeurs particuliers **************************************
//***************************************************************************************************
//***************************************************************************************************
class Modele_generique extends Decodeur {
    Modele_generique(String _reference, int _NMRA, 
                        int _courant_moteur_max, int _courant_pic_moteur, int _duree_pic_moteur, int _courant_total_max, int _courant_pic_total, String _connecteur, 
                        int _longueur, int _largeur, int _hauteur) {
        super(new Onglet[] { new Fiche(), new Configuration(), new Onglet_adresse(), new Moteur(), new ControleBasiqueVitesse(), new TableauVitesse(),
                             new CarteFonctions(), new TableauCV(), new Proprietaires(), new Lumieres(), new ControleAnalogique(), new Convoi(),
                             new Avance(), new Sons(), new VolumeSons(), new AccelDecel(), new ShuntUncouple(),
                             new AltFunctionMap(), new FunctionOutput(), new ZimoSpecific(), new Railcom(), new ABC(),
                             new SpeedRegulation(), new Servos() });
        decoupe_modele(_reference);
        //------ dimensions en 1/10ème de mm (à compléter) ------
        NMRA               = _NMRA;
        courant_moteur_max = _courant_moteur_max;
        courant_pic_moteur = _courant_pic_moteur;
        duree_pic_moteur   = _duree_pic_moteur;
        courant_total_max  = _courant_total_max;
        courant_pic_total  = _courant_pic_total;
        connecteur         = _connecteur;
        longueur           = _longueur;
        largeur            = _largeur;
        hauteur            = _hauteur;
        numero_version     = 0;
        valeurs_defaut1();
    }
}
