//*************************************** Groupe{} ********************************************
class Groupe {
    Bouton[] Boutons;
    
    Groupe(Bouton[] b0) {
       Boutons = b0;
    }  //  constructeur

    float   x0               = 0F;
    float   x                = 0F;
    float   y                = 0F;
    float   l                = 0F;
    float   h                = 0F;
    float   l0               = 0F;
    float   h0               = 0F;
    int     numero_groupe    = 0;

    //---------------------------------- choix_bouton_actions_vehicule() -------------------------------------
    void choix_bouton_actions_vehicule() {
        groupe = groupes[53];
        groupe.dessine_gros_boutons(110F, 440F, 240F, 40F);
        groupe.appui_gros_boutons();
    }
    //---------------------------------- choix_bouton_actions_filtres() -------------------------------------
    void choix_bouton_actions_filtres() {
        groupe = groupes[54];
        groupe.dessine_gros_boutons(110F, 380F, 560F, 40F);
        groupe.appui_gros_boutons();
    }
    //---------------------------------- choix_bouton_actions_decodeur() -------------------------------------
    void choix_bouton_actions_decodeur() {
        groupe = groupes[55];
        groupe.dessine_gros_boutons(850F, 440F, 400F, 40F);
        groupe.appui_gros_boutons();
    }
    //--------------------------------- choix_bouton_copie() --------------------------
    void choix_bouton_copie() {
        groupe = groupes[1];
        groupe.dessine_gros_boutons(60F+(gestion.l0+120F)/4F+60F+(gestion.l0+120F)/4F+60F,
                                    630F+100F/2F-40F/2F,
                                    width-2F*((gestion.l0+120F)/4F)-2F*60F-2F*60F,
                                    40F);
        groupe.appui_gros_boutons();
    }
    //---------------------------- dessine_gros_bouton() -------------------
    void dessine_gros_boutons(float _x0, float _y0, float _l0, float _h0) {
        noStroke();
        float taille_texte[] = new float[50];
        float taille_ecart   = 0F;                                                                                            //  au début, taille_ecart sert pour calculer la taille totale du texte
        int nb_zones = Boutons.length;
        textFont(Courier12);        
        for (int i = 0; i < nb_zones; i++) {
            bouton = Boutons[i];
            taille_texte[i] = textWidth(bouton.texte_affiche)*1.2F;
        }
        taille_ecart = 0F;
        for (int i = 0; i < nb_zones; i++) {
            taille_ecart = taille_ecart+taille_texte[i];
        }
        float pos = _x0;
        taille_ecart = (_l0-taille_ecart)/(nb_zones-1);
        pos = _x0;
        for (int i = 0; i < nb_zones; i++) {
            bouton = Boutons[i];
            bouton.dessine_bouton(pos, _y0, taille_texte[i], _h0);
            pos = pos+taille_texte[i]+taille_ecart;
        }
    }
    //---------------------------- dessine_deux_bouton() -------------------
    void dessine_deux_boutons(float _x0, float _y0, float _l0, float _h0) {
        float taille_texte[] = new float[2];
        float taille_ecart   = 0F;                                                                                            //  au début, taille_ecart sert pour calculer la taille totale du texte
        int nb_zones = Boutons.length;
        textFont(Courier12);        
        for (int i = 0; i < nb_zones; i++) {
            bouton = Boutons[i];
            taille_texte[i] = textWidth(bouton.texte_affiche)*1.2F;
        }
        taille_ecart = 0F;
        for (int i = 0; i < nb_zones; i++) {
            taille_ecart = taille_ecart+taille_texte[i];
        }
        float pos = _x0;
        taille_ecart = (_l0-taille_ecart)/3F;                                                                                 //  3f car il n'y a que 2 boutons
        pos = _x0+taille_ecart;
        for (int i = 0; i < nb_zones; i++) {
            bouton = Boutons[i];
            bouton.dessine_bouton(pos, _y0, taille_texte[i], _h0);
            pos = pos+taille_texte[i]+taille_ecart;
        }
    }
    //------------------------------ confirmation() -----------------------
    void confirmation() {
        groupe_confirmation = groupes[groupe_bouton];                                                                         //  groupe_bouton, c'est le groupe dans lequel est le bouton de départ
        String texte = groupe_confirmation.Boutons[ordre_bouton].texte_confirmation;                                          //  ordre_bouton, c'est l'ordre du bouton de départ dans le groupe de boutrons du départ
        textFont(Courier12);
        float taille_texte = textWidth(texte);
        gestion.dessine_rectangle_bosse(width/2F-taille_texte/2F-20F, height/2F-56F, taille_texte+40F, 112F);
        dessine_deux_boutons(width/2F-taille_texte/2F, height/2F+10F, taille_texte, 40F);
        appui_gros_boutons();
        fill(BLANC);
        text(texte, width/2F, height/2F-22F);
    }
    //---------------------------- choix_vehicule_compo() ----------------------
    void choix_vehicule_compo(float _x0, float _y0, float _l0) {
        bouton = Boutons[0];
        bouton.dessine_bouton(_x0, _y0, 20, 20);
        bouton = Boutons[1];
        bouton.dessine_bouton(_x0+_l0, _y0, 20, 20);
        appui_gros_boutons();
    }
    //---------------------------- appui_gros_bouton() -------------------
    void appui_gros_boutons() {
        int nb_zones = Boutons.length;
        for (int i = 0; i < nb_zones; i++) {
            bouton = Boutons[i];
            bouton.appui_bouton();
        }
    }
    //--------------------------- écrire les CV -------------------------------
    void ecrire_les_CV() {
        if (valide_ecrire_CV) {
            if (liste_CV.size() != 0) {
                imageMode(CORNER);                
                gestion.dessine_rectangle_bosse((width-500)/2F, (height-300F)/2F, 500F, 300F);
                if (premier_passage) {
                    ecrire_CV(liste_CV.get(0));
                    premier_passage = false;
                }
                textFont(Courier17);
                textAlign(CENTER, CENTER);
                text(texte_ecrire, width/2F, height/2F);
                fin_comptage = millis();
                if (fin_comptage-debut_comptage > 2000) {
                    liste_CV.remove(0);
                    premier_passage = true;
                }
            } else {
                maj_decodeur         = false;
                ajouter_decodeur     = false;
                choix_du_vehicule    = true;
                gestion.one_shot     = false;
                saisie_valide        = false;
                appui_validation     = false;
                affiche_proprietaire = false;
                valide_ecrire_CV        = false;
            }
        }
    }
    //********************************************************************************************************
    //********************************************************************************************************
    //--------------------------------- choix_onglet_fiche() --------------------------
    void choix_onglet_fiche() {
        if (vehicule.ID_CV != 0) {
            x0 = 60F; x = 345F; l = 40F; h = 20F; l0 = 400F; h0 = 30F;                                //  base 0 1 2
            for (int i = 0; i < 3; i++) {
                bouton = groupe.Boutons[i];
                y = 120F+42F*i;
                bouton.dessine_bouton_bleu();
                bouton.appui_bouton();
            }
            x0 = 480F; x = 765F; l = 40F; h = 20F; l0 = 400F; h0 = 30F;                                //  base 3 4 5
            for (int i = 0; i < 3; i++) {
                bouton = groupe.Boutons[i+3];
                y = 120F+42F*i;
                bouton.dessine_bouton_bleu();
                if (!affiche_proprietaire) {
                    bouton.appui_bouton();
                }
            }
            x0 = 900F; x = 1185F; l = 40F; h = 20F; l0 = 400F; h0 = 30F;                                //  base 6 7 8
            for (int i = 0; i < 3; i++) {
                bouton = groupe.Boutons[i+6];
                y = 120F+42F*i;
                bouton.dessine_bouton_bleu();
                bouton.appui_bouton();
            }
        }
        x0 = 60F; x = 320F; l = 130F; h = 20F; l0 = 400F; h0 = 30F;                                    //  vehicule 9 10 11 12
        for (int i = 4; i < 8; i++) {
            bouton = groupe.Boutons[i+5];
            y = 120F+42F*i;
            bouton.dessine_bouton_bleu();
            bouton.appui_bouton();
        }
        x0 = 480F; x = 765F; l = 130F; h = 20F; l0 = 400F; h0 = 30F;                                    //  vehicule 13 14 15 16
        for (int i = 4; i < 8; i++) {
            bouton = groupe.Boutons[i+9];
            y = 120F+42F*i;
            bouton.dessine_bouton_bleu();
            if (!affiche_proprietaire) {
                bouton.appui_bouton();
            }
        }
        if (vehicule.ID_CV != 0) {
            x0 = 900F; x = 1185F; l = 40F; h = 20F; l0 = 400F; h0 = 30F;                                //  vehicule 17 18 19
            for (int i = 4; i < 7; i++) {
                bouton = groupe.Boutons[i+13];
                y = 120F+42F*i;
                bouton.dessine_bouton_bleu();
                bouton.appui_bouton();
            }
        }
        x0 = 60F; x = 460F; l = 80F; h = 20F; l0 = 620F; h0 = 30F;                                      //  proprietaire 20 21
        for (int i = 9; i < 11; i++) {
            bouton = groupe.Boutons[i+11];
            y = 120F+42F*i;
            bouton.dessine_bouton_bleu();
            bouton.appui_bouton();
        }
        if (vehicule.ID_CV != 0) {                                                                     //  CV 8, 7    22 23
            x0 = 710F; x = 1090F; l = 80F; h = 20F; l0 = 590F; h0 = 30F;
            for (int i = 9; i < 11; i++) {
                bouton = groupe.Boutons[i+13];
                y = 120F+42F*i;
                bouton.dessine_bouton_bleu();
                if (!affiche_proprietaire) {
                    bouton.appui_bouton();
                }
            }
        }
        for (int i = 0; i < 4; i++) {                  
            bouton = groupe.Boutons[i+24];                                                          //  boutons gestion fichier proprietaires 24 25 26 27
            bouton.dessine_bouton(60F+i*120F, 120F+42F*11, 110F, 40F);
            bouton.appui_bouton();
        }
        bouton = groupe.Boutons[28];                                                                 //  boutons gestion fichier proprietaires 28
        bouton.dessine_bouton(540F, 120F+42F*11, 140F, 40F);
        bouton.appui_bouton();
        if (vehicule.ID_CV != 0) {                                                                    //  reset et master reset 29 30
            bouton = groupe.Boutons[29];
            bouton.dessine_bouton(890F, 690F, 280F, 40F);
            bouton.appui_bouton();
            bouton = groupe.Boutons[30];
            bouton.dessine_bouton(1185F, 690F, 150F, 40F);
            bouton.appui_bouton();
        }
        if (vehicule.moteur) {
            vehicule.couleur = unhex("FF808080");
            //-------------- insertion du véhicule ----------
            gestion.dessine_rectangle_creux(vehicule.couleur, 20F, 640F, 300F, 90F);
            imageMode(CENTER);
            image(vehicule.image_cote, 20F+300F/2F, 630F+100F/2F, vehicule.image_cote.width/4F, vehicule.image_cote.height/4F);
            imageMode(CORNER);
        }
        //********************************************************************************************************************************************
        //---------------------------- affectation du numéro de propriétaire ----------------------------
        if (groupe.Boutons[20].valide) {
            affiche_proprietaire = true;
            //--------------------- afficher_liste ------------------------
            bouton = groupe.Boutons[20];
            if (vehicule.ID == 0) {
                texte_information   = "On ne peut pas changer le propriétaire du véhicule n°0";
                texte_details       = "Validez pour quitter";
            } else {
                if (bouton.texte_choisi != null) {
                    for (Proprietaire prop0 : tous_proprietaires) {
                        if (("["+prop0.CV106+"] "+prop0.prop).equals(bouton.texte_choisi)) {
                            vehicule.CV106                  = prop0.CV106;
                            saut = false;
                            groupe.Boutons[21].valide       = true;
                            break;
                        }
                    }
                } else {
                    bouton.choisir_proprietaire();
                }
            }
            //--------------- on saute si on ne sort pas ------------
            if (!saut) {
                bouton.texte_choisi       = null;     //  on sort du traitement
                texte_information         = null;     //  annulle la question
                saisie_valide             = false;    //  annulle la question
                bouton.texte_choix[0]     = null;     //  on n'affiche plus le choix dans la liste
                texte_avertissement       = null;
                saut                      = true;
            }
        }
        //---------------------------- affectation du nom de propriétaire ----------------------------
        if (groupe.Boutons[21].valide) {
            affiche_proprietaire = true;
            //--------------------- afficher_liste ------------------------
            bouton = groupe.Boutons[21];
            if (vehicule.ID == 0) {
                texte_information   = "On ne peut pas changer le propriétaire du véhicule n°0";
                texte_details       = "Validez pour quitter";
            } else {
                if (bouton.texte_choisi != null) {
                    for (Proprietaire prop0 : tous_proprietaires) {
                        if (("["+prop0.CV106+"] "+prop0.prop).equals(bouton.texte_choisi)) {
                            vehicule.CV106                  = prop0.CV106;
                            saut = false;
                            groupe.Boutons[20].valide       = true;
                            break;
                        }
                    }
                } else {
                    bouton.choisir_proprietaire();
                }
            }
            //--------------- on saute si on ne sort pas ------------
            if (!saut) {
                bouton.texte_choisi       = null;     //  on sort du traitement
                texte_information         = null;     //  annulle la question
                saisie_valide             = false;    //  annulle la question
                bouton.texte_choix[0]     = null;     //  on n'affiche plus le choix dans la liste
                texte_avertissement       = null;
                saut                      = true;
            }
        }
        //---------------------------- ajouter propriétaire ----------------------------
        if (groupe.Boutons[24].valide) {
            if (tous_proprietaires.size() >= 43) {
                texte_information = "le maximum de 43 propriétaires est atteint";
                texte_details     = "Validez pour quitter";
                if (saisie_valide) {
                    saut          = false;
                }
            } else {
                affiche_proprietaire = true;
                bouton = groupe.Boutons[24];
                //--------------------- recherche du nouveau numéro ------------------------
                trouve = false;
                for (Proprietaire prop0 : tous_proprietaires) {
                    if (prop0.prop.equals("Nouveau")) {
                        trouve = true;
                        break;
                    }
                }
                if (!trouve) {
                    int nouveau_numero = -1;
                    for (Proprietaire prop0 : tous_proprietaires) {
                        nouveau_numero = max(nouveau_numero, prop0.CV106);
                    }
                    Proprietaire proprietaire1 = new Proprietaire();
                    proprietaire1.prop  = "Nouveau";
                    proprietaire1.CV106 = nouveau_numero+1;
                    tous_proprietaires.add(proprietaire1);
                    sauve_table_Proprietaires();
                    texte_information = "Nouveau proprietaire ajouté";
                    texte_details     = "Validez pour quitter";
                } else {
                    texte_information = "Commencez par modifier le nom du nouveau propriétaire"
                              +char(10)+"avant d'en créer un autre";
                    texte_details     = "Validez pour quitter";
                }
                if (saisie_valide) {
                    saut = false;                
                }
            }
            //--------------- on saute si on ne sort pas ------------
            if (!saut) {
                bouton.texte_choisi       = null;     //  on sort du traitement
                groupe.Boutons[25].valide = false;
                texte_information         = null;     //  annulle la question
                saisie_valide             = false;    //  annulle la question
                bouton.texte_choix[0]     = null;     //  on n'affiche plus le choix dans la liste
                texte_avertissement       = null;
                saut                      = true;
            }
        }
        //---------------------------- retirer propriétaire ----------------------------
        if (groupe.Boutons[25].valide) {
            affiche_proprietaire = true;
            //--------------------- afficher_liste ------------------------
            bouton = groupe.Boutons[25];
            bouton.choisir_proprietaire();
            if (bouton.texte_choisi != null) {
                int compte_prop = -1;
                if (bouton.texte_choisi.equals("[0] n.c.")) {
                    question = 1;
                } else {
                    for (Proprietaire prop0 : tous_proprietaires) {
                        compte_prop++;
                        if (("["+prop0.CV106+"] "+prop0.prop).equals(bouton.texte_choisi)) {
                            break;
                        }
                    }
                }
                switch (question) {
                    case 0 :
                        texte_avertissement = "Vous allez retirer un proprietaire"
                                    +char(10)+"dans le fichier des proprietaires"
                                    +char(10)+"Cela supprimera aussi ce proprietaire"
                                    +char(10)+"dans les véhicules correspondants";
                        texte_information   = "Le propriétaire à supprimer est : "
                                    +char(10)+"["+tous_proprietaires.get(compte_prop).CV106+"] "+tous_proprietaires.get(compte_prop).prop;
                        texte_details       = "Supprimer (o/n) ? :";
                        reponse             = 0;
                        break;
                    case 1 :
                        texte_information   = "On ne peut pas retirer [0] n.c.";
                        texte_details       = "Validez pour quitter";
                        reponse             = 1;
                        break;
                }
                if (saisie_valide) {
                    switch (reponse) {
                        case 0:
                            if (!bouton.texte_saisi_b.equals("")) {
                                if (bouton.texte_saisi_b.equals("o") || bouton.texte_saisi_b.equals("O") || bouton.texte_saisi_b.equals("oui")|| bouton.texte_saisi_b.equals("OUI")) {
                                    //---------------- efface le numéro proprietaire dans les véhicules --------------
                                    for (Vehicule veh0 : tous_vehicules_complet) {
                                        if (veh0.CV106 == tous_proprietaires.get(compte_prop).CV106) {
                                            veh0.CV106 = 0;
                                        }
                                    }
                                    //---------------- efface le propriétaire dans les propriétaires ----------
                                    tous_proprietaires.remove(compte_prop);
                                    sauve_table_Proprietaires();                        
                                    saut = false;
                                }
                            } else {
                                //------------------- réponse vide ------------
                                saut = false;                            
                            }
                            break;
                        case 1:
                            //------------------- cas du propriétaire "0" --------
                            saut = false;
                            break;
                    }
                }
                //--------------- on saute si on ne sort pas ------------
                if (!saut) {
                    bouton.texte_choisi       = null;     //  on sort du traitement
                    groupe.Boutons[25].valide = false;
                    texte_information         = null;     //  annulle la question
                    saisie_valide             = false;    //  annulle la question
                    bouton.texte_choix[0]     = null;     //  on n'affiche plus le choix dans la liste
                    texte_avertissement       = null;
                    saut                      = true;
                }
            }
        }
        //---------------------------- modifier nom propriétaire ----------------------------
        if (groupe.Boutons[26].valide) {
            affiche_proprietaire = true;
            //--------------------- afficher_liste ------------------------
            bouton = groupe.Boutons[26];
            bouton.choisir_proprietaire();
            if (bouton.texte_choisi != null) {
                int compte_prop = -1;
                if (bouton.texte_choisi.equals("[0] n.c.")) {
                    question = 2;
                } else {
                    for (Proprietaire prop0 : tous_proprietaires) {
                        compte_prop++;
                        if (("["+prop0.CV106+"] "+prop0.prop).equals(bouton.texte_choisi)) {
                            break;
                        }
                    }
                    if (trouve) {
                        question = 1;
                    } else {
                        question = 0;
                    }
                }
                switch (question) {
                    case 0 :
                        texte_avertissement = "Vous allez modifier le nom d'un proprietaire"
                                    +char(10)+"dans le fichier des proprietaires"
                                    +char(10)+"Cela ne modifiera pas le numéro qui lui est associé";
                        texte_information   = "L'ancien nom du propriétaire à modifier est : "
                                    +char(10)+"["+tous_proprietaires.get(compte_prop).CV106+"] "+tous_proprietaires.get(compte_prop).prop;
                        texte_details       = "Nouveau nom ? :";
                        reponse             = 0;
                        break;
                    case 1 :
                        texte_avertissement = "Ce nom existe déjà"
                                    +char(10)+"On ne peut pas avoir deux fois le même nom";
                        texte_information   = "L'ancien nom du propriétaire à modifier est : "
                                    +char(10)+"["+tous_proprietaires.get(compte_prop).CV106+"] "+tous_proprietaires.get(compte_prop).prop;
                        texte_details       = "Nouveau nom ? :";
                        reponse             = 0;
                        break;                        
                    case 2 :
                        texte_information   = "On ne peut pas modifier [0] n.c.";
                        texte_details       = "Validez pour quitter";
                        reponse             = 1;
                        break;
                }
                if (saisie_valide) {
                    switch (reponse) {
                        case 0:
                            if (!bouton.texte_saisi_b.equals("")) {
                                bouton.texte_saisi_b = bouton.texte_saisi_b.substring(0, 1).toUpperCase()+bouton.texte_saisi_b.substring(1).toLowerCase();
                                //----------- on cherche si cette réponse existe déjà ---------
                                trouve = false;
                                int compte_prop1 = -1;
                                for (Proprietaire prop0 : tous_proprietaires) {
                                    compte_prop1++;
                                    if (prop0.prop.equals(bouton.texte_saisi_b) && (compte_prop != compte_prop1)) {
                                        trouve = true;
                                        break;
                                    }
                                }
                                if (!trouve) {
                                    //---------------- la réponse n'existe pas dans la liste ----------
                                    //---------------- on modifie le nom dans les propriétaires ----------
                                    Proprietaire prop0 = tous_proprietaires.get(compte_prop);
                                    prop0.prop = bouton.texte_saisi_b;
                                    tous_proprietaires.set(compte_prop, prop0);
                                    sauve_table_Proprietaires();  //  nota : on ne fait rien dans la table "Vehicules.tsv" car le nom du propriétaire n'y est pas
                                    bouton.texte_saisi_b = "";
                                    saut                 = false;
                                } else {
                                    //---------------- le nom existe déjà -------
                                    question      = 1;
                                    saisie_valide = false;                                    
                                }
                            } else {
                                //------------------- réponse vide ------------
                                saut = false;                            
                            }
                            break;
                        case 1:
                            //------------------- cas du propriétaire "0" --------
                            saut = false;
                            break;
                    }
                }
                //--------------- on saute si on ne sort pas ------------
                if (!saut) {
                    bouton.texte_choisi       = null;     //  on sort du traitement
                    groupe.Boutons[26].valide = false;    //  dévalide le bouton qui redevient bleu
                    texte_information         = null;     //  annulle la question
                    saisie_valide             = false;    //  annulle la question
                    bouton.texte_choix[0]     = null;     //  on n'affiche plus le choix dans la liste
                    texte_avertissement       = null;
                    saut                      = true;
                }
            }
        }
        //---------------------------- modifier numéro propriétaire ----------------------------
        if (groupe.Boutons[27].valide) {
            affiche_proprietaire = true;
            //--------------------- afficher_liste ------------------------
            bouton = groupe.Boutons[27];
            bouton.choisir_proprietaire();
            if (bouton.texte_choisi != null) {
                int compte_prop = -1;
                if (bouton.texte_choisi.equals("[0] n.c.")) {
                    question = 3;
                } else {
                    for (Proprietaire prop0 : tous_proprietaires) {
                        compte_prop++;
                        if (("["+prop0.CV106+"] "+prop0.prop).equals(bouton.texte_choisi)) {
                            break;
                        }
                    }
                    if (trouve) {
                        question = 1;
                    } else {
                        if (int(bouton.texte_saisi_b) < 0 || (!bouton.texte_saisi_b.equals("") && int(bouton.texte_saisi_b) == 0)) {
                            question = 2;
                        } else {
                            question = 0;
                        }
                    }
                }
                switch (question) {
                    case 0 :
                        texte_avertissement = "Vous allez modifier le numéro d'un propriétaire"
                                    +char(10)+"dans le fichier des propriétaires"
                                    +char(10)+"et aussi dans le fichier du matériel"
                                    +char(10)+"Cela ne modifiera pas le nom qui lui est associé";
                        texte_information   = "L'ancien numéro du propriétaire à modifier est : "
                                    +char(10)+"["+tous_proprietaires.get(compte_prop).CV106+"] "+tous_proprietaires.get(compte_prop).prop;
                        texte_details       = "Nouveau numéro ? :";
                        reponse             = 0;
                        break;
                    case 1 :
                        texte_avertissement = "Ce numéro existe déjà"
                                    +char(10)+"On ne peut pas avoir deux fois le même numéro";
                        texte_information   = "L'ancien numéro du propriétaire à modifier est : "
                                    +char(10)+"["+tous_proprietaires.get(compte_prop).CV106+"] "+tous_proprietaires.get(compte_prop).prop;
                        texte_details       = "Nouveau numéro ? :";
                        reponse             = 0;
                        break;                        
                    case 2 :
                        texte_avertissement = "Entrez un numéro positif !";
                        texte_information   = "L'ancien numéro du propriétaire à modifier est : "
                                    +char(10)+"["+tous_proprietaires.get(compte_prop).CV106+"] "+tous_proprietaires.get(compte_prop).prop;
                        texte_details       = "Nouveau numéro ? :";
                        reponse             = 0;
                        break;
                    case 3 :
                        texte_information   = "On ne peut pas modifier [0] n.c.";
                        texte_details       = "Validez pour quitter";
                        reponse             = 1;
                        break;
                }
                if (saisie_valide) {
                    switch (reponse) {
                        case 0:
                            if (!bouton.texte_saisi_b.equals("")) {
                                //----------- on cherche si cette réponse existe déjà ---------
                                trouve = false;
                                int compte_prop1 = -1;
                                for (Proprietaire prop0 : tous_proprietaires) {
                                    compte_prop1++;
                                    if (prop0.CV106 == int(bouton.texte_saisi_b) && (compte_prop != compte_prop1) && compte_prop1 != 0) {
                                        trouve = true;
                                        break;
                                    }
                                }
                                if (!trouve) {
                                    //---------------- la réponse n'existe pas dans la liste ----------
                                    //---------------- teste si >=0 ----------
                                    if (int(bouton.texte_saisi_b) <= 0) {
                                        saisie_valide = false;
                                    } else {
                                        //------------- la réponse est bien > 0 -------------------
                                        int longueur_texte_choisi = bouton.texte_choisi.length();
                                        int rang_car = -1;
                                        for (int i = 1; i < longueur_texte_choisi; i++) {
                                            rang_car++;
                                            String car = bouton.texte_choisi.substring(i, i+1);
                                            if (car.equals("]")) {
                                                break;
                                            }
                                        }
                                        CV106 = int(bouton.texte_choisi.substring(1, rang_car+1));   //  CV106 est le nombre à modifier
                                        for (Vehicule veh0 : tous_vehicules) {  //  nota : on modifie dans la table "Vehicules.tsv" car le numéro du propriétaire y est
                                            if (veh0.CV106 == CV106) {
                                                veh0.CV106 = int(bouton.texte_saisi_b);
                                            }
                                        }
                                        sauve_table_Vehicules();
                                        Proprietaire prop0 = tous_proprietaires.get(compte_prop);
                                        prop0.CV106 = int(bouton.texte_saisi_b);
                                        tous_proprietaires.set(compte_prop,prop0);
                                        sauve_table_Proprietaires();                        
                                        bouton.texte_saisi_b = "";
                                        saut = false;                            
                                    }
                                } else {
                                    //---------------- le numero existe déjà -------
                                    question      = 1;
                                    saisie_valide = false;
                                }
                            } else {
                                //------------------- réponse vide ------------
                                saut = false;                            
                            }
                            break;
                        case 1:
                            //------------------- cas du propriétaire "0" --------
                            saut = false;
                            break;
                    }
                }
                //--------------- on saute si on ne sort pas ------------
                if (!saut) {
                    bouton.texte_choisi       = null;     //  on sort du traitement
                    groupe.Boutons[27].valide = false;
                    texte_information         = null;     //  annulle la question
                    saisie_valide             = false;    //  annulle la question
                    bouton.texte_choix[0]     = null;     //  on n'affiche plus le choix dans la liste
                    texte_avertissement       = null;
                    saut                      = true;
                }
            }
        }
        //---------------------------- affiche/efface ----------------------------
        if (groupe.Boutons[28].valide) {
            if (groupe.Boutons[20].valide || groupe.Boutons[21].valide || groupe.Boutons[24].valide || groupe.Boutons[25].valide || groupe.Boutons[26].valide || groupe.Boutons[27].valide) {
                bouton.texte_choisi       = null;     //  on sort du traitement
                for (int i = 0; i < 9; i++) {
                    groupe.Boutons[20+i].valide = false;
                }
                texte_information         = null;     //  annulle la question
                saisie_valide             = false;    //  annulle la question
                bouton.texte_choix[0]     = null;     //  on n'affiche plus le choix dans la liste
                texte_avertissement       = null;            
            } else {
                affiche_proprietaire = true;
                //--------------------- afficher_liste ------------------------
                bouton = groupe.Boutons[28];
                bouton.choisir_proprietaire();
            }
        }
        //-------------------------- affichage question ------------------------------
        if (texte_information != null) {
            gestion.dessine_rectangle_bosse((width-500)/2F, (height-300F)/2F, 500F, 300F);
            textFont(Courier14);
            imageMode(CORNER);
            fill(BLANC);
            textAlign(CENTER, CENTER);            
            text(texte_information, width/2F, height/2F-30F);
            if (texte_avertissement != null) {
                fill(NOIR);
                image(danger, width/2F-200F, height/2F-115F, 30F, 30F);
                textAlign(LEFT, CENTER);
                text(texte_avertissement, width/2F-160F, height/2F-100F);
            }
            if (texte_details.equals("Validez pour quitter")) {
                fill(BLANC);
                textFont(Courier14);
                textAlign(CENTER, CENTER);            
                text(texte_details, width/2F, height/2F);
                //----------------- RaZ des validations ---------------------
                for (int i = 0; i < 30; i++) {
                    groupe.Boutons[i].valide = false;
                }
            } else {
                textAlign(RIGHT, CENTER);
                text(texte_details, width/2F-2, height/2F+20F);
                image(affiche_bleu, width/2F+2F, height/2F+8F, 200F, 30F);
                fill(NOIR);
                text(texte_saisi, width/2F+2F+200F-5F, height/2F+20F);
                textAlign(CENTER, CENTER);
                fill(BLANC);
                text("Laissez vide et VALIDEZ pour sortir sans rien faire", width/2F, height/2F+60F);
                if (NC) {
                    text("Entrez 'nc' puis VALIDEZ pour 'n.c.'", width/2F, height/2F+80F);
                }
            }
        }
        //--------------------- valeurs usine ---------------------------------------
        if (valeurs_usine && !appui_validation) {
            String texte = "RESET 'LIGHT'"
              +char(10)+char(10)+"'Validez les choix pour cet onglet' si OK"
                       +char(10)+"'Ne rien changer pour cet onglet'   sinon";
            gestion.dessine_rectangle_bosse((width-500)/2F, (height-300F)/2F, 500F, 300F);
            textFont(Courier14);
            textAlign(CENTER, CENTER);
            text(texte, width/2F, height/2F);
            onglet.compteur = 0;
        }
        //----------------------- master reset ------------------------------------
        if (master_reset && !appui_validation) {
            String texte = "MASTER RESET"
              +char(10)+char(10)+"'Validez les choix pour cet onglet' si OK"
                       +char(10)+"'Ne rien changer pour cet onglet'   sinon";
            gestion.dessine_rectangle_bosse((width-500)/2F, (height-300F)/2F, 500F, 300F);
            textFont(Courier14);
            textAlign(CENTER, CENTER);
            text(texte, width/2F, height/2F);
            onglet.compteur = 0;
        }
        //--------------------------- écrire les CV -------------------------------
        ecrire_les_CV();
    }
    //********************************************************************************************************
    //--------------------------------- choix_onglet_configuration() --------------------------
    void choix_onglet_configuration() {
        x0 = 60F; x = 440F; l = 380F; h = 20F; l0 = 900F; h0 = 30F;
        bouton  = groupe.Boutons[0];
        y = 130F;
        bouton.dessine_bouton_bleu();        
        String CV29ici = binary(infos_CV.CV[29], 8);
        for (int i = 1; i < 9; i++) {
            bouton = groupe.Boutons[i];
            if (infos_CV.CV[29] != -1) {
                if (bouton.texte_choisi == null) {
                    bouton.valeur_bouton = int(CV29ici.substring(8-i, 8-i+1));                                                //(8-n°bit, 8-n°bit+1) si on démarre à 1
                }
            } else {
                if (bouton.texte_choisi == null) {
                    bouton.valeur_bouton = 0;
                }
            }
            y = 160F+42F*i;
            bouton.dessine_bouton_bleu();
            groupe.Boutons[i].appui_bouton();
        }
        bouton = groupe.Boutons[9];
        y = 570F;
        groupe.Boutons[9].dessine_bouton_bleu();
        //--------------------------- écrire les CV -------------------------------
        ecrire_les_CV();
    }
    //********************************************************************************************************
    //--------------------------------- choix_onglet_adresse() --------------------------
    void choix_onglet_adresse() {
        x0 = 60F; x = 440F; l = 280F; h = 20F; l0 = 800F; h0 = 30F;
        //----------------------------- affichage ancienne adresse ------------------------
        int CV29_bit5 = int(binary(infos_CV.CV[29], 8).substring(7-5, 7-5+1));                                                //(7-n°bit, 7-n°bit+1) si on démarre à 0
        if (CV29_bit5 == 0) {
            gestion.dessine_rectangle_bosse(50F, 140F, 820F, 155F);
            bouton = groupe.Boutons[0];                                                                                       //  adresse actuelle
            y = 150F;
            bouton.dessine_bouton_bleu();
            bouton = groupe.Boutons[1];                                                                                       //  CV29 bit5
            bouton.valeur_bouton = 0;
            y = 200F;
            bouton.dessine_bouton_bleu();
            bouton = groupe.Boutons[2];                                                                                       //  CV1
            y = 250F;
            bouton.dessine_bouton_bleu();
        } else {
            gestion.dessine_rectangle_bosse(50F, 140F, 820F, 205F);
            bouton = groupe.Boutons[0];                                                                                       //  adresse actuelle
            y = 150F;
            bouton.dessine_bouton_bleu();
            bouton = groupe.Boutons[1];                                                                                       //  CV29 bit5
            bouton.valeur_bouton = 1;
            y = 200F;
            bouton.dessine_bouton_bleu();
            bouton = groupe.Boutons[3];                                                                                       //  CV17
            y = 250F;
            bouton.dessine_bouton_bleu();
            bouton = groupe.Boutons[4];                                                                                       //  CV18
            y = 300F;
            bouton.dessine_bouton_bleu();
        }
        //--------------------------- demande de nouvelle adresse -------------------------
        bouton.modif_CV29 = false;
        bouton = groupe.Boutons[5];                                                                                           //  adresse demandée
        y = 400F;
        bouton.dessine_bouton_bleu();
        if (saisie_valide) {
            if (bouton.adresse_saisie != 0) {
                if (bouton.adresse_saisie > 0 && bouton.adresse_saisie < 100) {
                    //----------------adresse courte ----------------------
                    gestion.dessine_rectangle_bosse(50F, 390F, 820F, 155F);
                    bouton = groupe.Boutons[5];                                                                                   //  adresse demandée
                    y = 400F;
                    bouton.dessine_bouton_bleu();
                    bouton = groupe.Boutons[1];                                                                                   //  CV29 bit5
                    y = 450F;
                    bouton.valeur_bouton = 0;
                    if (CV29_bit5 == 0) {
                        bouton.dessine_bouton_bleu_modifie(false);
                    } else {
                        bouton.dessine_bouton_bleu_modifie(true);
                        bouton.modif_CV29 = true;
                        infos_CV.CV[29]   = CV29-32;
                    }
                    bouton = groupe.Boutons[2];                                                                                   //  CV1
                    y = 500F;
                    bouton.adresse_saisie = groupe.Boutons[5].adresse_saisie;
                    bouton.dessine_bouton_bleu_modifie(false);
                    infos_CV.CV[1] = bouton.adresse_saisie;
                                                                                                  //println("1, 29", infos_CV.CV[1], infos_CV.CV[29]);
                } else {
                    if (bouton.adresse_saisie > 127 && bouton.adresse_saisie < 9984) {
                        //-------------------adresse étendue --------------------
                        gestion.dessine_rectangle_bosse(50F, 390F, 820F, 205F);
                        bouton = groupe.Boutons[5];                                                                               //  adresse demandée
                        y = 400F;
                        bouton.dessine_bouton_bleu();
                        bouton = groupe.Boutons[1];                                                                               //  CV29 bit5
                        y = 450F;
                        bouton.valeur_bouton = 1;
                        if (CV29_bit5 == 0) {
                            bouton.dessine_bouton_bleu_modifie(true);
                            bouton.modif_CV29 = true;
                            infos_CV.CV[29] = CV29+32;
                        } else {
                            bouton.dessine_bouton_bleu_modifie(false);
                        }
                        bouton = groupe.Boutons[4];                                                                               //  CV18
                        y = 550F;
                        bouton.CV18 = int(256*((float(groupe.Boutons[5].adresse_saisie)/256F)-int(groupe.Boutons[5].adresse_saisie/256)));
                        bouton.dessine_bouton_bleu_modifie(false);
                        infos_CV.CV[18] = bouton.CV18;
                        bouton = groupe.Boutons[3];                                                                               //  CV17
                        y = 500F;
                        bouton.CV17 = int((float(groupe.Boutons[5].adresse_saisie)-bouton.CV18)/256F+192F);
                        bouton.dessine_bouton_bleu_modifie(false);
                        infos_CV.CV[17] = bouton.CV17;
                                                                                                  //println("17, 18, 29", infos_CV.CV[17], infos_CV.CV[18], infos_CV.CV[29]);
                    } else {
                        if (bouton.adresse_saisie != -1) {
                            //------------------ erreur d'adresse -------------------
                            gestion.dessine_rectangle_bosse(890F, 360F, 460F, 110F);
                            fill(BLANC);
                            textAlign(LEFT, CENTER);
                            text("Seuls certains décodeurs gèrent une valeur entre 0 et 10239", 900, 370);
                            text("s'ils sont bien associés à la centrale de la même marque.", 900, 390);
                            text("Entrez une valeur de 1 à 99 ou de 128 à 9983", 900, 410);
                            text("pour assurer la plus grande compatibilité", 900, 430);
                            text("avec toutes les centrales.", 900, 450);
                        }
                    }
                }
            } else {
                //----------------- cas de l'adresse 0 ------------------------------
                gestion.dessine_rectangle_bosse(890F, 360F, 460F, 110F);
                fill(BLANC);
                textAlign(LEFT, CENTER);
                text("L'adresse à 0 signifie que vous quittez le mode DCC.", 900, 370);
                text("La nouvelle source doit être définie au CV12.", 900, 390);
                text("Entrez une valeur de 1 à 99 ou de 128 à 9983", 900, 410);
                text("pour assurer la plus grande compatibilité", 900, 430);
                text("avec toutes les centrales.", 900, 450);
            }
        }
        CV29 = infos_CV.CV[29];
        //--------------------------- écrire les CV -------------------------------
        ecrire_les_CV();
    }
    //********************************************************************************************************
    //--------------------------------- affiche_onglet_moteur() --------------------------
    void choix_onglet_moteur() {
        textFont(Courier14);
        gestion.dessine_rectangle_bosse(20F, onglet.curseur_up-65F, 355F, 510F);
        //---------------- curseurs ---------------
        stroke(NOIR);
        strokeWeight(3);
        for (int i = 0; i < 2; i++) {
            line(onglet.x_curseur+i*width/16F, onglet.curseur_up, onglet.x_curseur+i*width/16F, onglet.curseur_down);
        }
        for (int i = 0; i < 2; i++) {
            onglet.calcule_pointsV(i);
        }
        for (int i = 0; i < 2; i++) {
            onglet.dessine_curseurV(i);
        }
        onglet.dessine_digits(0);
        onglet.dessine_digits(1);
        stroke(BLANC);
        strokeWeight(3);
        line(onglet.x_curseur-30F, onglet.curseur_up-30F, onglet.x_curseur-30F, onglet.curseur_down);
        fill(BLANC);
        triangle(onglet.x_curseur-35F, onglet.curseur_up-20F, onglet.x_curseur-25F, onglet.curseur_up-20F, onglet.x_curseur-30F, onglet.curseur_up-30F);
        textFont(Courier14);
        textAlign(CENTER, CENTER);
        text("Taux : Accélération / Décélération", onglet.x_curseur+30F, onglet.curseur_up-55F);
        text(" 0 s", onglet.x_curseur-60F, onglet.curseur_down-5F);
        text("30 s", onglet.x_curseur-60F, onglet.curseur_down-onglet.course_curseur/2F-5F);
        text("60 s", onglet.x_curseur-60F, onglet.curseur_up-5F);
        textSize(12);
        text("CV 3",  onglet.x_curseur,             onglet.y_curseur-38F);
        text("CV 4",  onglet.x_curseur+width/16F,   onglet.y_curseur-38F);
        textAlign(LEFT, CENTER);
        text("Nombre de crans de vitesse =", 30F, 519F);
        text("Durée d'un cran de vitesse en accélération =", 30F, 538F);
        text("Durée totale de l'accélération =", 30F, 557F);
        text("Durée d'un cran de vitesse en décélération =", 30F, 576F);
        text("Durée totale de la décélération =", 30F, 595F);
        textFont(fontUnits);
        fill(AQUA);
        textAlign(RIGHT, CENTER);
        textSize(10F);
        int duree = 0;
        int CV29_bit1 = int(binary(infos_CV.CV[29], 8).substring(8-2, 8-2+1));
        if (CV29_bit1 == 0) {
            for (int i = 0; i < 2; i++) {
                duree = int(1000F*onglet.hauteur_curseur[i]*0.896F/28F+0.5);
                text(str(duree), 345F, 538F+38F*i);
                duree = int(onglet.hauteur_curseur[i]*0.896F+0.5);
                text(str(duree), 270F, 557F+38F*i);
            }
            textFont(Courier14);
            textAlign(LEFT, CENTER);
            text("28 crans", 220F, 519F);
        } else {
            for (int i = 0; i < 2; i++) {
                duree = int(1000*onglet.hauteur_curseur[i]*0.896F/128F+.5);
                text(str(duree), 345F, 538F+38F*i);
                duree = int(onglet.hauteur_curseur[i]*0.896F+.5);
                text(str(duree), 270F, 557F+38F*i);
            }
            textFont(Courier14);
            textAlign(LEFT, CENTER);
            text("128 crans", 220F, 519F);
        }
        text("ms", 350F, 538F);
        text("s",  275F, 557F);
        text("ms", 350F, 576F);
        text("s",  275F, 595F);
        
        //--------------------------- écrire les CV -------------------------------
        ecrire_les_CV();;
    }
    //********************************************************************************************************
    //--------------------------------- choix_onglet_controle_basique_vitesse() --------------------------
    void choix_onglet_controle_basique_vitesse() {
        textFont(Courier14);
        //---------------- curseurs ---------------
        stroke(NOIR);
        strokeWeight(3);
        for (int i = 0; i < 3; i++) {
            line(onglet.x_curseur+i*width/4F, onglet.curseur_up, onglet.x_curseur+i*width/4F, onglet.curseur_down);
        }
        for (int i = 0; i < 3; i++) {
            onglet.calcule_pointsV(i);
        }
        stroke(AQUA);
        strokeWeight(3);
        for (int i = 0; i < 2; i++) {
            line(onglet.x_curseur+i*width/4F,     (onglet.curseur_down-(onglet.course_curseur)*onglet.hauteur_curseur[i]/255F)*onglet.zoom_c,
                 onglet.x_curseur+(i+1)*width/4F, (onglet.curseur_down-(onglet.course_curseur)*onglet.hauteur_curseur[i+1]/255F)*onglet.zoom_c);
        }
        for (int i = 0; i < 3; i++) {
            onglet.dessine_digits(i);
        }
        for (int i = 0; i < 3; i++) {
            onglet.dessine_curseurV(i);
        }
        stroke(BLANC);
        strokeWeight(3);
        line(onglet.x_curseur, onglet.curseur_down+30F, onglet.x_curseur+50F+2F*width/4F, onglet.curseur_down+30F);
        line(onglet.x_curseur-30F, onglet.curseur_up-40F, onglet.x_curseur-30F, onglet.curseur_down);
        fill(BLANC);
        triangle(onglet.x_curseur-35F,               onglet.curseur_up-30F, 
                 onglet.x_curseur-25F,               onglet.curseur_up-30F, 
                 onglet.x_curseur-30F,               onglet.curseur_up-40F);
        triangle(onglet.x_curseur+40F+2F*width/4F,   onglet.curseur_down+25F, 
                 onglet.x_curseur+40F+2F*width/4F,   onglet.curseur_down+35F, 
                 onglet.x_curseur+50F+2F*width/4F,   onglet.curseur_down+30F);
        textFont(Courier14);
        textAlign(CENTER, CENTER);
        text("Tension moteur", onglet.x_curseur-30F, onglet.curseur_up-60F);
        text("Crans de vitesse", onglet.x_curseur+width/4F, onglet.curseur_down+60F);
        text("0",   onglet.x_curseur,                onglet.curseur_down+40F);
        text("64",  onglet.x_curseur+width/4F,       onglet.curseur_down+40F);
        text("128", onglet.x_curseur+2F*width/4F,    onglet.curseur_down+40F);
        text("0 %",   onglet.x_curseur-60F,          onglet.curseur_down);
        text("50 %",  onglet.x_curseur-60F,          onglet.curseur_down-onglet.course_curseur/2F);
        text("100 %", onglet.x_curseur-60F,          onglet.curseur_up);
        textSize(12);
        text("CV 2",  onglet.x_curseur,              onglet.y_curseur-40F);
        text("CV 6",  onglet.x_curseur+width/4F,     onglet.y_curseur-40F);
        text("CV 5",  onglet.x_curseur+2F*width/4F,  onglet.y_curseur-40F);
        x0 = 348F; x = 728F; l = 280F; h = 20F; l0 = 800F; h0 = 30F;
        bouton = groupe.Boutons[0];
        bouton.valeur_bouton = 0;
        y = 640F;
        bouton.dessine_bouton_bleu();        
        //--------------------------- écrire les CV -------------------------------
        ecrire_les_CV();;
    }
    //********************************************************************************************************
    //--------------------------------- affiche_onglet_table_vitesse() --------------------------
    void choix_onglet_table_vitesse() {
        textFont(Courier14);
        stroke(NOIR);
        strokeWeight(3);
        for (int i = 0; i < 28; i++) {
            line(onglet.x_curseur+i*width/38F, onglet.curseur_up, onglet.x_curseur+i*width/38F, onglet.curseur_down);
        }
        //-------------------------------------- logistique ------------------------------
        for (int i = 0; i < 28; i++) {
            onglet.calcule_pointsV(i);
        }
        stroke(AQUA);
        strokeWeight(3);
        for (int i = 0; i < 27; i++) {
            line(onglet.x_curseur+i*width/38F,     (onglet.curseur_down-(onglet.course_curseur)*onglet.hauteur_curseur[i]/255F)*onglet.zoom_c,
                 onglet.x_curseur+(i+1)*width/38F, (onglet.curseur_down-(onglet.course_curseur)*onglet.hauteur_curseur[i+1]/255F)*onglet.zoom_c);
        }
        for (int i = 0; i < 28; i++) {
            onglet.dessine_digits(i);
        }
        for (int i = 0; i < 28; i++) {
            onglet.dessine_curseurV(i);
        }
        stroke(BLANC);
        strokeWeight(3);
        line(onglet.x_curseur, onglet.curseur_down+20F, onglet.x_curseur+50F+27F*width/38F, onglet.curseur_down+20F);
        line(onglet.x_curseur-30F, onglet.curseur_up-40F, onglet.x_curseur-30F, onglet.curseur_down);
        fill(BLANC);
        triangle(onglet.x_curseur-35F,                 onglet.curseur_up-30F, 
                 onglet.x_curseur-25F,                 onglet.curseur_up-30F, 
                 onglet.x_curseur-30F,                 onglet.curseur_up-40F);
        triangle(onglet.x_curseur+40F+27F*width/38F,   onglet.curseur_down+15F, 
                 onglet.x_curseur+40F+27F*width/38F,   onglet.curseur_down+25F, 
                 onglet.x_curseur+50F+27F*width/38F,   onglet.curseur_down+20F);
        textFont(Courier14);
        textAlign(CENTER, CENTER);
        text("Tension moteur", onglet.x_curseur-30F,   onglet.curseur_up-60F);
        text("Crans de vitesse", onglet.x_curseur+13F*width/38F, onglet.curseur_down+50F);
        for (int i = 0; i < 28; i++) {
            text(str(i), onglet.x_curseur+i*width/38F, onglet.curseur_down+30F);
        }
        text("0 %",   onglet.x_curseur-60F,            onglet.curseur_down);
        text("50 %",  onglet.x_curseur-60F,            onglet.curseur_down-onglet.course_curseur/2F);
        text("100 %", onglet.x_curseur-60F,            onglet.curseur_up);
        textFont(Courier12);
        for (int i = 0; i < 28; i++) {
            text("CV"+str(67+i), onglet.x_curseur+i*width/38F, onglet.y_curseur-40F);
        }
        //-------------------------------- curseurs annexes ----------------------
        float courbe[] = new float[255];
        switch(onglet.parametre) {
            case 0:
                //------------------- vapeur ----------------
                gestion.dessine_rectangle_bosse(onglet.x_curseur+30*width/38F-23F, onglet.curseur_up-60F, 5*width/38F+12F, 600F);
                stroke(NOIR);
                strokeWeight(3);
                for (int i = 30; i < 35; i++) {
                    line(onglet.x_curseur+i*width/38F, onglet.curseur_up, onglet.x_curseur+i*width/38F, onglet.curseur_down);
                }
                fill(BLANC);
                textAlign(CENTER, CENTER);
                for (int i = 30; i < 35; i++) {
                    text("P"+str(i-30), onglet.x_curseur+i*width/38F, onglet.y_curseur-40F);
                }
                for (int i = 30; i < 35; i++) {
                    onglet.calcule_pointsV(i);
                }
                onglet.p[0]           = 0F    + onglet.hauteur_curseur[30];
                onglet.p[1]           = 0.01F + onglet.hauteur_curseur[31]*0.09F/255F;
                onglet.p[2]           = 80F   + onglet.hauteur_curseur[32]*80F/255F;
                onglet.p[3]           = 0.01F + onglet.hauteur_curseur[33]*0.09F/255F;
                onglet.p[4]           = 0F    + onglet.hauteur_curseur[34]-onglet.p[0];
                float c        = 2*onglet.p[1]*onglet.p[3]/abs(onglet.p[1]+onglet.p[3]);
                for (int i = 0; i < 255; i++) {        
                    float f    = 1/(1+exp(-c*(onglet.p[2]-i)));
                    float g    = exp(onglet.p[1]*(onglet.p[2]-i));
                    float h    = exp(onglet.p[3]*(onglet.p[2]-i));
                    float q    = onglet.p[0]+(onglet.p[4]/(1+f*g+(1-f)*h));
                    courbe[i]  = q;
                }
                for (int i = 0; i < 28; i++) {
                    onglet.hauteur_curseur[i] = courbe[int(i*255F/28F)];
                }
                for (int i = 30; i < 35; i++) {
                    onglet.dessine_digits(i);
                }
                for (int i = 30; i < 35; i++) {
                    onglet.dessine_curseurV(i);
                }
                textFont(Courier14);
                fill(BLANC);
                textAlign(LEFT, CENTER);
                text("P0 : vitesse_mini",      onglet.x_curseur+30*width/38F-13F, onglet.curseur_down+58F);
                text("P1 : convexité basse",   onglet.x_curseur+30*width/38F-13F, onglet.curseur_down+78F);
                text("P2 : point d'inflexion", onglet.x_curseur+30*width/38F-13F, onglet.curseur_down+98F);
                text("P3 : convexité haute",   onglet.x_curseur+30*width/38F-13F, onglet.curseur_down+118F);
                text("P4 : vitesse_maxi",      onglet.x_curseur+30*width/38F-13F, onglet.curseur_down+138F);
                break;
            case 1:
                //------------------- electrique/diesel ----------------
                gestion.dessine_rectangle_bosse(onglet.x_curseur+30*width/38F-23F, onglet.curseur_up-60F, 5*width/38F+12F, 600F);
                stroke(NOIR);
                strokeWeight(3);
                for (int i = 30; i < 35; i=i+2) {
                    line(onglet.x_curseur+i*width/38F, onglet.curseur_up, onglet.x_curseur+i*width/38F, onglet.curseur_down);
                }
                fill(BLANC);
                textAlign(CENTER, CENTER);
                for (int i = 30; i < 35; i++) {
                    text("P"+str(i-30), onglet.x_curseur+i*width/38F, onglet.y_curseur-40F);
                }
                for (int i = 30; i < 35; i++) {
                    onglet.calcule_pointsV(i);
                }
                onglet.p[0]           = 0F    + onglet.hauteur_curseur[30];
                onglet.p[2]           = 10F   + onglet.hauteur_curseur[32]*230F/255F;
                onglet.p[4]           = 0F    + onglet.hauteur_curseur[34]-onglet.p[0];
                for (int i = 0; i < 255; i++) {        
                    float q    = onglet.p[0]+onglet.p[4]*(1-exp(-i/(255F-onglet.p[2])));
                    courbe[i]  = q;
                }
                for (int i = 0; i < 28; i++) {
                    onglet.hauteur_curseur[i] = courbe[int(i*255F/28F)];
                }
                for (int i = 30; i < 35; i=i+2) {
                    onglet.dessine_digits(i);
                }
                for (int i = 30; i < 35; i=i+2) {
                    onglet.dessine_curseurV(i);
                }
                textFont(Courier14);
                fill(BLANC);
                textAlign(LEFT, CENTER);
                text("P0 : vitesse_mini",  onglet.x_curseur+30*width/38F-13F, onglet.curseur_down+58F);
                text("P2 : pente",         onglet.x_curseur+30*width/38F-13F, onglet.curseur_down+78F);
                text("P3 : vitesse_maxi",  onglet.x_curseur+30*width/38F-13F, onglet.curseur_down+98F);
                break;
            case 2:
                break;
        }
        x0 = 348F; x = 728F; l = 280F; h = 20F; l0 = 800F; h0 = 30F;
        bouton = groupe.Boutons[0];
        bouton.valeur_bouton = 1;
        y = 640F;
        bouton.dessine_bouton_bleu();        
        //--------------------------- écrire les CV -------------------------------
        ecrire_les_CV();;
    }
    //--------------------------------- modif_courbe() --------------------------
    void modif_courbe() {
        groupe2.dessine_gros_boutons(747F, 575F, 400F, 45F);
        groupe2.appui_gros_boutons();
    }
    //********************************************************************************************************
    //------------------------- carte_fonctions() ------------------------------
    void choix_carte_fonctions() {
        gestion.dessine_rectangle_bosse(23F, 108F, 1320F, 520F);
        //-------------- flêches verticales --------
        stroke(BLEU_CLAIR);
        strokeWeight(3);
        textFont(Courier17);
        for (int colonne = 0; colonne < 3; colonne++) {
            line(885F+32F*colonne, 175F+32F*10F, 885F+32F*colonne, 155F);
        }
        for (int colonne = 3; colonne < 6; colonne++) {
            line(885F+32F*colonne, 175F+32F*5F, 885F+32F*colonne, 155F);
        }
        for (int colonne = 6; colonne < 14; colonne++) {
            line(885F+32F*colonne, 175F, 885F+32F*colonne, 155F);
        }
        fill(BLEU_CLAIR);
        for (int colonne = 0; colonne < 14; colonne++) {
            triangle(885F+32F*colonne-5F, 160F, 885F+32F*colonne+5F, 160F, 885F+32F*colonne, 150F);
        }
        //-------------- flêches horizontales --------
        stroke(BLANC);
        fill(BLANC);
        for (int ligne = 0; ligne < 14; ligne++) {
            line(770F, 190F+32F*ligne, 840F, 190F+32F*ligne);
        }
        for (int ligne = 0; ligne < 14; ligne++) {
            triangle(840F, 190F+32F*ligne-5F, 840F, 190F+32F*ligne+5F, 850F, 190F+32F*ligne);
        }
        for (int ligne = 0; ligne < 14; ligne++) {
            image(affiche_bleu, 670F, 190F+32F*ligne-10F, 80F, 20F);
        }
        //---------- ligne "CV" ------
        fill(NOIR);
        for (int ligne = 0; ligne < 14; ligne++) {
            text("(CV"+str(33+ligne)+")", 625F, 192F+32F*ligne);
        }
        textAlign(LEFT, CENTER);
        text("Fonction 0/FL(f)", 430F, 187F);
        text("Phare frontal en marche avant", 40F, 187F);
        text("Fonction 0/FL(r)", 430F, 187F+32F);
        text("Phare frontal en marche arrière", 40F, 187F+32F);
        for (int ligne = 2; ligne < 14; ligne++) {
            text(proprietaire.F[ligne-1], 40F, 187F+32F*ligne);
            text("Fonction "+str(ligne-1), 430F, 187F+32F*ligne);
        }
        text("Contenu du CV", 645F, 192F-32F);        
        //------------------ couleurs des fils du décodeur --------------------
        for (int colonne = 0; colonne < 14; colonne++) {
            noFill();
            noStroke();
            switch (colonne) {
                case 0 :
                    fill(BLANC);
                    circle(852+32F*(14-colonne), 120F, 12F);
                    break;
                case 1 :
                    fill(OR);
                    circle(852+32F*(14-colonne), 120F, 12F);
                    break;
                case 2 :
                    fill(VERT);
                    circle(852+32F*(14-colonne), 120F, 12F);
                    break;
                case 3 :
                    fill(POURPRE);
                    circle(852+32F*(14-colonne), 120F, 12F);
                    break;
                case 4 :
                    fill(BRUN);
                    circle(852+32F*(14-colonne), 120F, 12F);
                    break;
                default:
                    noFill();
                    noStroke();
            }
        }
        //---------- titres -----------
        textAlign(RIGHT, CENTER);
        fill(VERT);
        text("Couleurs des fils du décodeur :", 850F, 118F);
        fill(BLANC);        
        text("Sorties :", 850F, 135F);
        //--------------- boutons ---------------------
        textAlign(CENTER, CENTER);
        int compteur_boutons = -1;
        for (int ligne = -1; ligne < 14; ligne++) {                                                                                      //  le tableau est parcouru en ligne, puis en colonne en décroissant
            for (int colonne = 13; colonne > -1; colonne--) {                                                                            //  on a ainsi un tableau parcouru du coin en haut à droite au coin en bas à gauche
                if (ligne == -1) {
                    text(str(colonne+1), 852+32F*(14-colonne), 135F);
                }
                if (colonne >  5 && colonne < 14 && ligne > -1 && ligne <  5) {
                    compteur_boutons++;
                    bouton = groupe.Boutons[compteur_boutons];
                    bouton.dessine_bouton(870F+32F*colonne, 175F+32F*ligne, 30F, 30F);
                    bouton.appui_bouton();
                    if (bouton.valide) {
                        bouton.valeur_bouton = int(pow(2, (13-colonne)));
                    } else {
                        bouton.valeur_bouton = 0;
                    }
                }
                if (colonne >  2 && colonne < 11 && ligne >  4 && ligne < 10) {
                    compteur_boutons++;
                    bouton = groupe.Boutons[compteur_boutons];
                    bouton.dessine_bouton(870F+32F*colonne, 175F+32F*ligne, 30F, 30F);
                    bouton.appui_bouton();
                    if (bouton.valide) {
                        bouton.valeur_bouton = int(pow(2, (10-colonne)));
                    } else {
                        bouton.valeur_bouton = 0;
                    }
                }
                if (colonne > -1 && colonne <  8 && ligne >  9 && ligne < 14) {
                    compteur_boutons++;
                    bouton = groupe.Boutons[compteur_boutons];
                    bouton.dessine_bouton(870F+32F*colonne, 175F+32F*ligne, 30F, 30F);
                    bouton.appui_bouton();
                    if (bouton.valide) {
                        bouton.valeur_bouton = int(pow(2, (7-colonne)));
                    } else {
                        bouton.valeur_bouton = 0;
                    }
                }
            }
        }
        //----------------- calcul des CV et affichage -------------------
        for (int ligne = 0; ligne < 14; ligne++) {
            CV[ligne] = 0;
        }
        int m = 0;
        for (int k = 0; k < 112; k++) {
            bouton = groupe.Boutons[k];
            if (k%8 != 7) {
                CV[m] = CV[m]+bouton.valeur_bouton;
            } else {
                CV[m] = CV[m]+bouton.valeur_bouton;
                m++;
            }
        }
        fill(NOIR);
        for (int ligne = 0; ligne < 14; ligne++) {
            text(CV[ligne], 710F, 187F+32F*ligne);
        }
        //---------------- bouton valeurs par défaut -----------
        textFont(Courier12);        
        bouton = groupe.Boutons[112];
        bouton.dessine_bouton(1170F, 577F, 140F, 40F);
        bouton.appui_bouton();
        //---------------- bouton valeurs dans le décodeur -------
        bouton = groupe.Boutons[113];
        bouton.dessine_bouton(1170F, 510F, 140F, 60F);
        bouton.appui_bouton();        
        //--------------------------- écrire les CV -------------------------------
        ecrire_les_CV();;
    }
    //------------------------- transferts() -----------------------------------
    void transferts() {
        groupe1.dessine_gros_boutons(330F, 690F, 630F, 40F);
        groupe1.appui_gros_boutons();        
    }
    //------------------------- fonctions_par_defaut() ----------------------------
    void fonctions_par_defaut() {
        for (int k = 0; k < 112; k++) {
            bouton = groupe.Boutons[k];
            bouton.valide = false;          
        }
        for (int k = 0; k < 40; k = k+9) {
            bouton = groupe.Boutons[k];
            bouton.valide = true;
        }
        for (int k = 42; k < 80; k = k+9) {
            bouton = groupe.Boutons[k];
            bouton.valide = true;
        }
        for (int k = 84; k < 112; k = k+9) {
            bouton = groupe.Boutons[k];
            bouton.valide = true;
        }
    }
    //---------------------------- fonctions_decodeur() --------------------
    void fonctions_decodeur() {
        int compteur_boutons = -1;
        for (int j = 33; j < 47; j++) {
            String binaire = binary(infos_CV.CV[j], 8);
            for (int i = 7; i > -1; i--) {
                compteur_boutons++;
                bouton = groupe.Boutons[compteur_boutons];
                if (binaire.substring(i, i+1).equals("0")) {
                    bouton.valide = false;
                } else {
                    bouton.valide = true;
                }
            }
        }
    }
    //********************************************************************************************************
    //---------------------------- choix_onglet_tableau_CV() ----------------
    void choix_onglet_tableau_CV() {
        for (int ligne = 0; ligne < 12; ligne++) {                                                                                      //  le tableau est parcouru en ligne, puis en colonne
            for (int colonne = 0; colonne < 10; colonne++) {
                int case_CV = 10*ligne+colonne+1;
                gestion.dessine_rectangle_creux(GRIS, 15F+135F*colonne, 115F+43F*ligne, 120F, 30F);
                textAlign(LEFT, CENTER);
                fill(BLANC);
                text("CV"+str(case_CV), 20F+135F*colonne, 127F+43F*ligne);
                imageMode(CENTER);
                fill(NOIR);
                textAlign(CENTER, CENTER);
                if (CV_decodeur[case_CV] == infos_CV.CV[case_CV]) {
                    image(affiche_vert,                  75F+135F*colonne, 129F+43F*ligne, 30F, 21F);
                    image(affiche_vert,                 112F+135F*colonne, 129F+43F*ligne, 30F, 21F);
                    text(str(CV_decodeur[case_CV]),      75F+135F*colonne, 127F+43F*ligne);                
                    text(infos_CV.CV[case_CV],          112F+135F*colonne, 127F+43F*ligne);                    
                } else {
                    if (CV_decodeur[case_CV] == -2) {
                        image(affiche_bleu,             112F+135F*colonne, 129F+43F*ligne, 30F, 21F);
                        text(str(infos_CV.CV[case_CV]), 112F+135F*colonne, 127F+43F*ligne);                       
                    } else {
                        image(affiche_bleu,              75F+135F*colonne, 129F+43F*ligne, 30F, 21F);
                        image(affiche_bleu,             112F+135F*colonne, 129F+43F*ligne, 30F, 21F);
                        text(str(CV_decodeur[case_CV]),  75F+135F*colonne, 127F+43F*ligne);                
                        text(str(infos_CV.CV[case_CV]), 112F+135F*colonne, 127F+43F*ligne);                        
                    }
                }
            }
        }
        gestion.dessine_rectangle_creux(GRIS, 1020F, 115F+43F*12, 330F, 30F);
        textAlign(CENTER, CENTER);
        fill(BLANC);
        text("CV n°",            1040F, 127F+43F*12F);
        image(affiche_bleu,      1150F, 129F+43F*12F, 120F, 21F);
        image(affiche_bleu,      1280F, 129F+43F*12F, 120F, 21F);
        fill(NOIR);
        text("Dans le décodeur", 1150F, 127F+43F*12F);                
        text("Dans le fichier",  1280F, 127F+43F*12F);
        //----------------- boutons ---------------------
        //----------------- aucun bouton ------------------
        if (!transfert_fich_dec && !transfert_dec_fich) {
            textAlign(CENTER, CENTER);
            int compteur_boutons = -1;
            for (int ligne = 0; ligne < 12; ligne++) {                                                                                      //  le tableau est parcouru en ligne, puis en colonne
                for (int colonne = 0; colonne < 10; colonne++) {
                    String texte_info;
                    compteur_boutons++;
                    bouton = groupe.Boutons[compteur_boutons];
                    bouton.dessine_bouton(10F+135F*colonne, 112F+43F*ligne, 130F, 40F);
                    bouton.appui_bouton();
                    if (appui_validation) {
                        fin_comptage = millis();
                    }
                    if (appui_CV != 0 || (appui_validation && fin_comptage-debut_comptage < 2000)) {
                        String texte_ici = "Chaîne envoyée = <R "+str(appui_CV)+" 1"+str(appui_CV)+" 1"+str(appui_CV)+">";
                        if (appui_CV != 0) {
                            texte_info = texte_ici;
                        } else {
                            texte_info = texte_lire;
                        }
                        gestion.dessine_rectangle_bosse((width-500F)/2F, (height-300F)/2F, 500F, 300F);
                        textFont(Courier17);
                        textAlign(CENTER, CENTER);
                        text(texte_info, width/2F, height/2F);
                        if (appui_CV == 0 && fin_comptage-debut_comptage > 1000) {
                            appui_validation = false;
                            texte_lire = "";
                        }
                    }
                }
            }
        }
        //--------------------------- transfert decodeur --> ficher ------------------------
        if (transfert_dec_fich) {
            textAlign(CENTER, CENTER);
            int compteur_boutons = -1;
            for (int ligne = 0; ligne < 12; ligne++) {                                                                                      //  le tableau est parcouru en ligne, puis en colonne
                for (int colonne = 0; colonne < 10; colonne++) {
                    int case_CV = 10*ligne+colonne+1;
                    compteur_boutons++;
                    bouton = groupe.Boutons[compteur_boutons];
                    bouton.dessine_bouton(10F+135F*colonne, 112F+43F*ligne, 130F, 40F);
                    bouton.appui_bouton();
                    if (appui_CV != 0 && appui_CV == case_CV) {
                        infos_CV.CV[case_CV] = CV_decodeur[case_CV];
                        sauve_table_Infos_CV();
                        transfert_dec_fich = false;
                        appui_CV = 0;
                        break;
                    }
                }
            }
        }
        //--------------------------- transfert fichier --> decodeur ------------------------
        if (transfert_fich_dec) {
            textAlign(CENTER, CENTER);
            int compteur_boutons = -1;
            for (int ligne = 0; ligne < 12; ligne++) {                                                                                      //  le tableau est parcouru en ligne, puis en colonne
                for (int colonne = 0; colonne < 10; colonne++) {
                    int case_CV = 10*ligne+colonne+1;
                    compteur_boutons++;
                    bouton = groupe.Boutons[compteur_boutons];
                    bouton.dessine_bouton(10F+135F*colonne, 112F+43F*ligne, 130F, 40F);
                    bouton.appui_bouton();
                    if (appui_CV != 0 && appui_CV == case_CV) {
                        ecrire_CV(case_CV);
                        CV_decodeur[case_CV] = infos_CV.CV[case_CV];
                        transfert_fich_dec = false;
                        appui_CV = 0;
                        break;
                    }
                }
            }
        }
    }
    //********************************************************************************************************
    //---------------------------- choix_onglet_fonctions_proprietaires() ----------------
    void choix_onglet_fonctions_proprietaires() {
        for (Proprietaire prop0 : tous_proprietaires) {
            if (vehicule.CV106 == prop0.CV106) {
                proprietaire = prop0;
                break;
            }
        }
        for (int ligne = 0; ligne < 14; ligne++) {                                                                                      //  le tableau est parcouru en ligne, puis en colonne
            for (int colonne = 0; colonne < 2; colonne++) {
                int case_prop = 2*ligne+colonne+1;
                gestion.dessine_rectangle_creux(GRIS, 65F+625F*colonne, 110F+37F*ligne, 600F, 28F);
                textAlign(LEFT, CENTER);
                fill(BLANC);
                text("Libellé de la fonction F"+str(case_prop), 70F+625F*colonne, 124F-2F+37F*ligne);
                imageMode(CENTER);
                fill(NOIR);
                textAlign(CENTER, CENTER);
                if (prop[case_prop] != proprietaire.F[case_prop]) {
                    image(affiche_vert, 475F+625F*colonne, 124F+37F*ligne, 350F, 21F);
                } else {
                    image(affiche_bleu, 475F+625F*colonne, 124F+37F*ligne, 350F, 21F);
                }
                text(prop[case_prop],   475F+625F*colonne, 124F-2F+37F*ligne);                    
            }
        }
        gestion.dessine_rectangle_creux(GRIS, 65F+625F*1, 115F+37F*14.3F, 600F, 28F);
        text("Nom du propriétaire : "+proprietaire.prop+"    (CV106 = "+proprietaire.CV106+")", 365F+625F*1, 126F+37F*14.3F);
        //--------------------------- affichage cadre flottant ------------------------
        textAlign(CENTER, CENTER);
        int compteur_boutons = -1;
        for (int ligne = 0; ligne < 14; ligne++) {                                                                                      //  le tableau est parcouru en ligne, puis en colonne
            for (int colonne = 0; colonne < 2; colonne++) {
                //int case_prop = 2*ligne+colonne+1;
                compteur_boutons++;
                bouton = groupe.Boutons[compteur_boutons];
                bouton.dessine_bouton(65F+625F*colonne, 110F+37F*ligne, 600F, 28F);
                bouton.appui_bouton();
            }
        }
        //-------------------------- affichage question ------------------------------
        if (texte_information != null) {
            gestion.dessine_rectangle_bosse((width-500)/2F, (height-300F)/2F, 500F, 300F);
            textFont(Courier14);
            imageMode(CORNER);
            fill(BLANC);
            textAlign(CENTER, CENTER);            
            text(texte_information, width/2F, height/2F-120F);
            text("Ancien libellé de F"+appui_F+" : "
            +char(10)+"("+prop[appui_F]+")", width/2F, height/2F-70F);
            text(texte_details, width/2F, height/2F-20F);
            image(affiche_bleu, width/2F-178F, height/2F, 350F, 30F);
            textAlign(RIGHT, CENTER);
            fill(NOIR);
            text(texte_saisi, width/2F+ 172F-5F, height/2F+12F);
            textAlign(CENTER, CENTER);
            fill(BLANC);
            text("Laissez vide puis VALIDEZ pour sortir sans rien faire", width/2F, height/2F+60F);
        }
    }
    //************************************************************************************************************* valide_onglet() 
    //------------------------- valide_onglet() -----------------------------------
    void valide_onglet() {
        groupe1.dessine_deux_boutons(320F, 690F, 565F, 40F);
        groupe1.appui_gros_boutons();        
    }
}

//*******************************************************************************************
//*************************************** groupes particuliers ******************************
//*******************************************************************************************
//*******************************************************************************************
class Choix_vehicule extends Groupe {
    Choix_vehicule() {
        super(new Bouton[] { new Precedent_vehicule(), new Suivant_vehicule(), new Bouton_pupitre() });
        numero_groupe = 0;
    }
}
//*******************************************************************************************
class Copie_ligne2 extends Groupe {
    Copie_ligne2() {
        super(new Bouton[] { new Faire_copie(), new Sortir_copie() });
        numero_groupe = 1;
    }
}
//*******************************************************************************************
class Boutons_confirmation extends Groupe {
    Boutons_confirmation() {
        super(new Bouton[] { new OK(), new Annule() });
        numero_groupe = 3;
    }
}
//*******************************************************************************************
class Choix_compo extends Groupe {
    Choix_compo() {
        super(new Bouton[] { new Precedent_compo(), new Suivant_compo() });
        numero_groupe = 4;
    }
}
//*******************************************************************************************
class Boutons_onglet_fiche extends Groupe {
    Boutons_onglet_fiche() {
        super(new Bouton[] { new Longueur(), new Largeur(), new Hauteur(),                                                               //   0   1   2
                             new Courant_moteur_max(), new Courant_pic_moteur(), new Duree_pic_moteur(),                                 //   3   4   5
                             new Courant_total_max(),  new Courant_pic_total(), new Connecteur(),                                        //   6   7   8
                             new Nom(), new Image(), new Couleur(), new Vehicule_moteur(),                                               //   9  10  11  12
                             new Vehicule_marque(), new Vehicule_ref(), new Vehicule_echelle(), new Hors_tampon(),                       //  13  14  15  16
                             new Vitesse_reelle(), new Frein(), new Elan(),                                                              //  17  18  19
                             new Num_proprietaire(), new Nom_proprietaire(),                                                             //  20  21
                             new Numero_fabricant(), new Numero_version(),                                                               //  22  23
                             new Ajoute_proprietaire(), new Retire_proprietaire(), new Modif_nom(), new Modif_numero(), new Affiche(),   //  24  25  26  27 28
                             new Valeurs_usine(), new Master_reset() });                                                                 //  29  30
        numero_groupe = 5;
    }
}
//*******************************************************************************************
class Boutons_onglet_adresse extends Groupe {
    Boutons_onglet_adresse() {
        super(new Bouton[] { new Adresse_actuelle(), new Adresse_courte(), new CV1(), new CV17(), new CV18(), new Adresse() });
        numero_groupe = 6;
    }
}
//*******************************************************************************************
class Boutons_onglet_configuration extends Groupe {
    Boutons_onglet_configuration() {
        super(new Bouton[] { new Valeur_CV29_enregistree(), new Sens_normal(), new Nb_crans(), new Analogique(), new Bouton_railcom(), new Table_vitesse(),
                             new Adresse_courte(), new CV29_bit6(), new CV29_bit7(), new Valeur_CV29_modifiee() });
        numero_groupe = 7;
    }
}
//*******************************************************************************************
class Boutons_onglet_moteur extends Groupe {
    Boutons_onglet_moteur() {
        super(new Bouton[] {});
        numero_groupe = 8;
    }
}
//*******************************************************************************************
class Boutons_onglet_controle_basique_de_vitesse extends Groupe {
    Boutons_onglet_controle_basique_de_vitesse() {
        super(new Bouton[] { new Table_vitesse() });
        numero_groupe = 9;
    }
}
//*******************************************************************************************
class Boutons_onglet_tableau_vitesse extends Groupe {
    Boutons_onglet_tableau_vitesse() {
        super(new Bouton[] { new Table_vitesse() });
        numero_groupe = 10;
    }
}
//*******************************************************************************************
class Boutons_onglet_carte_fonctions extends Groupe {
    Boutons_onglet_carte_fonctions() {
        super(new Bouton[] { new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(),
                             new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(),
                             new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(),
                             new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(),
                             new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(),
                             new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(),
                             new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(),
                             new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(),
                             new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(),
                             new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(),
                             new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(),
                             new Bouton_fonction(), new Bouton_fonction(), new Fonctions_par_defaut(), new Fonctions_decodeur() });
        numero_groupe = 11;
    }
}
//*******************************************************************************************
class Boutons_onglet_tableau_CV extends Groupe {
    Boutons_onglet_tableau_CV() {
        super(new Bouton[] { new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(),
                             new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(),
                             new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(),
                             new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(),
                             new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(),
                             new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(),
                             new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(),
                             new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(),
                             new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(),
                             new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(),
                             new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(),
                             new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV() });
        numero_groupe = 12;
    }
}
//*******************************************************************************************
class Boutons_onglet_fonctions_proprietaires extends Groupe {
    Boutons_onglet_fonctions_proprietaires() {
        super(new Bouton[] { new Selection_fonctions(), new Selection_fonctions(), new Selection_fonctions(), new Selection_fonctions(), new Selection_fonctions(), new Selection_fonctions(), new Selection_fonctions(),
                             new Selection_fonctions(), new Selection_fonctions(), new Selection_fonctions(), new Selection_fonctions(), new Selection_fonctions(), new Selection_fonctions(), new Selection_fonctions(),
                             new Selection_fonctions(), new Selection_fonctions(), new Selection_fonctions(), new Selection_fonctions(), new Selection_fonctions(), new Selection_fonctions(), new Selection_fonctions(),
                             new Selection_fonctions(), new Selection_fonctions(), new Selection_fonctions(), new Selection_fonctions(), new Selection_fonctions(), new Selection_fonctions(), new Selection_fonctions() });
        numero_groupe = 13;
    }
}
//*******************************************************************************************
class Boutons_onglet_lumieres extends Groupe {
    Boutons_onglet_lumieres() {
        super(new Bouton[] {});
        numero_groupe = 14;
    }
}
//*******************************************************************************************
class Boutons_onglet_controle_analogique extends Groupe {
    Boutons_onglet_controle_analogique() {
        super(new Bouton[] {});
        numero_groupe = 15;
    }
}
//*******************************************************************************************
class Boutons_onglet_convoi extends Groupe {
    Boutons_onglet_convoi() {
        super(new Bouton[] {});
        numero_groupe = 16;
    }
}
//*******************************************************************************************
class Boutons_onglet_avance extends Groupe {
    Boutons_onglet_avance() {
        super(new Bouton[] {});
        numero_groupe = 17;
    }
}
//*******************************************************************************************
class Boutons_onglet_sons extends Groupe {
    Boutons_onglet_sons() {
        super(new Bouton[] {});
        numero_groupe = 18;
    }
}
//*******************************************************************************************
class Boutons_onglet_volume_sons extends Groupe {
    Boutons_onglet_volume_sons() {
        super(new Bouton[] {});
        numero_groupe = 19;
    }
}
//*******************************************************************************************
class Boutons_onglet_accel_decel extends Groupe {
    Boutons_onglet_accel_decel() {
        super(new Bouton[] {});
        numero_groupe = 20;
    }
}
//*******************************************************************************************
class Boutons_onglet_shunt_uncouple extends Groupe {
    Boutons_onglet_shunt_uncouple() {
        super(new Bouton[] {});
        numero_groupe = 21;
    }
}
//*******************************************************************************************
class Boutons_onglet_alt_fonctions_map extends Groupe {
    Boutons_onglet_alt_fonctions_map() {
        super(new Bouton[] {});
        numero_groupe = 22;
    }
}
//*******************************************************************************************
class Boutons_onglet_fonctions_output extends Groupe {
    Boutons_onglet_fonctions_output() {
        super(new Bouton[] {});
        numero_groupe = 23;
    }
}
//*******************************************************************************************
class Boutons_onglet_zimo_specific extends Groupe {
    Boutons_onglet_zimo_specific() {
        super(new Bouton[] {});
        numero_groupe = 24;
    }
}
//*******************************************************************************************
class Boutons_onglet_railcom extends Groupe {
    Boutons_onglet_railcom() {
        super(new Bouton[] {});
        numero_groupe = 25;
    }
}
//*******************************************************************************************
class Boutons_onglet_abc extends Groupe {
    Boutons_onglet_abc() {
        super(new Bouton[] {});
        numero_groupe = 26;
    }
}
//*******************************************************************************************
class Boutons_onglet_speed_regulation extends Groupe {
    Boutons_onglet_speed_regulation() {
        super(new Bouton[] {});
        numero_groupe = 27;
    }
}
//*******************************************************************************************
class Boutons_onglet_servos extends Groupe {
    Boutons_onglet_servos() {
        super(new Bouton[] {});
        numero_groupe = 28;
    }
}
//*******************************************************************************************
class Boutons_modif_courbe extends Groupe {
    Boutons_modif_courbe() {
        super(new Bouton[] { new Vapeur(), new Electrique_diesel(), new Boutons_libres() });
        numero_groupe = 29;
    }
}
//*******************************************************************************************
class Boutons_transfert_donnees extends Groupe {
    Boutons_transfert_donnees() {
        super(new Bouton[] { new Fichier_decodeur(), new Decodeur_fichier(), new Retour_vehicule() });
        numero_groupe = 30;
    }
}
//*******************************************************************************************
class Haut_bas0 extends Groupe {
    Haut_bas0() {
        super(new Bouton[] { new Haut(), new Bas() });
        numero_groupe = 31;
    }
}
//*******************************************************************************************
class Haut_bas2 extends Groupe {
    Haut_bas2() {
        super(new Bouton[] { new Haut(), new Bas() });
        numero_groupe = 32;
    }
}
//*******************************************************************************************
class Pupitre extends Groupe {
    Pupitre() {
        super(new Bouton[] { new Code_loco(), new Bouton_fonction_pupitre(), new Bouton_fonction_pupitre(), new Bouton_fonction_pupitre(), new Bouton_fonction_pupitre(), new Bouton_fonction_pupitre(),
                                              new Bouton_fonction_pupitre(), new Bouton_fonction_pupitre(), new Bouton_fonction_pupitre(), new Bouton_fonction_pupitre(), new Bouton_fonction_pupitre(),
                                              new Bouton_fonction_pupitre(), new Bouton_fonction_pupitre(), new Bouton_fonction_pupitre(), new Bouton_fonction_pupitre(), new Bouton_fonction_pupitre(),
                                              new Bouton_fonction_pupitre(), new Bouton_fonction_pupitre(), new Bouton_fonction_pupitre(), new Bouton_fonction_pupitre(), new Bouton_fonction_pupitre(),
                                              new Bouton_fonction_pupitre(), new Bouton_fonction_pupitre(), new Bouton_fonction_pupitre(), new Bouton_fonction_pupitre(), new Bouton_fonction_pupitre(),
                                              new Bouton_fonction_pupitre(), new Bouton_fonction_pupitre(), new Bouton_fonction_pupitre(),
                                              new Nixie_plus(),  new Nixie_plus(),  new Nixie_plus(),  new Nixie_plus(),  new Nixie_plus(),
                                              new Nixie_moins(), new Nixie_moins(), new Nixie_moins(), new Nixie_moins() ,new Nixie_moins() });
        numero_groupe = 33;
    }
}
//*******************************************************************************************
class Boutons_vehicule extends Groupe {
    Boutons_vehicule() {
        super(new Bouton[] { new Ajoute_vehicule(), new MaJ_vehicule(), new Retire_vehicule() });
        numero_groupe = 34;
    }
}
//*******************************************************************************************
class Boutons_filtres extends Groupe {
    Boutons_filtres() {
        super(new Bouton[] {  new Effacer_filtres(), new Echelle(), new Bouton_moteur(), new DCC(), new Marque(), new Bouton_Proprietaire() });
        numero_groupe = 35;
    }
}
//*******************************************************************************************
class Boutons_decodeur extends Groupe {
    Boutons_decodeur() {
        super(new Bouton[] { new Ajoute_decodeur(), new MaJ_decodeur(), new Retirer_decodeur(), new Copier_CV(), new Coller_CV() });
        numero_groupe = 36;
    }
}
//*******************************************************************************************
class Boutons_composition extends Groupe {
    Boutons_composition() {
        super(new Bouton[] { new Ajoute_compo(), new Retire_compo(), new Valide_compo() });
        numero_groupe = 37;
    }
}
//*******************************************************************************************
class Boutons_validation_onglet extends Groupe {
    Boutons_validation_onglet() {
        super(new Bouton[] { new Validation_CV(), new Sortir_CV() });
        numero_groupe = 100;
    }
}
