//***************************** Recherche de fichiers ouverts ********************************************
void recherche_fichiers_ouverts() {
    //------------------ affichage du message d'erreur sur Vehicules.tsv ---------
    String texte =     "Vérification des fichiers"
    +char(10)+char(10)+"et test de la présence d'un Arduino";
    gestion.dessine_rectangle_bosse((width-500)/2F, (height-300F)/2F, 500F, 300F);
    choix_du_vehicule = true;
    try { 
        saveTable(Vehicules, Repertoire_Communs+"TSV/Vehicules.tsv");
    } catch (Exception IOException) {
        maj_decodeur = false;
        texte = "Le fichier Matériel.tsv est ouvert"
                 +char(10)+"dans une autre application"
        +char(10)+char(10)+"Fermez Vehicules.tsv"
                 +char(10)+"et relancez le programme";
        gestion.dessine_rectangle_bosse((width-500)/2F, (height-300F)/2F, 500F, 300F);
        text(texte, width/2F, height/2F);
        choix_du_vehicule = false;
    }
    //------------------ affichage du message d'erreur sur Infos_CV.tsv ---------
    gestion.dessine_rectangle_bosse((width-500)/2F, (height-300F)/2F, 500F, 300F);
    choix_du_vehicule = true;
    try { 
        saveTable(Infos_CV, Repertoire_Communs+"TSV/Infos_CV.tsv");
    } catch (Exception IOException) {
        maj_decodeur = false;
        texte = "Le fichier Infos_CV.tsv est ouvert"
                 +char(10)+"dans une autre application"
        +char(10)+char(10)+"Fermez Infos_CV.tsv"
                 +char(10)+"et relancez le programme";
        gestion.dessine_rectangle_bosse((width-500)/2F, (height-300F)/2F, 500F, 300F);
        text(texte, width/2F, height/2F);
        choix_du_vehicule = false;
    }
    //------------------ affichage du message d'erreur sur Proprietaires.tsv ---------
    gestion.dessine_rectangle_bosse((width-500)/2F, (height-300F)/2F, 500F, 300F);
    choix_du_vehicule = true;
    try { 
        saveTable(Proprietaires, Repertoire_Communs+"Proprietaires/Proprietaires.tsv");
    } catch (Exception IOException) {
        maj_decodeur = false;
        texte = "Le fichier Proprietaires.tsv est ouvert"
                 +char(10)+"dans une autre application"
        +char(10)+char(10)+"Fermez Proprietaires.tsv"
                 +char(10)+"et relancez le programme";
        gestion.dessine_rectangle_bosse((width-500)/2F, (height-300F)/2F, 500F, 300F);
        text(texte, width/2F, height/2F);
        choix_du_vehicule = false;
    }
    //------------------ affichage du message d'erreur sur Compositions.tsv ---------
    gestion.dessine_rectangle_bosse((width-500)/2F, (height-300F)/2F, 500F, 300F);
    text(texte, width/2F, height/2F);
    choix_du_vehicule = true;
    try { 
        saveTable(Compositions, Repertoire_Communs+"Compositions/Compositions.tsv");
    } catch (Exception IOException) {
        maj_decodeur = false;
        texte = "Le fichier Compositions.tsv est ouvert"
                 +char(10)+"dans une autre application"
        +char(10)+char(10)+"Fermez Compositions.tsv"
                 +char(10)+"et relancez le programme";
        gestion.dessine_rectangle_bosse((width-500)/2F, (height-300F)/2F, 500F, 300F);
        text(texte, width/2F, height/2F);
        choix_du_vehicule = false;
    }
}
//********************************************************************************************
//********************* Recherche automatique de l'Arduino (merci Pierre59) ******************
void connexion() { String[] sl=null; String s=null; boolean trace=false; // booleen pour trace ou pas)
    trouve = false;
    print("Plateforme ");
    switch (platform) { // afichage du nom de la platteforme
        case WINDOWS: println("WINDOWS"); break; // COM*
        case MACOSX:  println("MACOSX");  break; // usbmodem*
        case LINUX:   println("LINUX");   break; // ttyACM*
        default:      println("AUTRE"); 
    }
    
    sl=Serial.list();
    for (int i=0; i<sl.length; i++) println("n° "+i+" "+Serial.list()[i]); println(); // affichage des ports serie
    for (int i=sl.length-1; i>=0; i--) { s=sl[i]; // pour tous les ports serie (n° port decroissant)
        if (trace) print("port "+s+" : ");
        try { 
          port=new Serial(this,s,115200); 
          delay(2000); // il faut attendre un peu pour que le port série soit stable
          port.write("power on <1>");
        } catch(Throwable e) { if (trace) println(" erreur "+e);  continue; }
        
        delay(3000); // laisser le temps a l'arduino de transmettre le message et attendre le retour de l'accusé réception
        chaine_lue = port.readStringUntil(SUPERIEUR);
        if (chaine_lue != null && chaine_lue.equals("<p1>")) {
            trouve = true;
            break;
        }
    }
    if (trouve) {
        texte_ecrire = "Arduino trouve sur le port "+s;
    } else {
        texte_ecrire = "Aucun Arduino n'est branché à l'ordinateur";
    }    
}
