 //************************************** Bouton{} *********************************************
class Bouton {
    float   x0              = 0F;
    float   x               = 0F;
    float   y               = 0F;
    float   l               = 0F;
    float   h               = 0F;
    float   l0              = 0F;
    float   h0              = 0F;
    String  texte_affiche;
    String  texte_confirmation;
    String  titre_choix;
    String  texte_choix[]   = new String[NB_CHOIX];
    int     nb_choix        = 0;
    float   largeur_choix   = 0F;
    String  texte_choisi;
    boolean choix[]         = new boolean[NB_CHOIX];
    int     valeur_bouton   = 0;
    int     adresse_saisie  = -1;
    int     CV17            = 0;
    int     CV18            = 0;
    boolean modif_CV29      = false;
    String  texte_saisi_b   = "";
    boolean valide          = false;
    String  dixieme_mm;
    boolean haut0           = false;
    boolean bas0            = false;
    boolean haut2           = false;
    boolean bas2            = false;
    Bouton() {}

    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        image(gros_bleu, _x, _y, _l, _h);
        textAlign(CENTER, CENTER);
        fill(NOIR);        
        text(texte_affiche, _x+_l/2F, _y+_h/2F);
        x = _x; y = _y; l = _l; h = _h;
    }
    //--------------------------------- effacer_les_boutons() -------------------------
    void effacer_les_boutons() {
        ajouter_decodeur       = false;
        maj_decodeur           = false;
        copier_CV              = false;
        coller_CV              = false;
        choix_du_vehicule      = false;
        sortir_sans_sauver     = false;
        choix_vehicule         = false;
        dans_curseurH_vehicule = false;
        dans_curseurH_compo    = false;
        for (int i = 0; i < 5; i++) {
            choix[i]           = false;
            groupe = groupes[54];
            groupe.Boutons[i+1].texte_choisi = null;
        }
        valide = false;
    }
    //------------------------------ choisir_filtre() ----------------------------------
    void choisir_filtre(int _filtre) {
        textFont(Courier12);
        float taille_texte = textWidth(titre_choix);
        gestion.dessine_rectangle_bosse(width/2F-taille_texte/2F-20F, height/2F-(100F+15F*nb_choix)/2F, taille_texte+40F, 100F+15F*nb_choix);
        textAlign(CENTER);
        text(titre_choix, width/2F, height/2F-(100F+15F*nb_choix)/2F+20F);
        gestion.dessine_rectangle_creux(GRIS, width/2F-largeur_choix/2F, height/2F-(100F+15F*nb_choix)/2F+40F, largeur_choix, 6+15*nb_choix);
        textFont(Courier14);
        textAlign(LEFT);
        int compte_choix = -1;
        for (int i = 0; i < nb_choix; i++) {
            compte_choix++;
            texte_choisi = texte_choix[compte_choix];
            if (mouseX > width/2F-largeur_choix/4F                                    && mouseX < width/2F+largeur_choix/4F
             && mouseY > height/2F-(100F+15F*nb_choix)/2F+40F+15F+15F*compte_choix-10F && mouseY < height/2F-(100F+15F*nb_choix)/2F+40F+15F+15F*compte_choix-10F+15F) {
                if (!mousePressed) {
                    fill(NOIR);
                    imageMode(CENTER);
                    image(affiche_bleu, width/2F, height/2F-(100F+15F*nb_choix)/2F+40F+10F+15F*compte_choix, textWidth(texte_choisi), 15);
                } else {
                    tous_vehicules.clear();
                    int compte_vehicules = -1;
                    switch (_filtre) {
                        //-------------- echelle -----------------
                        case 0 :
                            valide = true;
                            for (Vehicule veh0 : tous_vehicules_filtres) {
                                if (veh0.echelle.equals(texte_choisi)) {
                                    compte_vehicules++;
                                    veh0.rang = compte_vehicules;
                                    tous_vehicules.add(veh0);
                                }
                            }
                            break;
                        //--------------- moteur ----------------
                        case 1 :
                            valide = true;
                            for (Vehicule veh0 : tous_vehicules_filtres) {
                                if (texte_choisi.equals("Moteur")) {
                                    if (veh0.moteur) {
                                        compte_vehicules++;
                                        veh0.rang = compte_vehicules;
                                        tous_vehicules.add(veh0);
                                    }
                                } else {
                                    if (!veh0.moteur) {
                                        compte_vehicules++;
                                        veh0.rang = compte_vehicules;
                                        tous_vehicules.add(veh0);
                                    }
                                }
                            }
                            break;
                        //--------------- DCC ----------------
                        case 2 :
                            valide = true;
                            for (Vehicule veh0 : tous_vehicules_filtres) {
                                if (texte_choisi.equals("DCC")) {
                                    if (veh0.ID_CV != 0) {
                                        compte_vehicules++;
                                        veh0.rang = compte_vehicules;
                                        tous_vehicules.add(veh0);
                                    }
                                } else {
                                    if (veh0.ID_CV == 0) {
                                        compte_vehicules++;
                                        veh0.rang = compte_vehicules;
                                        tous_vehicules.add(veh0);
                                    }
                                }
                            }
                            break;
                        //-------------- marque -----------------
                        case 3 :
                            valide = true;
                            for (Vehicule veh0 : tous_vehicules_filtres) {
                                if (veh0.marque.equals(texte_choisi)) {
                                    compte_vehicules++;
                                    veh0.rang = compte_vehicules;
                                    tous_vehicules.add(veh0);
                                }
                            }
                            break;
                        //-------------- proprietaire -----------------
                        case 4 :
                            valide = true;
                            for (Vehicule veh0 : tous_vehicules_filtres) {
                                int CV106 = 0;
                                for (Proprietaire prop0 : tous_proprietaires) {
                                    if (prop0.prop == texte_choisi) {
                                        CV106 = prop0.CV106;
                                        break;
                                    }
                                }
                                if (veh0.CV106 == CV106) {
                                    compte_vehicules++;
                                    veh0.rang = compte_vehicules;
                                    tous_vehicules.add(veh0);
                                }
                            }
                            break;
                    }
                    //--------------------- si on ne trouve rien, on retire le dernier choix -----------
                    if (tous_vehicules.size() == 0) {
                        for (Vehicule veh0 : tous_vehicules_filtres) {
                            tous_vehicules.add(veh0);
                        }
                        groupe = groupes[54];
                        String commentaire = "";
                        switch (_filtre) {
                            case 0 :
                                valide = false;
                                if (tous_vehicules.size() == tous_vehicules_complet.size()) {
                                    commentaire = "Il n'y a pas de véhicule à l'échelle "+texte_choisi+" dans votre parc";
                                } else {
                                    commentaire = "Il n'y a pas de véhicule à l'échelle "+texte_choisi+" dans les élements déjà filtrés";
                                }
                                groupe.Boutons[1].texte_choisi = null;
                                break;
                            case 1 :
                                valide = false;
                                if (tous_vehicules.size() == tous_vehicules_complet.size()) {
                                    commentaire = "Il n'y a pas de véhicule "+texte_choisi+" dans votre parc";
                                } else {
                                    commentaire = "Il n'y a pas de véhicule "+texte_choisi+" dans les élements déjà filtrés";
                                }
                                groupe.Boutons[2].texte_choisi = null;
                                break;
                            case 2 :
                                valide = false;
                                if (tous_vehicules.size() == tous_vehicules_complet.size()) {
                                    commentaire = "Il n'y a pas de véhicule "+texte_choisi+" dans votre parc";
                                } else {
                                    commentaire = "Il n'y a pas de véhicule "+texte_choisi+" dans les élements déjà filtrés";
                                }
                                groupe.Boutons[3].texte_choisi = null;
                                break;
                            case 3 :
                                valide = false;
                                if (tous_vehicules.size() == tous_vehicules_complet.size()) {
                                    commentaire = "Il n'y a pas de véhicule "+texte_choisi+" dans votre parc";
                                } else {
                                    commentaire = "Il n'y a pas de véhicule "+texte_choisi+" dans les élements déjà filtrés";
                                }
                                groupe.Boutons[4].texte_choisi = null;
                                break;
                            case 4 :
                                valide = false;
                                if (tous_vehicules.size() == tous_vehicules_complet.size()) {
                                    commentaire = texte_choisi+" ne possède rien dans votre parc";
                                } else {
                                    commentaire = texte_choisi+" ne possède rien dans les élements déjà filtrés";
                                }
                                groupe.Boutons[5].texte_choisi = null;
                                break;
                        }
                        taille_texte = textWidth(commentaire);
                        gestion.dessine_rectangle_bosse(width/2F-taille_texte/2F-20F, height/2F-(60F+15F)/2F, taille_texte+40F, 60F+15F);
                        textAlign(CENTER);
                        text(commentaire, width/2F, height/2F);
                    } else {
                        tous_vehicules_filtres.clear();
                        for (Vehicule veh0 : tous_vehicules) {
                            tous_vehicules_filtres.add(veh0);
                        }
                        for (int j = 0; j < 5; j++) {
                            choix[j] = false;
                        }
                    }
                    vehicule = tous_vehicules_filtres.get(0);
                    infos_CV = toutes_infos_CV.get(vehicule.ID_CV);
                    choix_du_vehicule = true;
                    break;
                }
            } else {
                fill(BLANC);
            }                        
            textAlign(CENTER);
            text(texte_choisi, width/2F, height/2F-(100F+15F*nb_choix)/2F+40F+15F+15F*compte_choix);
        }
    }
    //------------------------------ choisir_proprietaire() ----------------------------------
    void choisir_proprietaire() {
        if (texte_choix[0] != null) {
            textFont(Courier12);
            float taille_texte = textWidth(titre_choix);
            gestion.dessine_rectangle_bosse((width/2F+100F)-taille_texte/2F-20F, height/2F-(100F+15F*nb_choix)/2F, taille_texte+40F, 49F+15F*nb_choix);
            textAlign(CENTER);
            text(titre_choix, (width/2F+100F), height/2F-(100F+15F*nb_choix)/2F+20F);
            gestion.dessine_rectangle_creux(GRIS, (width/2F+100F)-largeur_choix/2F, height/2F-(100F+15F*nb_choix)/2F+34F, largeur_choix, 6F+15*nb_choix);
            textFont(Courier14);
            textAlign(CENTER, CENTER);
            int compte_choix = -1;
            for (int i = 0; i < nb_choix; i++) {
                compte_choix++;
                if (mouseX > (width/2F+100F)-largeur_choix/4F                                  && mouseX < (width/2F+100F)+largeur_choix/4F
                 && mouseY > height/2F-(100F+15F*nb_choix)/2F+44F+15F*compte_choix-7.4F && mouseY < height/2F-(100F+15F*nb_choix)/2F+44F+15F*compte_choix+7.4F) {
                    if (!mousePressed) {
                        fill(NOIR);
                        imageMode(CENTER);
                        image(affiche_bleu, (width/2F+100F), height/2F-(100F+15F*nb_choix)/2F+44F+15F*compte_choix, textWidth(texte_choix[compte_choix]), 15);
                    } else {
                        for (Proprietaire prop0 : tous_proprietaires) {
                           if (("["+prop0.CV106+"] "+prop0.prop).equals(texte_choix[compte_choix])) {
                                texte_choisi = texte_choix[compte_choix];
                                break;
                            }
                        }
                    }
                } else {
                    fill(BLANC);
                }                        
                text(texte_choix[compte_choix], (width/2F+100F), height/2F-(100F+15F*nb_choix)/2F+44F+15F*compte_choix-2F);
            }
        }
    }
    //---------------------------- effacer_choix() -----------------------------
    void effacer_choix() {
        for (int i = 0; i < NB_CHOIX; i++) {
            texte_choix[i] = "-";
        }
    }
    //---------------------------- compte_choix() -----------------------------
    void compte_choix() {
        nb_choix      = 0;
        largeur_choix = 0F;
        int choix_courant = 0;
        while (!texte_choix[choix_courant].equals("-")) {
            nb_choix++;
            if (texte_choix[choix_courant].substring(0, 1).equals("(")) {
                largeur_choix = max(largeur_choix, textWidth(texte_choix[choix_courant].substring(18))*0.7F);
            } else {
                largeur_choix = max(largeur_choix, textWidth(texte_choix[choix_courant])/0.7F);
            }
            choix_courant++;
        }
    }
    //----------------------------- liste_choix() -----------------------------
    void liste_choix(int _bouton) {
        if (titre_choix != null) {
            if (choix[_bouton] && valide) {
                textFont(Courier12);
                float taille_texte = textWidth(titre_choix);
                gestion.dessine_rectangle_bosse(x+60F-taille_texte, y, taille_texte+40F, 100F+15F*nb_choix);
                textAlign(CENTER);
                text(titre_choix, x+60F-taille_texte+(taille_texte+40F)/2F, y+20F);
                gestion.dessine_rectangle_creux(GRIS, x+60F-taille_texte+(taille_texte+40F-largeur_choix)/2F, y+15F+15F*nb_choix, largeur_choix, 6+15*nb_choix);
                textFont(Courier14);
                textAlign(LEFT);
                int compte_choix = -1;
                for (int i = 0; i < nb_choix; i++) {
                    compte_choix++;
                    String texte_de_choix = texte_choix[compte_choix];
                    if (mouseX > x+60F-taille_texte+(taille_texte+40F)/2F-largeur_choix/2F && mouseX < x+60F-taille_texte+(taille_texte+40F)/2F+largeur_choix/2F
                     && mouseY > y+60F+15F*compte_choix-15F                                && mouseY < y+60F+15F*compte_choix) {
                        if (!mousePressed) {
                            fill(NOIR);
                            imageMode(CENTER);
                            image(affiche_bleu, x+60F-taille_texte+(taille_texte+40F)/2F, y+60F+15F*compte_choix-4F, largeur_choix-20F, 15F);
                        } else {
                            texte_choisi   = texte_de_choix;
                            valeur_bouton  = compte_choix;
                            choix[_bouton] = false;
                            break;
                        }
                    } else {
                        fill(BLANC);
                    }                        
                    textAlign(CENTER);
                    text(texte_de_choix.substring(18), x+60F-taille_texte+(taille_texte+40F)/2F, y+60F+15F*compte_choix);
                }                
            }
        }
    }
    //-------------------------- dessine_bouton_bleu() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        if (texte_choisi == null) {
            image(affiche_bleu, x+130F, y+5F, l, h);
            fill(NOIR);
            textAlign(LEFT, CENTER);       
            text(texte_choix[valeur_bouton].substring(0, 18), x, y+1F+h/2F);
            textAlign(CENTER, CENTER);       
            text(texte_choix[valeur_bouton].substring(18), x0+l0-l/2F, y+1F+h/2F);
        } else {
            if (CV29 == infos_CV.CV[29]) {
                image(affiche_bleu, x+130F, y+5F, l, h);
                texte_choisi = null;
            } else {
                image(affiche_vert, x+130F, y+5F, l, h);
            }
            fill(NOIR);
            textAlign(LEFT, CENTER);       
            text(texte_choix[valeur_bouton].substring(0, 18), x, y+1F+h/2F);
            textAlign(CENTER, CENTER);       
            text(texte_choix[valeur_bouton].substring(18), x0+l0-l/2F, y+1F+h/2F);
        }
    }
    //-------------------------- dessine_bouton_bleu_modifie() -------------------------------
    void dessine_bouton_bleu_modifie(boolean _vert) {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        if (_vert) {
            image(affiche_vert, x+130F, y+5F, l, h);
        } else {
            image(affiche_bleu, x+130F, y+5F, l, h);
        }
        fill(NOIR);
        textAlign(LEFT, CENTER);       
        text(texte_choix[valeur_bouton].substring(0,18), x, y+1F+h/2F);
        textAlign(CENTER, CENTER);       
        text(texte_choix[valeur_bouton].substring(18), x+270F, y+1F+h/2F);
    }
    //------------------------------- CV29_bin_dec() ----------------------------------------------
    void CV29_bin_dec() {
        CV29 = 0;
        for (int i = 1; i < 9; i++) {
            CV29 = CV29 + int(groupe.Boutons[i].valeur_bouton*pow(2, i-1));                                                   //  2 puissance (i-1)
        }
    }
    //---------------------------- valeur_mm() ---------------------------------
    void valeur_mm(int _dixieme) {
        dixieme_mm = str(int(_dixieme/10F))+"."+str(int(_dixieme-10F*int(_dixieme/10F)));
    }
    //---------------------------- efface_Fiche() --------------------------------
    void efface_fiche() {
        if (onglet != null && onglet.Groupes[0].numero_groupe == 5) {
            for (int i = 0; i < 22; i++) {
                onglet.Groupes[0].Boutons[i].valide      = false;
                onglet.Groupes[0].Boutons[i].texte_saisi_b = "";
                texte_avertissement                      = null;
            }
        }
    }
    //---------------------------- methodes vides ------------------------------
    void description_bouton() {}
    void appui_bouton() {}
    void valeurs_usine() {}
    void master_reset() {}
}
//****************************************************************************************************************************************
//************************************* boutons particuliers *****************************************************************************
//****************************************************************************************************************************************
//**************************************************************************************************************************************** Précédent/suivant véhicule
class Precedent_vehicule extends Bouton {                                                                      //  groupe[0]Boutons[0]
    Precedent_vehicule() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        image(bouton_bleu, _x, _y, _l, _h);        
        stroke(NOIR);
        noFill();
        strokeWeight(1.5F);
        rect(_x, _y, 20F, 20F, 2, 2, 2, 2);
        fill(NOIR);
        triangle(_x+15F, _y+5F, _x+15F, _y+15F, _x+5F, _y+10F);
        noStroke();
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        int identite = vehicule.rang;
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                identite = max(0, identite-1);
                vehicule = tous_vehicules_filtres.get(identite);
                infos_CV = toutes_infos_CV.get(vehicule.ID_CV);
                sauvegarde_vehicule();
                sauvegarde_infos_CV();
                if (copier_CV && !coller_CV) {
                    vehicule_copie = identite;
                }
                gestion.largeur_curseur[0] = gestion.l0*vehicule.rang/(tous_vehicules.size()-1);
            }
        }
    }
}
//*********************************************************************************************
class Suivant_vehicule extends Bouton {                                                                      //  groupe[0]Boutons[1]
    Suivant_vehicule() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        image(bouton_bleu, _x, _y, _l, _h);
        stroke(NOIR);
        noFill();
        strokeWeight(1.5F);
        rect(_x, _y, 20, 20, 2, 2, 2, 2);
        fill(NOIR);
        triangle(_x+5F, _y+5F, _x+5F, _y+15F, _x+15F, _y+10F);
        noStroke();
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        int identite = vehicule.rang;
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                identite = min(tous_vehicules.size()-1, identite+1);
                vehicule = tous_vehicules_filtres.get(identite);
                infos_CV = toutes_infos_CV.get(vehicule.ID_CV);
                sauvegarde_vehicule();
                sauvegarde_infos_CV();
                if (copier_CV && !coller_CV) {
                    vehicule_copie = identite;
                }
                gestion.largeur_curseur[0] = gestion.l0*vehicule.rang/(tous_vehicules.size()-1);
            }
        }
    }
}
//**************************************************************************************************************************************** Haut/bas véhicule
//**********************************************************************************************************
class Haut extends Bouton {                                                                      //  groupe[31]Boutons[0] ou groupe[32]Boutons[0]
    Haut() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        image(bouton_bleu, _x, _y, _l, _h);        
        stroke(NOIR);
        noFill();
        strokeWeight(1.5F);
        rect(_x, _y, 20F, 20F, 2, 2, 2, 2);
        fill(NOIR);
        triangle(_x+10F, _y+5F, _x+15F, _y+15F, _x+5F, _y+15F);
        noStroke();
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                if (groupe.numero_groupe == 30) {
                    haut0 = true;
                }
                if (groupe.numero_groupe == 32) {
                    haut2 = true;
                }
            }
        }
    }
}
//*********************************************************************************************
class Bas extends Bouton {                                                                      //  groupe[31]Boutons[1] ou groupe[32]Boutons[1]
    Bas() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        image(bouton_bleu, _x, _y, _l, _h);        
        stroke(NOIR);
        noFill();
        strokeWeight(1.5F);
        rect(_x, _y, 20F, 20F, 2, 2, 2, 2);
        fill(NOIR);
        triangle(_x+15F, _y+5F, _x+10F, _y+15F, _x+5F, _y+5F);
        noStroke();
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                if (groupe.numero_groupe == 30) {
                    bas0 = true;
                }
                if (groupe.numero_groupe == 32) {
                    bas2 = true;
                }
            }
        }
    }
}
//**************************************************************************************************************************************** Ajoute/Retire véhicule
//*********************************************************************************************
class Ajoute_vehicule extends Bouton {                                                                      //  groupe[34]Boutons[0]
    Ajoute_vehicule() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Ajouter";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                effacer_les_boutons();
                Vehicule veh0 = new Vehicule();
                int max_ID = -1;
                for (Vehicule veh1 : tous_vehicules_complet) {
                    max_ID = max(max_ID, veh1.ID);
                }
                veh0.ID         = max_ID+1;
                veh0.ID_CV      = 0;
                veh0.nom        = "n.c.";
                veh0.image_t    = "nc.png";
                veh0.image_cote = nc;
                veh0.marque     = "n.c.";
                veh0.ref        = "n.c.";
                veh0.htamp      = 0;
                veh0.couleur    = unhex("FF808080");
                veh0.echelle    = "n.c.";
                veh0.moteur     = false;
                veh0.date       = "";
                veh0.rang       = tous_vehicules_complet.size();
                veh0.filtre     = true;
                veh0.CV106      = 0;
                tous_vehicules_complet.add(veh0);
                tous_vehicules_filtres.add(veh0);
                tous_vehicules.add(veh0);
                sauve_table_Vehicules();
                vehicule = tous_vehicules_complet.get(veh0.rang);                                      //  c'est le dernier véhicule, celui qu'on vient d'ajouter
                infos_CV = toutes_infos_CV.get(0);                                                     //  les CV sont à "vide"
                gestion.largeur_curseur[0] = gestion.l0*veh0.rang/(tous_vehicules.size()-1);
                choix_du_vehicule = true;
                texte_saisi_b     = " ";
            }
        }
    }
}
//*********************************************************************************************
class Retire_vehicule extends Bouton {                                                                      //  groupe[34]Boutons[2]
    Retire_vehicule() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Retirer";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                if (vehicule.ID == 0) {
                    texte_information = "On ne peut pas retirer le véhicule n° 0 (zéro)";
                    texte_details     = "faites ENTREE";
                } else {
                    valide              = true;
                    texte_avertissement = "Vous allez supprimer un véhicule !"
                                +char(10)+"Cela supprimera aussi ce véhicule"
                                +char(10)+"dans les compositions";
                    texte_information   = "Voulez-vous toujours supprimer le véhicule ?";
                    texte_details       = "o/n :";
                }
            }
            if (valide && saisie_valide) {
                if (texte_saisi.equals("o") || texte_saisi.equals("O") || texte_saisi.equals("oui")|| texte_saisi.equals("OUI")) {
                    if (vehicule.ID_CV != 0) {
                        toutes_infos_CV.remove(vehicule.ID_CV);                                  //  suppression des infos_CV
                        sauve_table_Infos_CV();
                    }
                    sauve_table_Infos_CV();
                    Vehicule vehicule_supprime = vehicule;                                      //  on garde le nom du véhicule pour le supprimer dans les compositions
                    for (int i = (tous_vehicules_complet.size()-1); i >= 0; i--) {
                        if (vehicule.equals(tous_vehicules_complet.get(i))) {
                             tous_vehicules_complet.remove(i);                                  //  suppression du véhicule
                             break;
                        }
                    }
                    tous_vehicules.clear();
                    tous_vehicules_filtres.clear();
                    for (int i = 0; i < tous_vehicules_complet.size(); i++) {
                        tous_vehicules.add(tous_vehicules_complet.get(i));                      //  maj "tous_vehicules" et "tous_vehicules_filtres"
                        tous_vehicules_filtres.add(tous_vehicules_complet.get(i));
                        tous_vehicules_complet.get(i).rang = i;
                    }                
                    sauve_table_Vehicules();
                    vehicule = tous_vehicules_complet.get(0);                                    //  on repart au premier véhicule
                    infos_CV  = toutes_infos_CV.get(0);
                    gestion.largeur_curseur[0] = gestion.l0*vehicule.rang/(tous_vehicules.size()-1);
                    choix_du_vehicule = true;
                    for (Composition compo0 : toutes_compositions) {
                        for (int i = 0; i < 20; i++) {
                            if (compo0.veh[i] == vehicule_supprime) {
                                for (int j = i; j < 19; j++) {
                                    compo0.veh[j] = compo0.veh[j+1];                              //  suppression du véhicule dans les compositions
                                }
                                compo0.veh[19] = null;
                                i--;
                            }
                        }
                    }
                    valide            = false;
                    texte_information = null;
                    texte_saisi       = "";
                    sauve_table_Compositions();
                }
                if (texte_saisi.equals("n") || texte_saisi.equals("N")) {
                    texte_information = null;
                    texte_saisi       = "";
                    valide            = false;
                }
            }
        }
    }
}
//*********************************************************************************************
class MaJ_vehicule extends Bouton {                                                                      //  groupe[34]Boutons[1]
    MaJ_vehicule() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Mettre à jour";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                effacer_les_boutons();
                maj_decodeur          = true;
                gestion.one_shot      = true;
                gestion.ligne_modele  = 0;
                if (gestion.one_shot) {
                    gestion.fabricant_choisi = infos_CV.fabricant;
                    gestion.famille_choisie  = gestion.fabricant_choisi+"/"+infos_CV.famille;
                    for (String mod0 : tous_modeles) {
                        int mod = mod0.indexOf("//");
                        if (mod0.substring(0, mod).equals(gestion.famille_choisie)) {
                            for (Decodeur dec0 : tous_decodeurs) {
                                if (dec0 != null && dec0.nom_modele.equals(mod0)) {
                                    gestion.modele_choisi   = gestion.famille_choisie+"//"+infos_CV.modele;
                                    gestion.decodeur_choisi = dec0;
                                }
                            }                        
                        }
                    }
                    for (String mod0 : tous_modeles) {
                        int mod = mod0.indexOf("//");
                        if (mod0.substring(0, mod).equals(gestion.famille_choisie)) {
                            tous_onglets.clear();
                            int nb_onglets = gestion.decodeur_choisi.Onglets.length;
                            for (int i = 0; i < nb_onglets ; i++) {
                                tous_onglets.add(gestion.decodeur_choisi.Onglets[i]);
                            }
                        }
                    }
                    for (Onglet ong0 : tous_onglets) {
                        ong0.maj_curseurs();
                    }
                }
            }
        }        
    }
}
//**************************************************************************************************************************************** Filtres
//*********************************************************************************************
class Effacer_filtres extends Bouton {                                                                      //  groupe[35]Boutons[0]
    Effacer_filtres() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Effacer filtres";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                int compte_vehicules = -1;
                tous_vehicules_filtres.clear();
                tous_vehicules.clear();
                for (Vehicule veh0 : tous_vehicules_complet) {
                    compte_vehicules++;
                    veh0.rang = compte_vehicules;
                    tous_vehicules_filtres.add(veh0);
                    tous_vehicules.add(veh0);
                }
                vehicule = tous_vehicules_complet.get(0);
                infos_CV  = toutes_infos_CV.get(0);
                effacer_les_boutons();
                choix_du_vehicule = true;
                //---------------------------- gestion des filtres ----------------------------
                for (int i = 0; i < 5; i++) {
                    groupe = groupes[54];
                    groupe.Boutons[i+1].choix[i] = false;
                    groupe.Boutons[i+1].valide   = false;
                }
            }
        }        
    }
}
//*********************************************************************************************
class Echelle extends Bouton {                                                                      //  groupe[35]Boutons[1]
    Echelle() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Echelle";
        effacer_choix();
        titre_choix    = "Filtrer par échelle";
        texte_choix[0] = "HO";
        texte_choix[1] = "HOe";
        texte_choix[2] = "HOm";
        texte_choix[3] = "N";
        texte_choix[4] = "0";
        haut0          = false;
        compte_choix();
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (valide) {
            image(gros_vert, _x, _y, _l, _h);
        } else {
            image(gros_bleu, _x, _y, _l, _h);
        }
        textAlign(CENTER, CENTER);       
        fill(NOIR);
        text(texte_affiche, _x+_l/2, _y+_h/2F);
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                valide   = true;
                choix[0] = true;
            }
        }
    }
}
//*********************************************************************************************
class Bouton_moteur extends Bouton {                                                                      //  groupe[35]Boutons[2]
    Bouton_moteur() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Moteur";
        effacer_choix();
        titre_choix    = "Filtrer par type de matériel";
        texte_choix[0] = "Moteur";
        texte_choix[1] = "Remorqué";
        haut0          = false;
        compte_choix();
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (valide) {
            image(gros_vert, _x, _y, _l, _h);
        } else {
            image(gros_bleu, _x, _y, _l, _h);
        }
        textAlign(CENTER, CENTER);
        fill(NOIR);
        text(texte_affiche, _x+_l/2, _y+_h/2F);
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                valide   = true;
                choix[1] = true;
            }
        }        
    }
}
//*********************************************************************************************
class DCC extends Bouton {                                                                      //  groupe[35]Boutons[3]
    DCC() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = " DCC ";
        effacer_choix();
        titre_choix    = "Filtrer par décodeur";
        texte_choix[0] = "DCC";
        texte_choix[1] = "Non";
        haut0          = false;
        compte_choix();
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (valide) {
            image(gros_vert, _x, _y, _l, _h);
        } else {
            image(gros_bleu, _x, _y, _l, _h);
        }
        textAlign(CENTER, CENTER);
        fill(NOIR);
        text(texte_affiche, _x+_l/2, _y+_h/2F);
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                valide   = true;
                choix[2] = true;
            }
        }        
    }
}
//*********************************************************************************************
class Marque extends Bouton {                                                                      //  groupe[35]Boutons[4]
    Marque() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Marque véhicule";
        titre_choix    = "Filtrer par marque";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (valide) {
            image(gros_vert, _x, _y, _l, _h);
        } else {
            image(gros_bleu, _x, _y, _l, _h);
        }
        textAlign(CENTER, CENTER);
        fill(NOIR);
        text(texte_affiche, _x+_l/2, _y+_h/2F);
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                effacer_choix();
                int marques_size = toutes_marques.size();
                for (int i = 0; i < marques_size; i++) {
                    texte_choix[i] = toutes_marques.get(i);
                }
                valide   = true;
                choix[3] = true;
                haut0    = false;
                compte_choix();
            }
        }        
    }
}
//*********************************************************************************************
class Bouton_Proprietaire extends Bouton {                                                                      //  groupe[35]Boutons[5]
    Bouton_Proprietaire() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Propriétaire";
        titre_choix    = "Filtrer par propriétaire";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (valide) {
            image(gros_vert, _x, _y, _l, _h);
        } else {
            image(gros_bleu, _x, _y, _l, _h);
        }
        textAlign(CENTER, CENTER);
        fill(NOIR);
        text(texte_affiche, _x+_l/2, _y+_h/2F);
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                effacer_choix();
                int prop_size = tous_proprietaires.size();
                for (int i = 0; i < prop_size; i++) {
                    texte_choix[i] = "["+tous_proprietaires.get(i).CV106+"] "+tous_proprietaires.get(i).prop;
                }
                haut0    = false;
                choix[4] = true;
                valide   = true;
                compte_choix();
            }
        }        
    }
}
//*************************************************************************************************************************************** Ajoute/retire décodeur
//*********************************************************************************************
class Ajoute_decodeur extends Bouton {                                                                      //  groupe[55]Boutons[0]
    Ajoute_decodeur() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Ajouter";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {              
                if (vehicule.ID == 0) {
                    texte_information = "le véhicule n° 0 (zéro) est le seul véhicule"
                              +char(10)+"pour lequel on ne peut pas mettre de décodeur";
                    texte_details     = "Validez pour quitter";
                } else {
                    effacer_les_boutons();
                    ajouter_decodeur         = true;
                    gestion.one_shot         = true;
                    gestion.fabricant_choisi = ".";
                    gestion.famille_choisie  = ".";
                    gestion.modele_choisi    = ".";
                    gestion.ligne_fabricant  = -1;
                    gestion.ligne_famille    = -1;
                    gestion.ligne_modele     = -1;
                    //------------------ ajoute la nouvelle ligne de décodeur dans Infos_CV ---------------
                    Infos_CV infos_CV1       = new Infos_CV();
                    infos_CV1.ID_CV          = vehicule.ID;
                    infos_CV1.v_reelle       = 999;
                    infos_CV1.frein          = 1;
                    infos_CV1.elan           = 1;
                    for (int i = 0; i < 5; i++) {
                        infos_CV1.p[i] = 0;
                    }
                    CV106 = vehicule.CV106;
                    for (int i = 0; i < 201; i++) {
                        infos_CV1.CV[i] = -1;
                    }
                    infos_CV1.CV[106] = CV106;
                    toutes_infos_CV.add(infos_CV1);
                    sauve_table_Infos_CV();
                    infos_CV = toutes_infos_CV.get(toutes_infos_CV.size()-1);
                    //--------------- MàJ de la table Vehicules ----------------------
                    vehicule.ID_CV = toutes_infos_CV.size()-1;
                    sauve_table_Vehicules();
                    top = 2;
                }
            }
        }        
    }
}
//*********************************************************************************************
class MaJ_decodeur extends Bouton {                                                                      //  groupe[55]Boutons[1]
    MaJ_decodeur() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Mettre à jour";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                effacer_les_boutons();
                maj_decodeur          = true;
                gestion.one_shot      = true;
                gestion.ligne_modele  = 0;
                if (gestion.one_shot) {
                    gestion.fabricant_choisi = infos_CV.fabricant;
                    gestion.famille_choisie  = gestion.fabricant_choisi+"/"+infos_CV.famille;
                    for (String mod0 : tous_modeles) {
                        int mod = mod0.indexOf("//");
                        if (mod0.substring(0, mod).equals(gestion.famille_choisie)) {
                            for (Decodeur dec0 : tous_decodeurs) {
                                if (dec0 != null && dec0.nom_modele.equals(mod0)) {
                                    gestion.modele_choisi   = gestion.famille_choisie+"//"+infos_CV.modele;
                                    gestion.decodeur_choisi = dec0;
                                }
                            }                        
                        }
                    }
                    for (String mod0 : tous_modeles) {
                        int mod = mod0.indexOf("//");
                        if (mod0.substring(0, mod).equals(gestion.famille_choisie)) {
                            tous_onglets.clear();
                            int nb_onglets = gestion.decodeur_choisi.Onglets.length;
                            for (int i = 0; i < nb_onglets ; i++) {
                                tous_onglets.add(gestion.decodeur_choisi.Onglets[i]);
                            }
                        }
                    }
                    for (Onglet ong0 : tous_onglets) {
                        ong0.maj_curseurs();
                    }
                }
            }
        }        
    }
}
//*********************************************************************************************
class Retirer_decodeur extends Bouton {                                                                      //  groupe[55]Boutons[2]
    Retirer_decodeur() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Retirer";
        texte_confirmation = "Retirer le décodeur efface aussi tous les CV. Confirmez-vous ?";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (OK) {
            //----------- efface la ligne dans Infos_CV -------------
            toutes_infos_CV.remove(vehicule.ID_CV);
            sauve_table_Infos_CV();
            //---------------- met à 0 l'ID_CV dans vehicule ----------
            vehicule.ID_CV = 0;
            sauve_table_Vehicules();
            OK = false;
            confirmation      = false;
            annule            = false;
            groupe_bouton     = -1;
            ordre_bouton      = -1;
            effacer_les_boutons();
            choix_du_vehicule = true;
        } else {
            if (annule) {
                confirmation      = false;
                annule            = false;
                groupe_bouton     = -1;
                ordre_bouton      = -1;
                effacer_les_boutons();
                choix_du_vehicule = true;
            } else {
                if (mouseX > x && mouseX < x+l
                 && mouseY > y && mouseY < y+h) {
                    if (top == 1) {
                        effacer_les_boutons();
                        confirmation  = true;
                        groupe_bouton = 55;                                                                                    //  "groupe_bouton", c'est le groupe dans lequel est le bouton de départ
                        ordre_bouton  = 2;                                                                                    //  "ordre_bouton", c'est l'ordre du bouton de départ dans le groupe de boutrons du départ
                    }
                }
            }
        }
    }
}
//*************************************************************************************************************************************** copier/coller CV
//*********************************************************************************************
class Copier_CV extends Bouton {                                                                      //  groupe[55]Boutons[3]
    Copier_CV() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Copier CV";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                vehicule_copie = vehicule.rang;
                copier_CV      = true;
            }
        }       
    }
}
//*********************************************************************************************
class Coller_CV extends Bouton {                                                                      //  groupe[55]Boutons[4]
    Coller_CV() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Coller CV";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                coller_CV  = true;
            }
        }        
    }
}
//*********************************************************************************************
class Faire_copie extends Bouton {                                                                      //  groupe[1]Boutons[0]
    Faire_copie() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Réaliser la copie effective";
        texte_confirmation = "Les CV existants seront écrasés. Confirmez-vous ?";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        if (infos_CV.fabricant != "n.c.") {
            imageMode(CORNER);
            image(gros_bleu, _x, _y, _l, _h);        
            textAlign(CENTER, CENTER);
            fill(NOIR);
            text(texte_affiche, _x+_l/2, _y+_h/2F);
            x = _x; y = _y; l = _l; h = _h;
        }
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (OK) {
            if (infos_CV.fabricant != "n.c.") {
                for (int i = 1; i < 201; i++) {
                    infos_CV.CV[i] = toutes_infos_CV.get(tous_vehicules_filtres.get(vehicule_copie).ID_CV).CV[i];
                }
                groupe_bouton      = -1;
                ordre_bouton       = -1;
                confirmation       = false;
                OK                 = false;
                effacer_les_boutons();
                choix_du_vehicule  = true;
                sauver_et_sortir   = true;
            }
        } else {
            if (annule) {
                confirmation      = false;
                annule            = false;
                groupe_bouton     = -1;
                ordre_bouton      = -1;
                effacer_les_boutons();
                choix_du_vehicule = true;
            } else {
                if (mouseX > x && mouseX < x+l
                 && mouseY > y && mouseY < y+h) {
                    if (top == 1) {
                        effacer_les_boutons();
                        groupe_bouton = 1;                                                                                    //  "groupe_bouton", c'est le groupe dans lequel est le bouton de départ
                        ordre_bouton  = 0;                                                                                    //  "ordre_bouton", c'est l'ordre du bouton de départ dans le groupe de boutrons du départ
                        confirmation  = true;
                    }
                }
            }
        }
    }
}
//*********************************************************************************************
class Sortir_copie extends Bouton {                                                                      //  groupe[1]Boutons[1]
    Sortir_copie() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Sortir de la copie sans rien faire";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                copier_CV      = false;
                coller_CV      = false;
                choix_vehicule = true;
                vehicule_copie = vehicule.rang;
            }
        }        
    }
}
//**************************************************************************************************************************************** Précédent/suivant composition
//*********************************************************************************************
class Precedent_compo extends Bouton {                                                                      //  groupe[4]Boutons[0]
    Precedent_compo() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        image(bouton_bleu, _x, _y, _l, _h);        
        stroke(NOIR);
        noFill();
        strokeWeight(1.5F);
        rect(_x, _y, 20F, 20F, 2, 2, 2, 2);
        fill(NOIR);
        triangle(_x+15F, _y+5F, _x+15F, _y+15F, _x+5F, _y+10F);
        noStroke();
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                choix_train = max(0, choix_train-1);
                gestion.largeur_curseur[1] = gestion.l0*choix_train/(toutes_compositions.size()-1);
            }
        }
    }
}
//*********************************************************************************************
class Suivant_compo extends Bouton {                                                                      //  groupe[4]Boutons[1]
    Suivant_compo() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        image(bouton_bleu, _x, _y, _l, _h);
        stroke(NOIR);
        noFill();
        strokeWeight(1.5F);
        rect(_x, _y, 20, 20, 2, 2, 2, 2);
        fill(NOIR);
        triangle(_x+5F, _y+5F, _x+5F, _y+15F, _x+15F, _y+10F);
        noStroke();
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        //int identite = vehicule.rang;
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                choix_train = min(toutes_compositions.size()-1, choix_train+1);
                gestion.largeur_curseur[1] = gestion.l0*choix_train/(toutes_compositions.size()-1);
            }
        }
    }
}
//**************************************************************************************************************************************** Valide ajoute retire composition
//*********************************************************************************************
class Valide_compo extends Bouton {
    Valide_compo() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Valide compo";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        image(gros_bleu, _x, _y, _l, _h);
        fill(NOIR);
        textAlign(CENTER, CENTER);
        text(texte_affiche, _x+_l/2F, _y+_h/2F);
        noStroke();
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        //int identite = vehicule.rang;
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                sauve_table_Compositions();
            }
        }
    }
}
//*********************************************************************************************
class Ajoute_compo extends Bouton {
    Ajoute_compo() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Ajoute compo";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        image(gros_bleu, _x, _y, _l, _h);
        fill(NOIR);
        textAlign(CENTER, CENTER);
        text(texte_affiche, _x+_l/2F, _y+_h/2F);
        noStroke();
        x = _x; y = _y; l = _l; h = _h;
    }
    //---------------------------- appui_bouton() -----------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                valide              = true;
                texte_information   = "Entrez le NOM DE LA COMPOSITION A AJOUTER"
                            +char(10)+"au clavier puis VALIDEZ";
                texte_details       = "Nom de la composition :";
                saisie_valide       = false;
            }
        }
        if (valide && saisie_valide) {
            Composition compo0 = new Composition();
            compo0.nom         = texte_saisi;
            toutes_compositions.add(compo0);
            sauve_table_Compositions();
            valide      = false;
            texte_saisi = "";
            choix_train = toutes_compositions.size()-1;
        }
    }
}
//*********************************************************************************************
class Retire_compo extends Bouton {
    Retire_compo() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Retire compo";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        image(gros_bleu, _x, _y, _l, _h);
        fill(NOIR);
        textAlign(CENTER, CENTER);
        text(texte_affiche, _x+_l/2F, _y+_h/2F);
        noStroke();
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                valide              = true;
                texte_avertissement = "Vous allez supprimer cette composition !";
                texte_information   = "Voulez-vous supprimer la composition ?";
                texte_details       = "o/n :";
                saisie_valide       = false;
            }
        }
        if (valide && saisie_valide) {
            if (texte_saisi.equals("o") || texte_saisi.equals("O") || texte_saisi.equals("oui")|| texte_saisi.equals("OUI")) {
                for (int i = (toutes_compositions.size() - 1); i >= 0; i--) {
                    if (choix_train == i) {
                         toutes_compositions.remove(i);
                    }
                }
                sauve_table_Compositions();
                choix_train = 0;
                gestion.largeur_curseur[1] = gestion.l0*choix_train/(tous_vehicules.size()-1);
                choix_du_vehicule = true;
                valide            = false;
                texte_information = null;
                texte_saisi       = "";
            }
            if (texte_saisi.equals("n") || texte_saisi.equals("N")) {
                texte_information = null;
                texte_saisi       = "";
                valide            = false;
            }
        }
    }
}
//******************************************************************************************************************************************* OK/Annule
//*********************************************************************************************
class OK extends Bouton {
    OK() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "  OK  ";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                OK     = true;
                annule = false;
                groupe_confirmation = groupes[groupe_bouton];                                                                 //  groupe_bouton, c'est le groupe dans lequel est le bouton de départ
                groupe_confirmation.Boutons[ordre_bouton].appui_bouton();                                                     //  ordre_bouton, c'est l'ordre du bouton de départ dans le groupe de boutrons du départ
                //--------------- onglet adresse ----------------
                if (groupe.numero_groupe == 6) {
                    infos_CV.CV[29] = CV29;
                }
            }
        }        
    }
}
//*********************************************************************************************
class Annule extends Bouton {
    Annule() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "  Annuler et sortir  ";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                annule = true;
                OK     = false;
                groupe_confirmation = groupes[groupe_bouton];                                                                 //  groupe_bouton, c'est le groupe dans lequel est le bouton de départ
                groupe_confirmation.Boutons[ordre_bouton].appui_bouton();                                                     //  ordre_bouton, c'est l'ordre du bouton de départ dans le groupe de boutrons du départ
            }
        }        
    }
}
//*************************************************************************************************************************************** Infos Base : dimensions
//*********************************************************************************************
class Longueur extends Bouton {
    Longueur() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Longueur du décodeur";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        if (texte_choisi == null) {
            textAlign(LEFT, CENTER);       
            fill(NOIR);
            text("(valeur fabricant)", x-100F, y+1F+h/2F);
            imageMode(CORNER);
            if (valide) {
                image(affiche_vert, x+45F, y+5F, l+20F, h);
            } else {
                image(affiche_bleu, x+45F, y+5F, l+20F, h);
            }
            fill(NOIR);
            textAlign(RIGHT, CENTER);
            if (!texte_saisi_b.equals("") && valide) {
                decodeur.longueur = int(texte_saisi_b);
            }
            valeur_mm(decodeur.longueur);
            text(dixieme_mm+" mm", x0+l0-l/2F+5F, y+1F+h/2F);
        }
    }
    //---------------------------- appui_bouton() -----------------------------------------
    void appui_bouton() {
        if (mouseX > x0 && mouseX < x0+l0
         && mouseY > y  && mouseY < y+h0) {
            if (top == 1) {
                efface_fiche();
                valide              = true;
                texte_avertissement = "Informations de la Base en lecture seule";
                texte_information   = "Faire la proposition de modification"
                            +char(10)+"sur le forum de LOCODUINO fil DECODUINO"+char(10);
                texte_details       = "Validez pour quitter";
            }
        }       
    }
}
//*********************************************************************************************
class Largeur extends Bouton {
    Largeur() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Largeur du décodeur";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        if (texte_choisi == null) {
            textAlign(LEFT, CENTER);       
            fill(NOIR);
            text("(valeur fabricant)", x-100F, y+1F+h/2F);
            imageMode(CORNER);
            if (valide) {
                image(affiche_vert, x+45F, y+5F, l+20F, h);
            } else {
                image(affiche_bleu, x+45F, y+5F, l+20F, h);
            }
            fill(NOIR);
            textAlign(RIGHT, CENTER);
            if (!texte_saisi_b.equals("") && valide) {
                decodeur.largeur = int(texte_saisi_b);
            }
            valeur_mm(decodeur.largeur);
            text(dixieme_mm+" mm", x0+l0-l/2F+5F, y+1F+h/2F);
        }
    }
    //---------------------------- appui_bouton() -----------------------------------------
    void appui_bouton() {
        if (mouseX > x0 && mouseX < x0+l0
         && mouseY > y  && mouseY < y+h0) {
            if (top == 1) {
                efface_fiche();
                valide              = true;
                texte_avertissement = "Informations de la Base en lecture seule";
                texte_information   = "Faire la proposition de modification"
                            +char(10)+"sur le forum de LOCODUINO fil DECODUINO"+char(10);
                texte_details       = "Validez pour quitter";
            }
        }       
    }
}
//*********************************************************************************************
class Hauteur extends Bouton {
    Hauteur() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Hauteur du décodeur";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        if (texte_choisi == null) {
            textAlign(LEFT, CENTER);       
            fill(NOIR);
            text("(valeur fabricant)", x-100F, y+1F+h/2F);
            imageMode(CORNER);
            if (valide) {
                image(affiche_vert, x+45F, y+5F, l+20F, h);
            } else {
                image(affiche_bleu, x+45F, y+5F, l+20F, h);
            }
            fill(NOIR);
            textAlign(RIGHT, CENTER);
            if (!texte_saisi_b.equals("") && valide) {
                decodeur.hauteur = int(texte_saisi_b);
            }
            valeur_mm(decodeur.hauteur);
            text(dixieme_mm+" mm", x0+l0-l/2F+5F, y+1F+h/2F);
        }
    }
    //---------------------------- appui_bouton() -----------------------------------------
    void appui_bouton() {
        if (mouseX > x0 && mouseX < x0+l0
         && mouseY > y  && mouseY < y+h0) {
            if (top == 1) {
                efface_fiche();
                valide              = true;
                texte_avertissement = "Informations de la Base en lecture seule";
                texte_information   = "Faire la proposition de modification"
                            +char(10)+"sur le forum de LOCODUINO fil DECODUINO"+char(10);
                texte_details       = "Validez pour quitter";
            }
        }       
    }
}
//***************************************************************************************************************************************** Infos Base : Courants
//*********************************************************************************************
class Courant_moteur_max extends Bouton {
    Courant_moteur_max() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Courant moteur maximal";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        if (texte_choisi == null) {
            imageMode(CORNER);
            if (valide) {
                image(affiche_vert, x+35F, y+5F, l+30F, h);
            } else {
                image(affiche_bleu, x+35F, y+5F, l+30F, h);
            }
            fill(NOIR);
            textAlign(RIGHT, CENTER);
            if (!texte_saisi_b.equals("") && valide) {
                decodeur.courant_moteur_max = int(texte_saisi_b);
            }
            if (decodeur.courant_moteur_max > 999) {
                text(str(decodeur.courant_moteur_max/1000F)+" A", x0+l0-15F, y+1F+h/2F);
            } else {
                if (decodeur.courant_moteur_max == 0) {
                    text("n.c.", x0+l0-15F, y+1F+h/2F);
                } else {
                    text(str(decodeur.courant_moteur_max)+" mA", x0+l0-15F, y+1F+h/2F);
                }
            }
        }
    }
    //---------------------------- appui_bouton() -----------------------------------------
    void appui_bouton() {
        if (mouseX > x0 && mouseX < x0+l0
         && mouseY > y  && mouseY < y+h0) {
            if (top == 1) {
                efface_fiche();
                valide              = true;
                texte_avertissement = "Informations de la Base en lecture seule";
                texte_information   = "Faire la proposition de modification"
                            +char(10)+"sur le forum de LOCODUINO fil DECODUINO"+char(10);
                texte_details       = "Validez pour quitter";
            }
        }       
    }
}
//*********************************************************************************************
class Courant_pic_moteur extends Bouton {
    Courant_pic_moteur() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Courant pic moteur";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        if (texte_choisi == null) {
            imageMode(CORNER);
            if (valide) {
                image(affiche_vert, x+35F, y+5F, l+30F, h);
            } else {
                image(affiche_bleu, x+35F, y+5F, l+30F, h);
            }
            fill(NOIR);
            textAlign(RIGHT, CENTER);
            if (!texte_saisi_b.equals("") && valide) {
                decodeur.courant_pic_moteur = int(texte_saisi_b);
            }
            if (decodeur.courant_pic_moteur > 999) {
                text(str(decodeur.courant_pic_moteur/1000F)+" A", x0+l0-15F, y+1F+h/2F);
            } else {
                if (decodeur.courant_pic_moteur == 0) {
                    text("n.c.", x0+l0-15F, y+1F+h/2F);
                } else {
                    text(str(decodeur.courant_pic_moteur)+" mA", x0+l0-15F, y+1F+h/2F);
                }                
            }
        }
    }
    //---------------------------- appui_bouton() -----------------------------------------
    void appui_bouton() {
        if (mouseX > x0 && mouseX < x0+l0
         && mouseY > y  && mouseY < y+h0) {
            if (top == 1) {
                efface_fiche();
                valide              = true;
                texte_avertissement = "Informations de la Base en lecture seule";
                texte_information   = "Faire la proposition de modification"
                            +char(10)+"sur le forum de LOCODUINO fil DECODUINO"+char(10);
                texte_details       = "Validez pour quitter";
            }
        }       
    }
}
//*********************************************************************************************
class Duree_pic_moteur extends Bouton {
    Duree_pic_moteur() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Durée pic moteur";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        if (texte_choisi == null) {
            imageMode(CORNER);
            if (valide) {
                image(affiche_vert, x+35F, y+5F, l+30F, h);
            } else {
                image(affiche_bleu, x+35F, y+5F, l+30F, h);
            }
            fill(NOIR);
            textAlign(RIGHT, CENTER);
            if (!texte_saisi_b.equals("") && valide) {
                decodeur.duree_pic_moteur = int(texte_saisi_b);
            }
            if (decodeur.duree_pic_moteur == 0) {
                text("n.c.", x0+l0-15F, y+1F+h/2F);
            } else {
                text(str(decodeur.duree_pic_moteur)+"sec", x0+l0-15F, y+1F+h/2F);
            }                                            
        }
    }
    //---------------------------- appui_bouton() -----------------------------------------
    void appui_bouton() {
        if (mouseX > x0 && mouseX < x0+l0
         && mouseY > y  && mouseY < y+h0) {
            if (top == 1) {
                efface_fiche();
                valide              = true;
                texte_avertissement = "Informations de la Base en lecture seule";
                texte_information   = "Faire la proposition de modification"
                            +char(10)+"sur le forum de LOCODUINO fil DECODUINO"+char(10);
                texte_details       = "Validez pour quitter";
            }
        }       
    }
}
//*********************************************************************************************
class Courant_total_max extends Bouton {
    Courant_total_max() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Courant total maximal";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        if (texte_choisi == null) {
            imageMode(CORNER);
            if (valide) {
                image(affiche_vert, x+35F, y+5F, l+30F, h);
            } else {
                image(affiche_bleu, x+35F, y+5F, l+30F, h);
            }
            fill(NOIR);
            textAlign(RIGHT, CENTER);
            if (!texte_saisi_b.equals("") && valide) {
                decodeur.courant_total_max = int(texte_saisi_b);
            }
            if (decodeur.courant_total_max > 999) {
                text(str(decodeur.courant_total_max/1000F)+" A", x0+l0-15F, y+1F+h/2F);
            } else {
                if (decodeur.courant_total_max == 0) {
                    text("n.c.", x0+l0-15F, y+1F+h/2F);
                } else {
                    text(str(decodeur.courant_total_max)+" mA", x0+l0-15F, y+1F+h/2F);
                }                                
            }
        }
    }
    //---------------------------- appui_bouton() -----------------------------------------
    void appui_bouton() {
        if (mouseX > x0 && mouseX < x0+l0
         && mouseY > y  && mouseY < y+h0) {
            if (top == 1) {
                efface_fiche();
                valide              = true;
                texte_avertissement = "Informations de la Base en lecture seule";
                texte_information   = "Faire la proposition de modification"
                            +char(10)+"sur le forum de LOCODUINO fil DECODUINO"+char(10);
                texte_details       = "Validez pour quitter";
            }
        }       
    }
}
//*********************************************************************************************
class Courant_pic_total extends Bouton {
    Courant_pic_total() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Courant pic total";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        if (texte_choisi == null) {
            imageMode(CORNER);
            if (valide) {
                image(affiche_vert, x+35F, y+5F, l+30F, h);
            } else {
                image(affiche_bleu, x+35F, y+5F, l+30F, h);
            }
            fill(NOIR);
            textAlign(RIGHT, CENTER);
            if (!texte_saisi_b.equals("") && valide) {
                decodeur.courant_pic_total = int(texte_saisi_b);
            }
            if (decodeur.courant_pic_total > 999) {
                text(str(decodeur.courant_pic_total/1000F)+" A", x0+l0-15F, y+1F+h/2F);
            } else {
                if (decodeur.courant_pic_total == 0) {
                    text("n.c.", x0+l0-15F, y+1F+h/2F);
                } else {
                    text(str(decodeur.courant_pic_total)+" mA", x0+l0-15F, y+1F+h/2F);
                }                                                
            }
        }
    }
    //---------------------------- appui_bouton() -----------------------------------------
    void appui_bouton() {
        if (mouseX > x0 && mouseX < x0+l0
         && mouseY > y  && mouseY < y+h0) {
            if (top == 1) {
                efface_fiche();
                valide              = true;
                texte_avertissement = "Informations de la Base en lecture seule";
                texte_information   = "Faire la proposition de modification"
                            +char(10)+"sur le forum de LOCODUINO fil DECODUINO"+char(10);
                texte_details       = "Validez pour quitter";
            }
        }       
    }
}
//*********************************************************************************************
class Connecteur extends Bouton {
    Connecteur() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Connecteur";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        if (valide) {
            image(affiche_vert, x+35F, y+5F, l+30F, h);
        } else {
            image(affiche_bleu, x+35F, y+5F, l+30F, h);
        }
        fill(NOIR);
        textAlign(RIGHT, CENTER);
        if (!texte_saisi_b.equals("") && valide) {
            if (texte_saisi_b == null) {
                decodeur.connecteur = null;
            } else {
                decodeur.connecteur = texte_saisi_b;
            }
        }
        if (decodeur.connecteur == null) {
            text("n.c.", x0+l0-15F, y+1F+h/2F);
        } else {
            text(decodeur.connecteur, x0+l0-15F, y+1F+h/2F);
        }
    }
    //---------------------------- appui_bouton() -----------------------------------------
    void appui_bouton() {
        if (mouseX > x0 && mouseX < x0+l0
         && mouseY > y  && mouseY < y+h0) {
            if (top == 1) {
                efface_fiche();
                valide              = true;
                texte_avertissement = "Informations de la Base en lecture seule";
                texte_information   = "Faire la proposition de modification"
                            +char(10)+"sur le forum de LOCODUINO fil DECODUINO"+char(10);
                texte_details       = "Validez pour quitter";
            }
        }       
    }
}
//***************************************************************************************************************************************** Infos véhicule : nom, image, couleur
//*********************************************************************************************
class Nom extends Bouton {
    Nom() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche      = "Nom du véhicule";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        if (valide) {
            image(affiche_vert, x-100F, y+5F, l+100F, h);
        } else {
            image(affiche_bleu, x-100F, y+5F, l+100F, h);
        }
        fill(NOIR);
        textAlign(RIGHT, CENTER);
        if (!texte_saisi_b.equals("") && valide) {
            if (texte_saisi_b == null) {
                vehicule.nom = null;
            } else {
                vehicule.nom = texte_saisi_b;
            }
        }
        if (vehicule.nom == null) {
            text("n.c.", x0+l0-15F, y+1F+h/2F);
        } else {
            text(vehicule.nom, x0+l0-15F, y+1F+h/2F);
        }
    }
    //---------------------------- appui_bouton() -----------------------------------------
    void appui_bouton() {
        if (mouseX > x0 && mouseX < x0+l0
         && mouseY > y  && mouseY < y+h0) {
            if (top == 1) {
                efface_fiche();
                valide              = true;
                texte_information   = "Entrez le NOM du véhicule au clavier puis VALIDEZ";
                texte_details       = "Nom du véhicule :";
                NC                  = true;
            }
        }       
    }
}
//*********************************************************************************************
class Image extends Bouton {
    Image() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche      = "Image du véhicule";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        if (valide) {
            image(affiche_vert, x-100F, y+5F, l+100F, h);
        } else {
            image(affiche_bleu, x-100F, y+5F, l+100F, h);
        }
        fill(NOIR);
        textAlign(RIGHT, CENTER);
        if (saisie_valide) {
            if (!texte_saisi_b.equals("")) {
                trouve = false;
                for (String img0 : filenames) {
                    if (img0.equals(texte_saisi_b+".png")) {
                        trouve = true;
                        break;
                    }
                }
                if (trouve) {
                    vehicule.image_t = texte_saisi_b+".png";
                    vehicule.image_cote = loadImage(Repertoire_Communs+"Vehicules/"+texte_saisi_b+".png");
                    //-------------- insertion du véhicule ----------
                    gestion.dessine_rectangle_creux(vehicule.couleur, 20F, 640F, 300F, 90F);
                    imageMode(CENTER);
                    image(vehicule.image_cote, 20F+300F/2F, 630F+100F/2F, vehicule.image_cote.width/4F, vehicule.image_cote.height/4F);
                    imageMode(CORNER);
                } else {
                    texte_information = "CE NOM DE FICHIER N'EXISTE PAS !"
                              +char(10)+"Entrez un NOM DE FICHIER IMAGE qui existe (ou créez le fichier)";
                }
            }
        }
        if (vehicule.image_t.equals("nc.png")) {
            text("nc.png", x0+l0-15F, y+1F+h/2F);
        } else {
            text(vehicule.image_t, x0+l0-15F, y+1F+h/2F);
        }
    }
    //---------------------------- appui_bouton() -----------------------------------------
    void appui_bouton() {
        if (mouseX > x0 && mouseX < x0+l0
         && mouseY > y  && mouseY < y+h0) {
            if (top == 1) {
                efface_fiche();
                valide              = true;
                texte_information   = "Entrez le NOM DU FICHIER IMAGE du véhicule"
                            +char(10)+"au clavier (sans le '.png') puis VALIDEZ";
                texte_details       = "Nom du fichier image :";
                NC                  = true;
            }
        }       
    }
}
//*********************************************************************************************
class Couleur extends Bouton {
    Couleur() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche      = "Couleur de fond en composition";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        if (valide) {
            image(affiche_vert, x+50F, y+5F, l-50F, h);
        } else {
            image(affiche_bleu, x+50F, y+5F, l-50F, h);
        }
        fill(NOIR);
        textAlign(RIGHT, CENTER);
        if (saisie_valide) {
            if (!texte_saisi_b.equals("")) {
                if (texte_saisi_b.equals("nc") || texte_saisi_b.equals("n.c.")) {
                    vehicule.couleur = 0;
                } else {
                    vehicule.couleur = unhex("FF"+texte_saisi_b);
                    //-------------- insertion du véhicule ----------
                    gestion.dessine_rectangle_creux(vehicule.couleur, 20F, 640F, 300F, 90F);
                    imageMode(CENTER);
                    image(vehicule.image_cote, 20F+300F/2F, 630F+100F/2F, vehicule.image_cote.width/4F, vehicule.image_cote.height/4F);
                    imageMode(CORNER);
                }
            }
        }
        if (vehicule.couleur == 0) {
            text("n.c.", x0+l0-15F, y+1F+h/2F);
        } else {
            text("#"+hex(color(vehicule.couleur)).substring(2), x0+l0-15F, y+1F+h/2F);
        }
    }
    //---------------------------- appui_bouton() -----------------------------------------
    void appui_bouton() {
        if (mouseX > x0 && mouseX < x0+l0
         && mouseY > y  && mouseY < y+h0) {
            if (top == 1) {
                efface_fiche();
                valide              = true;
                texte_information   = "Entrez le CODE DE LA COULEUR DU FOND"
                            +char(10)+"du véhicule au clavier puis VALIDEZ";
                texte_details       = "Code couleur (sans le '#') :";
                NC                  = false;
            }
        }       
    }
}
//*********************************************************************************************
class Vehicule_moteur extends Bouton {
    Vehicule_moteur() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche      = "Est-ce un véhicule moteur ?";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        if (valide) {
            image(affiche_vert, x+50F, y+5F, l-50F, h);
        } else {
            image(affiche_bleu, x+50F, y+5F, l-50F, h);
        }
        fill(NOIR);
        textAlign(RIGHT, CENTER);
        if (saisie_valide) {
            if (!texte_saisi_b.equals("")) {
                if (texte_saisi_b.equals("nc") || texte_saisi_b.equals("n.c.")) {
                    vehicule.moteur = false;
                } else {
                    if (texte_saisi_b.equals("o") || texte_saisi_b.equals("O") || texte_saisi_b.equals("oui")|| texte_saisi_b.equals("OUI")) {
                        vehicule.moteur = true;
                    } else {
                        vehicule.moteur = false;
                    }
                }
            }
        }
        if (vehicule.moteur) {
            text("Oui", x0+l0-15F, y+1F+h/2F);
        } else {
            text("Non", x0+l0-15F, y+1F+h/2F);
        }
    }
    //---------------------------- appui_bouton() -----------------------------------------
    void appui_bouton() {
        if (mouseX > x0 && mouseX < x0+l0
         && mouseY > y  && mouseY < y+h0) {
            if (top == 1) {
                efface_fiche();
                valide              = true;
                texte_information   = "Le véhicule est-il moteur ?";
                texte_details       = "Entrez o/n :";
                NC                  = false;
            }
        }       
    }
}
//***************************************************************************************************************************************** Infos véhicule : marque, référence, échelle
//*********************************************************************************************
class Vehicule_marque extends Bouton {
    Vehicule_marque() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche      = "Marque du véhicule";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        if (valide) {
            image(affiche_vert, x-100F, y+5F, l+75F, h);
        } else {
            image(affiche_bleu, x-100F, y+5F, l+75F, h);
        }
        fill(NOIR);
        textAlign(RIGHT, CENTER);
        if (saisie_valide) {
            if (!texte_saisi_b.equals("")) {
                if (texte_saisi_b.equals("nc") || texte_saisi_b.equals("n.c.")) {
                    vehicule.marque = "n.c.";
                } else {
                    vehicule.marque = texte_saisi_b.substring(0, 1).toUpperCase()+texte_saisi_b.substring(1);
                }
            }
        }
        text(vehicule.marque, x0+l0-15F, y+1F+h/2F);         
    }
    //---------------------------- appui_bouton() -----------------------------------------
    void appui_bouton() {
        if (mouseX > x0 && mouseX < x0+l0
         && mouseY > y  && mouseY < y+h0) {
            if (top == 1) {
                efface_fiche();
                valide              = true;
                texte_information   = "Entrez la MARQUE du véhicule au clavier puis VALIDEZ";
                texte_details       = "Marque du véhicule :";
                NC                  = true;
            }
        }       
    }
}
//*********************************************************************************************
class Vehicule_ref extends Bouton {
    Vehicule_ref() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche      = "Référence du véhicule";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        if (valide) {
            image(affiche_vert, x-100F, y+5F, l+75F, h);
        } else {
            image(affiche_bleu, x-100F, y+5F, l+75F, h);
        }
        fill(NOIR);
        textAlign(RIGHT, CENTER);
        if (saisie_valide) {
            if (!texte_saisi_b.equals("")) {
                if (texte_saisi_b.equals("nc") || texte_saisi_b.equals("n.c.")) {
                    vehicule.ref = "n.c.";
                } else {
                    vehicule.ref = texte_saisi_b.substring(0, 1).toUpperCase()+texte_saisi_b.substring(1);
                }
            }
        }
        text(vehicule.ref, x0+l0-15F, y+1F+h/2F);         
    }
    //---------------------------- appui_bouton() -----------------------------------------
    void appui_bouton() {
        if (mouseX > x0 && mouseX < x0+l0
         && mouseY > y  && mouseY < y+h0) {
            if (top == 1) {
                efface_fiche();
                valide              = true;
                texte_information   = "Entrez la REFERENCE du véhicule au clavier puis VALIDEZ";
                texte_details       = "Référence du véhicule :";
                NC                  = true;
            }
        }       
    }
}
//*********************************************************************************************
class Vehicule_echelle extends Bouton {
    Vehicule_echelle() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche      = "Echelle";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        if (valide) {
            image(affiche_vert, x+60F, y+5F, l-85F, h);
        } else {
            image(affiche_bleu, x+60F, y+5F, l-85F, h);
        }
        fill(NOIR);
        textAlign(RIGHT, CENTER);
        if (saisie_valide) {
            if (!texte_saisi_b.equals("")) {
                if (texte_saisi_b.equals("nc") || texte_saisi_b.equals("n.c.")) {
                    vehicule.echelle = "n.c.";
                } else {
                    if (texte_saisi_b.length() == 1) {
                        vehicule.echelle = texte_saisi_b.toUpperCase();                    
                    } else {
                        if (texte_saisi_b.length() == 2) {
                            vehicule.echelle = texte_saisi_b.toUpperCase();
                        } else {
                            vehicule.echelle = texte_saisi_b.substring(0,2).toUpperCase()+texte_saisi_b.substring(2).toLowerCase();
                        }
                    }
                }
            }
        }
        text(vehicule.echelle, x0+l0-15F, y+1F+h/2F);         
    }
    //---------------------------- appui_bouton() -----------------------------------------
    void appui_bouton() {
        if (mouseX > x0 && mouseX < x0+l0
         && mouseY > y  && mouseY < y+h0) {
            if (top == 1) {
                efface_fiche();
                valide              = true;
                texte_information   = "Entrez le NOM DE L'ECHELLE du véhicule au clavier puis VALIDEZ";
                texte_details       = "Echelle :";
                NC                  = false;
            }
        }       
    }
}
//*********************************************************************************************
class Hors_tampon extends Bouton {
    Hors_tampon() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche      = "Longueur hors-tampons du modèle réduit";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        if (valide) {
            image(affiche_vert, x+50F, y+5F, l-75F, h);
        } else {
            image(affiche_bleu, x+50F, y+5F, l-75F, h);
        }
        fill(NOIR);
        textAlign(RIGHT, CENTER);
        if (saisie_valide) {
            if (!texte_saisi_b.equals("")) {
                if (texte_saisi_b.equals("nc") || texte_saisi_b.equals("n.c.")) {
                    vehicule.htamp = 0;
                } else {
                    vehicule.htamp = int(texte_saisi_b);
                }
            }
        }
        text(vehicule.htamp+" mm", x0+l0-15F, y+1F+h/2F);
    }
    //---------------------------- appui_bouton() -----------------------------------------
    void appui_bouton() {
        if (mouseX > x0 && mouseX < x0+l0
         && mouseY > y  && mouseY < y+h0) {
            if (top == 1) {
                efface_fiche();
                valide              = true;
                texte_information   = "Entrez la LONGUEUR HORS TAMPON du modèle réduit"
                            +char(10)+"au clavier puis VALIDEZ";
                texte_details       = "Valeur en mm :";
                NC                  = true;
            }
        }       
    }
}
//***************************************************************************************************************************************** Infos véhicule : vitesses
//*********************************************************************************************
class Vitesse_reelle extends Bouton {
    Vitesse_reelle() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Vitesse maximale de la vraie loco";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        if (valide) {
            image(affiche_vert, x+35F, y+5F, l+30F, h);
        } else {
            image(affiche_bleu, x+35F, y+5F, l+30F, h);
        }
        fill(NOIR);
        textAlign(RIGHT, CENTER);
        if (saisie_valide) {
            if (!texte_saisi_b.equals("")) {
                if (texte_saisi_b.equals("nc") || texte_saisi_b.equals("n.c.")) {
                    infos_CV.v_reelle = 0;
                } else {
                    infos_CV.v_reelle = int(texte_saisi_b);
                }
            }
        }
        text(infos_CV.v_reelle+" km/h", x0+l0-15F, y+1F+h/2F);
    }
    //---------------------------- appui_bouton() -----------------------------------------
    void appui_bouton() {
        if (mouseX > x0 && mouseX < x0+l0
         && mouseY > y  && mouseY < y+h0) {
            if (top == 1) {
                efface_fiche();
                valide              = true;
                texte_information   = "Entrez la VITESSE MAXI du modèle réel au clavier puis VALIDEZ";
                texte_details       = "Valeur en km/h :";
                NC                  = true;
            }
        }       
    }
}
//*********************************************************************************************
class Frein extends Bouton {
    Frein() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Coefficient correctif de freinage";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        if (valide) {
            image(affiche_vert, x, y+5F, l+65F, h);
        } else {
            image(affiche_bleu, x, y+5F, l+65F, h);
        }
        fill(NOIR);
        textAlign(RIGHT, CENTER);
        if (saisie_valide) {
            if (!texte_saisi_b.equals("")) {
                if (texte_saisi_b.equals("nc") || texte_saisi_b.equals("n.c.")) {
                    infos_CV.frein = 1;
                } else {
                    infos_CV.frein = float(texte_saisi_b);
                }
            }
        }
        text(str(infos_CV.frein), x0+l0-15F, y+1F+h/2F);
    }
    //---------------------------- appui_bouton() -----------------------------------------
    void appui_bouton() {
        if (mouseX > x0 && mouseX < x0+l0
         && mouseY > y  && mouseY < y+h0) {
            if (top == 1) {
                efface_fiche();
                valide              = true;
                texte_information   = "Entrez le COEFFICIENT DE FREINAGE au clavier puis VALIDEZ";
                texte_details       = "Valeur <= 1 :";
                NC                  = true;
            }
        }       
    }
}
//*********************************************************************************************
class Elan extends Bouton {
    Elan() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Coefficient correctif d'élan";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        if (valide) {
            image(affiche_vert, x, y+5F, l+65F, h);
        } else {
            image(affiche_bleu, x, y+5F, l+65F, h);
        }
        fill(NOIR);
        textAlign(RIGHT, CENTER);
        if (saisie_valide) {
            if (!texte_saisi_b.equals("")) {
                if (texte_saisi_b.equals("nc") || texte_saisi_b.equals("n.c.")) {
                    infos_CV.elan = 1;
                } else {
                    infos_CV.elan = float(texte_saisi_b);
                }
            }
        }
        text(str(infos_CV.elan), x0+l0-15F, y+1F+h/2F);
    }
    //---------------------------- appui_bouton() -----------------------------------------
    void appui_bouton() {
        if (mouseX > x0 && mouseX < x0+l0
         && mouseY > y  && mouseY < y+h0) {
            if (top == 1) {
                efface_fiche();
                valide              = true;
                texte_information   = "Entrez le COEFFICIENT D'ELAN au clavier puis VALIDEZ";
                texte_details       = "Valeur <= 1 :";
                NC                  = true;
            }
        }       
    }
}
//***************************************************************************************************************************************** Infos DCC : propriétaire, fabricant, version
//*********************************************************************************************
class Num_proprietaire extends Bouton {                                                        //  groupe[5]Bouton[20]
    boolean premiere_question = true;
    String  nom_proprietaire  = "n.c.";
    int     CV106             = 0;
    Num_proprietaire() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Numéro du propriétaire";
        titre_choix   = "Choisir propriétaire";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        fill(NOIR);
        text("(valeur entrée dans le CV106)", x-120F, y+20F);
        imageMode(CORNER);
        if (valide) {
            image(affiche_vert, x+130F, y+5F, l, h);
        } else {
            image(affiche_bleu, x+130F, y+5F, l, h);
        }
        fill(NOIR);
        textAlign(CENTER, CENTER);
        text(str(vehicule.CV106), x0+l0-l/2F-10F, y+1F+h/2F);        
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x0 && mouseX < x0+l0
         && mouseY > y  && mouseY < y+h0) {
            if (top == 1) {
                effacer_choix();
                int prop_size = tous_proprietaires.size();
                for (int i = 0; i < prop_size; i++) {
                    texte_choix[i] = "["+tous_proprietaires.get(i).CV106+"] "+tous_proprietaires.get(i).prop;
                }
                compte_choix();
                valide               = true;
                texte_choisi         = null;
                saisie_valide        = false;
                saut                 = true;
                top                  = 2;
            }
        }        
    }
}
//*********************************************************************************************
class Nom_proprietaire extends Bouton {                                                        //  groupe[5]Bouton[21]
    String  nom_proprietaire  = "n.c.";
    Nom_proprietaire() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Nom du propriétaire";
        titre_choix   = "Choisir propriétaire";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        if (valide) {
            image(affiche_vert, x+130F, y+5F, l, h);
        } else {
            image(affiche_bleu, x+130F, y+5F, l, h);
        }
        nom_proprietaire = "n.c.";
        for (Proprietaire prop0 : tous_proprietaires) {
            if (vehicule.CV106 == prop0.CV106) {
                nom_proprietaire = prop0.prop;
                break;
            }
        }
        fill(NOIR);
        textAlign(CENTER, CENTER);
        text(nom_proprietaire, x0+l0-l/2F-10F, y+1F+h/2F);
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x0 && mouseX < x0+l0 
         && mouseY > y  && mouseY < y+h0) {
            if (top == 1) {
                effacer_choix();
                int prop_size = tous_proprietaires.size();
                for (int i = 0; i < prop_size; i++) {
                    texte_choix[i] = "["+tous_proprietaires.get(i).CV106+"] "+tous_proprietaires.get(i).prop;
                }
                compte_choix();
                texte_choisi         = null;
                valide               = true;
                saisie_valide        = false;
                saut                 = true;
                top                  = 2;
            }
        }        
    }
}
//*********************************************************************************************
class Numero_fabricant extends Bouton {                                                        //  groupe[5]Bouton[22]
    Numero_fabricant() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Numéro du fabricant du décodeur";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        if (texte_choisi == null) {
            textAlign(LEFT, CENTER);       
            fill(NOIR);
            text("(valeur NMRA dans le CV8)", x-120F, y+1F+h/2F);
            imageMode(CORNER);
            if (valide) {
                image(affiche_vert, x+120F, y+5F, l, h);
            } else {
                image(affiche_bleu, x+120F, y+5F, l, h);
            }
            fill(NOIR);
            textAlign(CENTER, CENTER);
            text(str(decodeur.NMRA), x0+l0-l/2F-10F, y+1F+h/2F);
        }
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x0 && mouseX < x0+l0
         && mouseY > y  && mouseY < y+h0) {
            if (top == 1) {
                efface_fiche();
                valide              = true;
                texte_information   = "Valeur en lecture seule";
                texte_details       = "Validez pour quitter";
            }
        }
    }
}
//*********************************************************************************************
class Numero_version extends Bouton {                                                        //  groupe[5]Bouton[23]
    Numero_version() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Numéro de version du décodeur";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        if (texte_choisi == null) {
            textAlign(LEFT, CENTER);       
            fill(NOIR);
            text("(valeur fabricant dans le CV7)", x-120F, y+1F+h/2F);
            imageMode(CORNER);
            if (valide) {
                image(affiche_vert, x+120F, y+5F, l, h);
            } else {
                image(affiche_bleu, x+120F, y+5F, l, h);
            }
            fill(NOIR);
            textAlign(CENTER, CENTER);
            decodeur.numero_version = infos_CV.CV[7];
            text(str(decodeur.numero_version), x0+l0-l/2F-10F, y+1F+h/2F);
        }
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x0 && mouseX < x0+l0
         && mouseY > y  && mouseY < y+h0) {
            if (top == 1) {
                efface_fiche();
                valide              = true;
                texte_information   = "Valeur en lecture seule";
                texte_details       = "Validez pour quitter";
            }
        }       
    }
}
//************************************************************************************************************************************** Boutons gestion Proprietaires
//*********************************************************************************************
class Ajoute_proprietaire extends Bouton {                                                        //  groupe[5]Bouton[24]
    Ajoute_proprietaire() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Ajoute prop";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (valide) {
            image(gros_vert, _x, _y, _l, _h);
        } else {
            image(gros_bleu, _x, _y, _l, _h);
        }
        textAlign(CENTER, CENTER);
        fill(NOIR);
        text(texte_affiche, _x+_l/2, _y+_h/2F);
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                valide        = true;
                saisie_valide = false;
                saut          = true;
                top    = 2;
            }
        }        
    }
}
//*********************************************************************************************
class Retire_proprietaire extends Bouton {                                                        //  groupe[5]Bouton[25]
    Retire_proprietaire() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Retire prop";
        titre_choix   = "Choisir propriétaire";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (valide) {
            image(gros_vert, _x, _y, _l, _h);
        } else {
            image(gros_bleu, _x, _y, _l, _h);
        }
        textAlign(CENTER, CENTER);
        fill(NOIR);
        text(texte_affiche, _x+_l/2, _y+_h/2F);
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                effacer_choix();
                int prop_size = tous_proprietaires.size();
                for (int i = 0; i < prop_size; i++) {
                    texte_choix[i] = "["+tous_proprietaires.get(i).CV106+"] "+tous_proprietaires.get(i).prop;
                }
                compte_choix();
                valide        = true;
                saisie_valide = false;
                saut          = true;
                top                  = 2;
            }
        }        
    }
}
//*********************************************************************************************
class Modif_nom extends Bouton {                                                        //  groupe[5]Bouton[26]
    Modif_nom() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Modif nom";
        titre_choix   = "Choisir propriétaire";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (valide) {
            image(gros_vert, _x, _y, _l, _h);
        } else {
            image(gros_bleu, _x, _y, _l, _h);
        }
        textAlign(CENTER, CENTER);
        fill(NOIR);
        text(texte_affiche, _x+_l/2, _y+_h/2F);
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                effacer_choix();
                int prop_size = tous_proprietaires.size();
                for (int i = 0; i < prop_size; i++) {
                    texte_choix[i] = "["+tous_proprietaires.get(i).CV106+"] "+tous_proprietaires.get(i).prop;
                }
                compte_choix();
                texte_choisi  = null;
                trouve        = false;
                valide        = true;
                saisie_valide = false;
                saut          = true;
                top                  = 2;
            }
        }        
    }
}
//*********************************************************************************************
class Modif_numero extends Bouton {                                                        //  groupe[5]Bouton[27]
    Modif_numero() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Modif n°";
        titre_choix   = "Choisir propriétaire";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (valide) {
            image(gros_vert, _x, _y, _l, _h);
        } else {
            image(gros_bleu, _x, _y, _l, _h);
        }
        textAlign(CENTER, CENTER);
        fill(NOIR);
        text(texte_affiche, _x+_l/2, _y+_h/2F);
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                effacer_choix();
                int prop_size = tous_proprietaires.size();
                for (int i = 0; i < prop_size; i++) {
                    texte_choix[i] = "["+tous_proprietaires.get(i).CV106+"] "+tous_proprietaires.get(i).prop;
                }
                compte_choix();
                texte_choisi  = null;
                trouve        = false;
                valide        = true;
                saisie_valide = false;
                saut          = true;
                top                  = 2;
            }
        }        
    }
}
//*********************************************************************************************
class Affiche extends Bouton {                                                        //  groupe[5]Bouton[28]
    Affiche() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Affiche/Efface";
        titre_choix   = "Choisir propriétaire";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (valide) {
            image(gros_vert, _x, _y, _l, _h);
        } else {
            image(gros_bleu, _x, _y, _l, _h);
        }
        textAlign(CENTER, CENTER);
        fill(NOIR);
        text(texte_affiche, _x+_l/2, _y+_h/2F);
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x  && mouseX < x+l
         && mouseY > y  && mouseY < y+h) {
            if (top == 1) {
                effacer_choix();
                int prop_size = tous_proprietaires.size();
                for (int i = 0; i < prop_size; i++) {
                    texte_choix[i] = "["+tous_proprietaires.get(i).CV106+"] "+tous_proprietaires.get(i).prop;
                }
                compte_choix();
                affiche_proprietaire = true;
                valide               = !valide;
                saut                 = true;
                top                  = 2;
            }
        }        
    }
}
//************************************************************************************************************************************** Boutons valeurs usine, Master reset
//*********************************************************************************************
class Valeurs_usine extends Bouton {
    Valeurs_usine() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Retour des CV aux valeurs usine";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (valeurs_usine) {
            image(gros_vert, _x, _y, _l, _h);
        } else {
            image(gros_bleu, _x, _y, _l, _h);
        }
        textAlign(CENTER, CENTER);
        fill(NOIR);        
        text(texte_affiche, _x+_l/2, _y+_h/2F);
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                valeurs_usine = true;
            } else {
                String texte_info =  "Si des mises à jour récentes"
                           +char(10)+"étaient cause de dysfonctionnements,"
                           +char(10)+"le retour des principaux CV"
                           +char(10)+"aux valeurs usine PEUT permettre"
                           +char(10)+"de retrouver le fonctionnement"
                           +char(10)+"nominal de la loco."
                  +char(10)+char(10)+"Il s'agit ICI d'un RESET 'LIGHT'."
                           +char(10)+"On recopie simplement les valeurs usine de ce décodeur.";
                gestion.dessine_rectangle_bosse((width-500)/2F, (height-300F)/2F, 500F, 300F);
                textFont(Courier14);
                textAlign(CENTER, CENTER);
                text(texte_info, width/2F, height/2F);              
            }
        }       
    }
    //--------------------------- valeurs_usine() --------------------------------------
    void valeurs_usine() {
        CV106 = infos_CV.CV[106];                                        //  on sauve le CV106
        for (int i = 1; i < 8; i++) {
            infos_CV.CV[i] = -1;
        }
        //----------- on évite les CV7 et CV8 ---
        for (int i = 9; i < 105; i++) {
            infos_CV.CV[i] = -1;
        }
        //----------- on évite les CV105 et CV106 ------
        for (int i = 107; i < 201; i++) {
            infos_CV.CV[i] = -1;
        }
        for (int i = 33; i < 47; i++) {
            infos_CV.CV[i] = 0;
        }
        infos_CV.CV[106] = CV106;                                        //  on rétablit le CV106, là AVANT le Reset Light
        liste_CV.append(106);                                            //  on ajoute le CV106 à la liste des CV à modifier
        infos_CV.CV[1] = decodeur.CV1_;                                  //  on va chercher le CV1 dans le décodeur par défaut
        liste_CV.append(1);
        infos_CV.CV[2] = decodeur.CV2_;                                  //  on va chercher le CV2 dans le décodeur par défaut
        liste_CV.append(2);
        infos_CV.CV[3] = decodeur.CV3_;                                  //  on va chercher le CV3 dans le décodeur par défaut
        liste_CV.append(3);
        infos_CV.CV[4] = decodeur.CV4_;                                  //  on va chercher le CV4 dans le décodeur par défaut
        liste_CV.append(4);
        infos_CV.CV[5] = decodeur.CV5_;                                  //  on va chercher le CV5 dans le décodeur par défaut
        liste_CV.append(5);
        infos_CV.CV[6] = decodeur.CV6_;                                  //  on va chercher le CV6 dans le décodeur par défaut
        liste_CV.append(6);
        infos_CV.CV[17] = decodeur.CV17_;                                  //  on va chercher le CV17 dans le décodeur par défaut
        liste_CV.append(17);
        infos_CV.CV[18] = decodeur.CV18_;                                  //  on va chercher le CV18 dans le décodeur par défaut
        liste_CV.append(18);
        infos_CV.CV[28] = decodeur.CV28_;                                  //  on va chercher le CV28 dans le décodeur par défaut
        liste_CV.append(28);
        infos_CV.CV[29] = decodeur.CV29_;                                  //  on va chercher le CV29 dans le décodeur par défaut
        liste_CV.append(29);
        infos_CV.CV[66] = decodeur.CV66_;                                  //  on va chercher le CV66 dans le décodeur par défaut
        liste_CV.append(66);
        infos_CV.CV[95] = decodeur.CV95_;                                  //  on va chercher le CV95 dans le décodeur par défaut
        liste_CV.append(95);
        valeurs_usine    = false;
        appui_validation = false;
        valide_ecrire_CV = true;                                            //  lance l'affichage de toutes les modifications des CV
    }
}
//*********************************************************************************************
class Master_reset extends Bouton {
    Master_reset() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Master reset";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (master_reset) {
            image(gros_vert, _x, _y, _l, _h);
        } else {
            image(gros_bleu, _x, _y, _l, _h);
        }
        textAlign(CENTER, CENTER);
        fill(NOIR);        
        text(texte_affiche, _x+_l/2, _y+_h/2F);
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                if (gestion.modele_choisi.equals("Zimo/MX617//MX617 Version Fleischmann")) {
                    master_reset = true;
                }
            } else {
                String texte_info  = "Si le décodeur est définitivement bloqué,"
                           +char(10)+"il faut recourir à un reset complet"
                           +char(10)+"du décodeur suivant une procédure"
                           +char(10)+"tout à fait spécifique."
                  +char(10)+char(10)+"Il s'agit ICI d'un MASTER RESET";
                gestion.dessine_rectangle_bosse((width-500)/2F, (height-300F)/2F, 500F, 300F);
                textFont(Courier14);
                textAlign(CENTER, CENTER);
                text(texte_info, width/2F, height/2F);              
            }
        }       
    }
    //--------------------------- master_reset() --------------------------------------
    void master_reset() {
        CV106 = infos_CV.CV[106];                                        //  on sauve le CV106
        for (int i = 1; i < 8; i++) {
            infos_CV.CV[i] = -1;
        }
        //----------- on évite les CV7 et CV8 ---
        for (int i = 9; i < 105; i++) {
            infos_CV.CV[i] = -1;
        }
        //----------- on évite les CV105 et CV106 ------
        for (int i = 107; i < 201; i++) {
            infos_CV.CV[i] = -1;
        }
        for (int i = 33; i < 47; i++) {
            infos_CV.CV[i] = 0;
        }
        infos_CV.CV[7]        = 0;                                             //  on met le CV7 à   0
        liste_CV.append(7);
        infos_CV.CV[31]       = 0;                                             //  on met le CV31 à  0
        liste_CV.append(31);
        infos_CV.CV[32]       = 0;                                             //  on met le CV32 à  0
        liste_CV.append(32);
        infos_CV.CV[8]        = 8;                                             //  on met le CV8 à   8
        liste_CV.append(8);
        infos_CV.CV[15]       = 0;                                             //  on met le CV15 à  0
        liste_CV.append(15);
        infos_CV.CV[16]       = 0;                                             //  on met le CV16 à  0
        liste_CV.append(16);
        infos_CV.CV[8]        = 8;                                             //  on met le CV8 à   8
        liste_CV.append(8);
        infos_CV.CV[144]      = 0;                                             //  on met le CV144 à 0
        liste_CV.append(144);
        infos_CV.CV[106]      = CV106;                                        //  on rétablit le CV106, là APRES le Master Reset
        liste_CV.append(106);                                                 //  on ajoute le CV106 à la liste des CV à modifier
        master_reset     = false;
        appui_validation = false;
        valide_ecrire_CV = true;                                            //  lance l'affichage de toutes les modifications des CV
    }
}
//*************************************************************************************************************************************** Configuration
//*********************************************************************************************
class Valeur_CV29_enregistree extends Bouton {
    Valeur_CV29_enregistree() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Valeur du CV29 enregistrée dans le décodeur";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        groupe.Boutons[0].CV29_bin_dec();
        if (texte_choisi == null) {
            imageMode(CORNER);
            image(affiche_bleu, x+130F, y+5F, l, h);
            textAlign(LEFT, CENTER);       
            fill(NOIR);
            text(str(infos_CV.CV[29]), x+320F, y+1F+h/2F);
        }
    }
}
//*********************************************************************************************
class Sens_normal extends Bouton {
    Sens_normal() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Sens normal/sens inverse";
        effacer_choix();
        titre_choix    = "Voulez-vous inverser le sens de circulation ?";
        texte_choix[0] = "(CV29 bit 0 = 0)  Sens normal";
        texte_choix[1] = "(CV29 bit 0 = 1)  Sens inverse";
        compte_choix();
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x+130F && mouseX < x0+l0
         && mouseY > y      && mouseY < y+h) {
            if (top == 1) {
                for (int i = 1; i < 9; i++) {
                    groupe.Boutons[i].valide = false;
                }
                groupe.Boutons[1].valide   = true;
                groupe.Boutons[1].choix[1] = true;
            }
        }
    }
}
//*********************************************************************************************
class Nb_crans extends Bouton {
    Nb_crans() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Nombre de crans de vitesse";
        effacer_choix();
        titre_choix    = "Choisissez le nombre de crans de vitesse désiré";
        texte_choix[0] = "(CV29 bit 1 = 0)  14/28 crans";
        texte_choix[1] = "(CV29 bit 1 = 1)  128 crans (recommandé)";
        compte_choix();
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x+130F && mouseX < x0+l0
         && mouseY > y      && mouseY < y+h) {
            if (top == 1) {
                for (int i = 1; i < 9; i++) {
                    groupe.Boutons[i].valide = false;
                }
                groupe.Boutons[2].valide   = true;
                groupe.Boutons[2].choix[2] = true;
            } else {
                gestion.dessine_rectangle_bosse(x0+l0+20F, y, 330F, 90F);
                textAlign(LEFT, TOP);
                fill(BLANC);
                text("S'il y a 14 crans de vitesse, l'inversion"
                +char(10)+"des phares dépend du sens de circulation."
                +char(10)+"S'il y a 28 ou 128 crans, l'inversion"
                +char(10)+"des phares est gérée par les fonctions.", x0+l0+30F, y+5F);
            }
        }
    }
}
//*********************************************************************************************
class Analogique extends Bouton {
    Analogique() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Gestion d'une source d'alimentation non DCC";
        effacer_choix();
        titre_choix    = "Voulez-vous pouvoir rouler avec une source d'alimentation non DCC ?";
        texte_choix[0] = "(CV29 bit 2 = 0)  Interdire le changement de source (recommandé)";
        texte_choix[1] = "(CV29 bit 2 = 1)  Autoriser le changement de source";
        compte_choix();
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x+130F && mouseX < x0+l0
         && mouseY > y      && mouseY < y+h) {
            if (top == 1) {
                for (int i = 1; i < 9; i++) {
                    groupe.Boutons[i].valide = false;
                }
                groupe.Boutons[3].valide   = true;
                groupe.Boutons[3].choix[3] = true;
            }
        }
    }
}
//*********************************************************************************************
class Bouton_railcom extends Bouton {
    Bouton_railcom() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Utilisation de Railcom";
        effacer_choix();
        titre_choix    = "Voulez-vous utiliser Railcom ?";
        texte_choix[0] = "(CV29 bit 3 = 0)  Sans Railcom";
        texte_choix[1] = "(CV29 bit 3 = 1)  Avec Railcom";
        compte_choix();
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x+130F && mouseX < x0+l0
         && mouseY > y      && mouseY < y+h) {
            if (top == 1) {
                for (int i = 1; i < 9; i++) {
                    groupe.Boutons[i].valide = false;
                }
                groupe.Boutons[4].valide   = true;
                groupe.Boutons[4].choix[4] = true;
            }
        }
    }
}
//*********************************************************************************************
class Table_vitesse extends Bouton {
    Table_vitesse() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Nombre de points de la courbe de vitesse";
        effacer_choix();
        titre_choix    = "Quel type de gestion de vitesse voulez-vous ?";
        texte_choix[0] = "(CV29 bit 4 = 0)  Gestion à  3 points";
        texte_choix[1] = "(CV29 bit 4 = 1)  Gestion à 28 points";
        compte_choix();
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x+130F && mouseX < x0+l0
         && mouseY > y      && mouseY < y+h) {
            if (top == 1) {
                for (int i = 1; i < 9; i++) {
                    groupe.Boutons[i].valide = false;
                }
                groupe.Boutons[5].valide   = true;
                groupe.Boutons[5].choix[5] = true;
            }
        }
    }
}
//*********************************************************************************************
class Adresse_courte extends Bouton {
    Adresse_courte() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Adresse courte (1 à 99) ou étendue (128 à 9983)";
        effacer_choix();
        titre_choix    = "Quelle longueur d'adresse voulez-vous ?";
        texte_choix[0] = "(CV29 bit 5 = 0)  Adresse courte";
        texte_choix[1] = "(CV29 bit 5 = 1)  Adresse étendue";
        compte_choix();
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x+130F && mouseX < x0+l0
         && mouseY > y      && mouseY < y+h) {
            if (top == 1) {
                //--------------- onglet adresse ----------------
                if (groupe.numero_groupe == 6) {
                    groupe.Boutons[0].choix[0] = true;
                } else {
                    //------------- onglet configutation ------------
                    if (groupe.numero_groupe == 7) {
                        for (int i = 1; i < 9; i++) {
                            groupe.Boutons[i].valide = false;
                        }
                        groupe.Boutons[6].valide   = true;
                        groupe.Boutons[6].choix[6] = true;
                    }
                }
            }
        }
    }
}
//*********************************************************************************************
class CV29_bit6 extends Bouton {
    CV29_bit6() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Réservé pour une utilisation future par la NMRA";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        if (texte_choisi == null) {
            textAlign(LEFT, CENTER);       
            fill(NOIR);
            text("(CV29 bit 6 = 0)", x, y+1F+h/2F);
        }
    }
}
//*********************************************************************************************
class CV29_bit7 extends Bouton {
    CV29_bit7() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Réservé pour une utilisation future par la NMRA";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        if (texte_choisi == null) {
            textAlign(LEFT, CENTER);       
            fill(NOIR);
            text("(CV29 bit 7 = 0)", x, y+1F+h/2F);
        }
    }
}
//*********************************************************************************************
class Valeur_CV29_modifiee extends Bouton {
    Valeur_CV29_modifiee() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Valeur décimale du CV29 tenant compte des sélections faites";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        groupe.Boutons[0].CV29_bin_dec();
        if (texte_choisi == null) {
            imageMode(CORNER);
            if (CV29 == infos_CV.CV[29]) {
                image(affiche_bleu, x+130F, y+5F, l, h);
            } else {
                image(affiche_vert, x+130F, y+5F, l, h);
            }
            textAlign(LEFT, CENTER);       
            fill(NOIR);
            text(str(CV29), x+320F, y+1F+h/2F);
        }
    }
}
//******************************************************************************************************************************************* Adresse
//*********************************************************************************************
class Adresse extends Bouton {
    Adresse() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche      = "Entrez une adresse au clavier puis faites ENTREE";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        image(affiche_bleu, x+130F, y+5F, l, h);
        fill(NOIR);
        textAlign(CENTER, CENTER);
        if (adresse_saisie == -1) {
            image(affiche_bleu, x+130F, y+5F, l, h);
            text(texte_saisi, x+270F, y+1F+h/2F);
        } else {
            image(affiche_vert, x+130F, y+5F, l, h);
            text(adresse_saisie, x+270F, y+1F+h/2F);
        }
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x0+l0
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                //--------------- onglet adresse ----------------
                if (groupe.numero_groupe == 6) {
                    groupe.Boutons[0].choix[0] = true;
                }
            }
        }
    }
}
//*********************************************************************************************
class Adresse_actuelle extends Bouton {
    Adresse_actuelle() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Adresse actuelle";
    }
    //-------------------------- dessine_bouton_bleu() -------------------------------
    void dessine_bouton_bleu() {                                                                                    //  affiche le bouton du haut, toujours en bleu
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        int CV29_bit5 = int(binary(infos_CV.CV[29], 8).substring(7-5, 7-5+1));
        image(affiche_bleu, x+130F, y+5F, l, h);
        fill(NOIR);
        textAlign(CENTER, CENTER);       
        if (CV29_bit5 == 0) {
            text(infos_CV.CV[1], x+270F, y+1F+h/2F);
        } else {
            text((infos_CV.CV[17]-192)*256+infos_CV.CV[18], x+270F, y+1F+h/2F);
        }
    }
}
//*********************************************************************************************
class CV1 extends Bouton {
    CV1() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Valeur du CV1";
    }
    //-------------------------- dessine_bouton_bleu() -------------------------------
    void dessine_bouton_bleu() {                                                                                    //  affiche le bouton du haut, toujours en bleu
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        image(affiche_bleu, x+130F, y+5F, l, h);
        fill(NOIR);
        textAlign(LEFT, CENTER);       
        text("(CV1)             ", x, y+1F+h/2F);
        textAlign(CENTER, CENTER);       
        text(infos_CV.CV[1], x+270F, y+1F+h/2F);
    }
    //-------------------------- dessine_bouton_bleu_modifie() -------------------------------
    void dessine_bouton_bleu_modifie(boolean _vert) {                                                                //  affiche le bouton du bas, en bleu ou en vert
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        image(affiche_vert, x+130F, y+5F, l, h);
        fill(NOIR);
        textAlign(LEFT, CENTER);       
        text("(CV1)             ", x, y+1F+h/2F);
        textAlign(CENTER, CENTER);
        text(str(adresse_saisie), x+270F, y+1F+h/2F);
    }
}
//*********************************************************************************************
class CV17 extends Bouton {
    CV17() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Adresse étendue (128 à 9983) bits de poids fort";
    }
    //-------------------------- dessine_bouton_bleu() -------------------------------
    void dessine_bouton_bleu() {                                                                                    //  affiche le bouton du haut, toujours en bleu
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        image(affiche_bleu, x+130F, y+5F, l, h);
        fill(NOIR);
        textAlign(LEFT, CENTER);       
        text("(CV17)            ", x, y+1F+h/2F);
        textAlign(CENTER, CENTER);       
        text(infos_CV.CV[17], x+270F, y+1F+h/2F);
    }
    //-------------------------- dessine_bouton_bleu_modifie() -------------------------------
    void dessine_bouton_bleu_modifie(boolean _vert) {                                                                //  affiche le bouton du bas, en bleu ou en vert
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        image(affiche_vert, x+130F, y+5F, l, h);
        fill(NOIR);
        textAlign(LEFT, CENTER);       
        text("(CV17)            ", x, y+1F+h/2F);
        textAlign(CENTER, CENTER);
        text(str(CV17), x+270F, y+1F+h/2F);
    }
}
//*********************************************************************************************
class CV18 extends Bouton {
    CV18() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Adresse étendue (128 à 9983) bits de poids faible";
    }
    //-------------------------- dessine_bouton_bleu() -------------------------------
    void dessine_bouton_bleu() {                                                                                    //  affiche le bouton du haut, toujours en bleu
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        image(affiche_bleu, x+130F, y+5F, l, h);
        fill(NOIR);
        textAlign(LEFT, CENTER);       
        text("(CV18)            ", x, y+1F+h/2F);
        textAlign(CENTER, CENTER);       
        text(infos_CV.CV[18], x+270F, y+1F+h/2F);
    }
    //-------------------------- dessine_bouton_bleu_modifie() -------------------------------
    void dessine_bouton_bleu_modifie(boolean _vert) {                                                                //  affiche le bouton du bas, en bleu ou en vert
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle_creux(GRIS, x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        image(affiche_vert, x+130F, y+5F, l, h);
        fill(NOIR);
        textAlign(LEFT, CENTER);       
        text("(CV18)            ", x, y+1F+h/2F);
        textAlign(CENTER, CENTER);
        text(str(CV18), x+270F, y+1F+h/2F);
    }
}
//***************************************************************************************************************************************** Vitesses 28 points
//*********************************************************************************************
class Vapeur extends Bouton {
    Vapeur() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Loco vapeur";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                onglet.parametre = 0;
            }
        }       
    }
}
//*********************************************************************************************
class Electrique_diesel extends Bouton {
    Electrique_diesel() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Loco électrique/diesel";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                onglet.parametre = 1;
            }
        }       
    }
}
//*********************************************************************************************
class Boutons_libres extends Bouton {
    Boutons_libres() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Boutons libres";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                onglet.parametre = 2;
            }
        }       
    }
}
//************************************************************************************************************************************** Fonctions
//*********************************************************************************************
class Bouton_fonction extends Bouton {
    Bouton_fonction() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (valide) {
            image(validation, _x, _y, _l, _h);
        } else {
            image(validationV, _x, _y, _l, _h);
        }
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                valide = !valide;
            }
        }        
    }
}
//*********************************************************************************************
class Fonctions_par_defaut extends Bouton {
    Fonctions_par_defaut() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Valeurs par défaut";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                groupe.fonctions_par_defaut();
            }
        }       
    }
}
//*********************************************************************************************
class Fonctions_decodeur extends Bouton {
    Fonctions_decodeur() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Valeurs déjà dans"+char(10)+"le décodeur";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                groupe.fonctions_decodeur();
            }
        }       
    }
}
//*********************************************************************************************
class Selection_CV extends Bouton {
    Selection_CV() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (valide) {
            image(validationVG, _x, _y, _l, _h);
        }
        fill(NOIR);
        textAlign(RIGHT, CENTER);
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                appui_CV = int(10F*((y-112F)/43F)+((x-10F)/135F)+1.5F);        // 1.5 = +1 car on démarre à 1 et +0.5 pour l'arrondi
                                                                          println(appui_CV);
                if (!transfert_fich_dec && !transfert_dec_fich) {
                    port.write("<R "+str(appui_CV)+" 1"+str(appui_CV)+" 1"+str(appui_CV)+">");
                    debut_comptage = millis();
                }
            } else {
                valide = true;
            }
        } else {
            valide = false;
        }
    }
}
//*********************************************************************************************
class Selection_fonctions extends Bouton {
    Selection_fonctions() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (valide && texte_information == null) {
            image(validationVG650, _x, _y, _l, _h);
        }
        x = _x; y = _y; l = _l; h = _h;
        if (saisie_valide) {
            if (!texte_saisi_b.equals("")) {
                prop[appui_F] = texte_saisi_b;
                saisie_valide = false;
            }
        }
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            appui_F           = int(2F*((y-129F)/38F)+((x-380F)/675F)+2.5F);        // 1.5 = +1 car on démarre à 1 et +0.5 pour l'arrondi
            if (top == 1) {
                texte_information = "Un libellé de fonction est unique"
                          +char(10)+"pour un propriétaire donné";
                texte_details     = "Entrez le nouveau libellé de F"+appui_F+" (42 caractères maxi) :";
            } else {
                valide = true;
            }
        } else {
            valide = false;
        }
    }
}
//*********************************************************************************************
class Fichier_decodeur extends Bouton {
    Fichier_decodeur() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Transfert Fichier --> Décodeur";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (transfert_fich_dec) {
            image(gros_vert, _x, _y, _l, _h);
        } else {
            image(gros_bleu, _x, _y, _l, _h);
        }
        textAlign(CENTER, CENTER);       
        fill(NOIR);
        text(texte_affiche, _x+_l/2, _y+_h/2F);
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                transfert_fich_dec = true;
                appui_CV = 0;
            } else {
                if (!transfert_fich_dec) {
                    String texte_info  = "Normalement, la valeur du CV dans le décodeur"
                               +char(10)+"est la même que celle dans le fichier."
                               +char(10)+"Les deux sont donc sur fond vert."
                      +char(10)+char(10)+"En cas d'écart, les valeurs apparaissent sur fond bleu."
                      +char(10)+char(10)+"Pour rectifier :"
                               +char(10)+"1°) Appuyez d'abord sur LE BON BOUTON DU BAS,"                           
                               +char(10)+"2°) Puis cliquez dans LA CASE à rectifier.";
                    gestion.dessine_rectangle_bosse((width-500)/2F, (height-300F)/2F, 500F, 300F);
                    textFont(Courier14);
                    textAlign(CENTER, CENTER);
                    text(texte_info, width/2F, height/2F);
                }
            }
        }       
    }
}
//*********************************************************************************************
class Decodeur_fichier extends Bouton {
    Decodeur_fichier() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Transfert Décodeur --> Fichier";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (transfert_dec_fich) {
            image(gros_vert, _x, _y, _l, _h);
        } else {
            image(gros_bleu, _x, _y, _l, _h);
        }
        textAlign(CENTER, CENTER);       
        fill(NOIR);
        text(texte_affiche, _x+_l/2, _y+_h/2F);
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                transfert_dec_fich = true;
                appui_CV = 0;
            } else {
                if (!transfert_dec_fich) {
                    String texte_info  = "Normalement, la valeur du CV dans le décodeur"
                               +char(10)+"est la même que celle dans le fichier."
                               +char(10)+"Les deux sont donc sur fond vert."
                      +char(10)+char(10)+"En cas d'écart, les valeurs apparaissent sur fond bleu."
                      +char(10)+char(10)+"Pour rectifier :"
                               +char(10)+"1°) Appuyez d'abord sur LE BON BOUTON DU BAS,"                           
                               +char(10)+"2°) Puis cliquez dans LA CASE à rectifier.";
                    gestion.dessine_rectangle_bosse((width-500)/2F, (height-300F)/2F, 500F, 300F);
                    textFont(Courier14);
                    textAlign(CENTER, CENTER);
                    text(texte_info, width/2F, height/2F);
                }
            }
        }       
    }
}
//*********************************************************************************************
class Retour_vehicule extends Bouton {
    Retour_vehicule() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Retour au véhicule";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (valide) {
            image(gros_vert, _x, _y, _l, _h);
        } else {
            image(gros_bleu, _x, _y, _l, _h);
        }
        textAlign(CENTER, CENTER);       
        fill(NOIR);
        text(texte_affiche, _x+_l/2, _y+_h/2F);
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                valide            = false;
                ajouter_decodeur  = false;
                maj_decodeur      = false;
                choix_du_vehicule = true;
            }
        }        
    }
}
//************************************************************************************************************************************** Pupitre
//*********************************************************************************************
class Bouton_pupitre extends Bouton {
    Bouton_pupitre() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (!affiche_proprietaire && infos_CV.ID_CV != 0) {
            if (mouseX > x && mouseX < x+l
             && mouseY > y && mouseY < y+h) {
                if (mouseX > 630F && mouseX < (630F+346F)
                 && mouseY > 15F  && mouseY < (15F+100F)) {
                    //  éviter l'autre bouton côté pupitre
                } else {
                    if (top == 1) {
                        affiche_pupitre   = true;
                        choix_du_vehicule = false;
                        top = 2;
                    }
                }
            }
        }
    }
}
//*********************************************************************************************
class Code_loco extends Bouton {
    Code_loco() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                affiche_pupitre   = false;
                choix_du_vehicule = true;
            }
        }
    }
}
//*********************************************************************************************
class Bouton_fonction_pupitre extends Bouton {
    Bouton_fonction_pupitre() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (valide) {
            image(voyant_rouge, _x+10F, _y-35F, 30F, 30F);
        } else {
            image(voyant_rouge_eteint, _x+10F, _y-35F, 30F, 30F);
        }
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                valide = !valide;
            }
        }        
    }
}
//*********************************************************************************************
class Nixie_plus extends Bouton {
    Nixie_plus() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        image(bouton_SNCF, _x, _y, _l, _h);
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                gestion.nixie[int((x-646F)/70F+.5)] = min(9, gestion.nixie[int((x-646F)/70F+.5)]+1); 
                int nixie = gestion.nixie[4]+10*(gestion.nixie[3]+10*(gestion.nixie[2]+10*(gestion.nixie[1]+10*(gestion.nixie[0]))));
                if (nixie > 10239) {
                   gestion.nixie[int((x-646F)/70F+.5)]--; 
                }
            }
        }        
    }
}
//*********************************************************************************************
class Nixie_moins extends Bouton {
    Nixie_moins() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        image(bouton_SNCF, _x, _y, _l, _h);
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                gestion.nixie[int((x-646F)/70F+.5)] = max(0, gestion.nixie[int((x-646F)/70F+.5)]-1); 
            }
        }        
    }
}
//**************************************************************************************************************************************** Validation CV
//*********************************************************************************************
class Validation_CV extends Bouton {
    Validation_CV() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Validez les choix pour cet onglet";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (appui_validation) {
            image(gros_vert, _x, _y, _l, _h);
        } else {
            image(gros_bleu, _x, _y, _l, _h);
        }
        textAlign(CENTER, CENTER);       
        fill(NOIR);
        text(texte_affiche, _x+_l/2, _y+_h/2F);
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                appui_validation = true;
                gestion.dessine_rectangle_bosse((width-500)/2F, (height-300F)/2F, 500F, 300F);
                if (groupe1.numero_groupe == 100) {
                    //------------- onglet fiche --------------
                    if (groupe.numero_groupe == 5) {                                         //  Boutons_onglet_fiche
                        //-------------------------------------- valeurs usine -----------------------------------------
                        if (valeurs_usine) {
                            groupe.Boutons[28].valeurs_usine();
                        } else {
                            //---------------------------------- master rest -----------------------------------------------------------
                            if (master_reset) {
                                groupe.Boutons[29].master_reset();
                            } else {
                                //---------------------------------- cas général --------------------------------------
                                if (vehicule.ID_CV != 0) {
                                    infos_CV.CV[106] = vehicule.CV106;
                                    liste_CV.append(106);
                                    valide_ecrire_CV  = true;
                                } else {
                                    ajouter_decodeur     = false;
                                    maj_decodeur         = false;
                                    choix_du_vehicule    = true;
                                    appui_validation     = false;
                                }
                                maj_date();
                                vehicule.date = date;
                                sauve_table_Vehicules();
                                sauvegarde_vehicule();
                                //----------------- RaZ des validations ---------------------
                                for (int i = 0; i < 30; i++) {
                                    groupe.Boutons[i].valide = false;
                                }
                            }
                        }
                    }
                    //------------- onglet configutation ------------
                    if (groupe.numero_groupe == 7) {                                                                          //  Boutons_onglet_configuration
                        infos_CV.CV[29] = CV29;
                        liste_CV.append(29);
                        valide_ecrire_CV  = true;
                        //----------------- RaZ des validations ---------------------
                        for (int i = 0; i < 10; i++) {
                            groupe.Boutons[i].valide = false;
                        }
                    }
                    //------------- onglet adresse ------------
                    if (groupe.numero_groupe == 6) {                                                                          //  Boutons_onglet_adresse
                        bouton = groupe.Boutons[1];                                                                           //  Adresse_courte()
                        if (bouton.modif_CV29) { 
                            liste_CV.append(29);
                        }
                        int CV29_bit5 = int(binary(infos_CV.CV[29], 8).substring(7-5, 7-5+1));
                        if (CV29_bit5 == 0) {
                            liste_CV.append(1);
                        } else {
                            liste_CV.append(17);
                            liste_CV.append(18);
                        }
                        bouton = groupe.Boutons[5];                                                                           //  Adresse()
                        bouton.adresse_saisie = -1;
                        valide_ecrire_CV  = true;
                        //----------------- RaZ des validations ---------------------
                        for (int i = 0; i < 6; i++) {
                            groupe.Boutons[i].valide = false;
                        }
                    }
                    //------------- onglet moteur ------------
                    if (groupe.numero_groupe == 8) {                                                                          //  Boutons_onglet_moteur
                        for (int i = 0; i < 2; i++) {
                            infos_CV.CV[i+3] = int(onglet.hauteur_curseur[i]+.5F);
                            liste_CV.append(i+3);
                        }
                        valide_ecrire_CV = true;
                    }
                    //------------- onglet controle basique de vitesse ------------
                    if (groupe.numero_groupe == 9) {                                                                          //  Boutons_onglet_controle_basique_de_vitesse
                        texte_ecrire = "";
                        int CV29_bit4 = int(binary(infos_CV.CV[29], 8).substring(7-4, 7-4+1));
                        if (CV29_bit4 == 1) {
                            infos_CV.CV[29] = infos_CV.CV[29]-16;                            
                            liste_CV.append(29);
                        }
                        infos_CV.CV[2] = int(onglet.hauteur_curseur[0]+.5);
                        liste_CV.append(2);
                        infos_CV.CV[6] = int(onglet.hauteur_curseur[1]+.5);
                        liste_CV.append(6);
                        infos_CV.CV[5] = int(onglet.hauteur_curseur[2]+.5);
                        liste_CV.append(5);
                        valide_ecrire_CV = true;
                    }
                    //------------- onglet tableau_vitesse ------------
                    if (groupe.numero_groupe == 10) {                                                                         //  Boutons_onglet_tableau_vitesse
                        texte_ecrire = "";
                        int CV29_bit4 = int(binary(infos_CV.CV[29], 8).substring(7-4, 7-4+1));
                        if (CV29_bit4 == 0) {
                            infos_CV.CV[29] = infos_CV.CV[29]+16;                            
                            liste_CV.append(29);
                        }
                        for (int i = 0; i < 28; i++) {
                            infos_CV.CV[67+i] = int(onglet.hauteur_curseur[i]+.5);
                            liste_CV.append(67+i);
                        }
                        valide_ecrire_CV = true;
                        for (int i = 30; i < 35; i++) {
                            infos_CV.p[i-30] = int(onglet.hauteur_curseur[i]+.5);
                        }
                    }
                    //------------- onglet fonctions -----------------
                    if (groupe.numero_groupe == 11) {                                                                         //  Boutons_onglet_carte_fonctions
                        for (int i = 33; i < 47; i++) {
                            infos_CV.CV[i] = CV[i-33];
                            liste_CV.append(i);
                        }
                        valide_ecrire_CV = true;
                    }
                    //------------- onglet fonctions proprietaires -----------------
                    if (groupe.numero_groupe == 13) {                                                                         //  Boutons_onglet_carte_fonctions
                        for (int i = 1; i < 29; i++) {
                            proprietaire.F[i] = prop[i];
                        }
                        sauve_table_Proprietaires();
                        //----------------- RaZ des validations ---------------------
                        for (int i = 1; i < 28; i++) {
                            groupe.Boutons[i].valide = false;
                        }
                    }
                    top = 2;
                    sauve_table_Infos_CV();
                    sauvegarde_infos_CV();
                    //effacer_les_boutons();
                    gestion.one_shot     = false;
                    //saisie_valide      = false;
                    affiche_proprietaire = false;
                }
            } else {
                //-------------------- avant adresse ---------------
                if (groupe.numero_groupe == 6) {                                                                              //  Boutons_onglet_adresse
                    bouton = groupe.Boutons[5];
                    if (!saisie_valide) {
                        gestion.dessine_rectangle_bosse((width-500)/2F, (height-300F)/2F, 500F, 300F);
                        textFont(Courier17);
                        textAlign(CENTER, CENTER);
                        text("Vous n'avez pas fait 'ENTREE'", width/2F, height/2F);
                    }
                }
            }
        }        
    }
}
//*********************************************************************************************
class Sortir_CV extends Bouton {
    Sortir_CV() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Ne rien changer pour cet onglet";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                if (groupe1.numero_groupe == 100) {
                    appui_validation = true;
                    recuperation_infos_CV();
                    //------------- onglet fiche ------------
                    if (groupe.numero_groupe == 5) {
                        affiche_proprietaire = false;
                        recuperation_vehicule();
                        valeurs_usine     = false;
                        master_reset      = false;
                        for (int i = 0; i < 30; i++) {
                            groupe.Boutons[i].texte_saisi_b = "";
                        }
                        //----------------- RaZ des validations ---------------------
                        for (int i = 0; i < 30; i++) {
                            groupe.Boutons[i].valide         = false;
                            groupe.Boutons[i].texte_choix[0] = null;
                            groupe.Boutons[i].texte_choisi   = null;
                        }
                    }
                    //------------- onglet adresse ------------
                    if (groupe.numero_groupe == 6) {
                        bouton = groupe.Boutons[5];
                        bouton.adresse_saisie = -1;
                        //----------------- RaZ des validations ---------------------
                        for (int i = 0; i < 6; i++) {
                            groupe.Boutons[i].valide = false;
                        }
                    }
                    //------------- onglet configutation ------------
                    if (groupe.numero_groupe == 7) {
                        for (int i = 1; i < 9; i++) {
                            bouton = groupe.Boutons[i];
                            bouton.texte_choisi = null;
                        }
                        groupe.choix_onglet_configuration();
                        //----------------- RaZ des validations ---------------------
                        for (int i = 0; i < 10; i++) {
                            groupe.Boutons[i].valide = false;
                        }
                    }
                    //------------- onglet tableau vitesse ------------
                    if (groupe.numero_groupe == 10) {
                        onglet.parametre = 2;
                        onglet.maj_curseurs();
                    }
                    //------------- onglet carte_fonctions ------------
                    if (groupe.numero_groupe == 11) {
                        groupe.fonctions_decodeur();
                    }
                    gestion.one_shot     = true;
                    appui_validation     = false;
                    texte_saisi          = "";
                    ecriture_OK          = true;
                    choix_du_vehicule    = true;
                    saisie_valide        = false;
                    texte_information    = null;
                    effacer_les_boutons();
                    texte_choix[0]       = null;
                    affiche_proprietaire = false;
                    ajouter_decodeur     = false;
                    maj_decodeur         = false;
                    choix_du_vehicule    = true;
                }
            }
        }        
    }
}
