/////////////////////////////////// Globales ///////////////////////////////////////////////////////////
int       TAILLE_POLICE          = 14;
float     ZOOM                   = TAILLE_POLICE*0.85F;
float     H                      = 2F*TAILLE_POLICE*0.85F;
int       E                      = 3;
int       NB_DECODEURS           = 2897;
int       NB_GROUPES             = 130;
int       NB_CHOIX               = 130;
int       LF                     = 10;  //LineFeed
int       SUPERIEUR              = 62;  // >
//---------------------- booléens --------------------------
boolean   aff_fabricant          = false;
boolean   affiche_en_tete        = false;
boolean   affiche_proprietaire   = false;
boolean   affiche_pupitre        = false;
boolean   ajouter_decodeur       = false;
boolean   annule                 = false;
boolean   appui_validation       = false;
boolean   bouton_DCC             = false;
boolean   bouton_moteur          = false;
boolean   charge_tables          = true;
boolean   cherche_arduino        = true;
boolean   cherche_fichier        = true;
boolean   choix_du_vehicule      = false;
boolean   choix_onglet           = false;
boolean   choix_vehicule         = false;
boolean   coller_CV              = false;
boolean   confirmation           = false;
boolean   copier_CV              = false;
boolean   dans_curseurH_compo    = false;
boolean   dans_curseurH_vehicule = false;
boolean   dans_curseurV          = false;
boolean   dans_onglets           = false;
boolean   demo                   = true;
boolean   dessine_les_fabricants = false;
boolean   dessine_les_familles   = false;
boolean   dessine_les_modeles    = false;
boolean   ecriture_OK            = true;
boolean   maj_decodeur           = false;
boolean   marque_loco            = false;
boolean   master_reset           = false;
boolean   NC                     = false;    
boolean   OK                     = false;
boolean   premier_passage        = true;
boolean   pupitre                = false;
boolean   saisie_valide          = false;
boolean   saut                   = false;
boolean   sauver_et_sortir       = false;
boolean   sortir_sans_sauver     = false;
boolean   supprime_proprietaire  = false;
boolean   tables_construites     = false;
boolean   transfert_dec_fich     = false;
boolean   transfert_fich_dec     = false;
boolean   transfert_F            = false;
boolean   trouve                 = false;
boolean   valeurs_usine          = false;
boolean   valide_ecrire_CV       = false;
//------------------- entiers ---------------------------------
int       appui_CV               = 0;
int       appui_F                = 0;
int       choix_train            = 0;
int       compte_demo            = 0;
int       cran                   = 0;
int       CV[]                   = new int[14];
int       CV_decodeur[]          = new int[121];
int       CV106                  = 0;
int       CV29                   = 0;
int       delta0                 = 0;
int       delta2                 = 0;
int       en_cours               = 0;
int       groupe_bouton          = -1;
int       inverse                = 0;
int       ordre                  = 0;
int       ordre_bouton           = 0;
int       question               = 0;
int       reponse                = 0;
int       saut1                  = 0;
int       top                    = 0;
int       vehicule_copie         = 0;
//------------------- entiers doubles -------------------------
double    debut_comptage         = 0;
double    fin_comptage           = 0;
//------------------- flottants -------------------------------
float     alpha                  = QUARTER_PI;
float     alpha_i                = 0F;
float     alpha_vi               = -3F*QUARTER_PI;
float     alpha_vo               = -3F*QUARTER_PI;
float     alpha_a                = -3F*QUARTER_PI;
float     blanc[]                = new float[25];
float     debut_onglet[]         = new float[25];
float     vitesse                = 0F;
//------------------- chaînes de caractères -------------------
String    chaine_lue;
String    CV_valide;
String    date                   = "";
String    prop[]                 = new String[29];
String    Repertoire_Communs     = "";
String    Repertoire_Decoduino   = "";
String    s                      = null;
String    sl[]                   = null;
String    texte_avertissement    = null;
String    texte_details          = null;
String    texte_ecrire           = "";
String    texte_information      = null;
String    texte_lire             = "";
String    texte_saisi            = "";
//------------------ fontes de caractères ------------------
PFont     Courier12;
PFont     Courier14;
PFont     Courier17;
PFont     Courier25;
PFont     fontUnits;
//------------------ Tables --------------------------
Table     Vehicules;
Table     Infos_CV;
Table     Proprietaires;
Table     Base_decodeurs;
Table     Compositions;
//------------------------------ couleurs -------------------
int       GRIS       = #808080;
int       ROUGE      = #FF0000;
int       GRIS_FONCE = #B5B5B5;
int       BLANC      = #FFFFFF;
int       JAUNE      = #faca30;//#ffb200;//#FFFF00;
int       VERT       = #00FF00;
int       VIOLET     = #9370DB;
int       VERT_FONCE = #008000;
int       ARDOISE    = #5A5E6B;
int       BLEU       = #0000FF;
int       BLEU1      = #C8E8E8;
int       BLEU2      = #9AB3B3;
int       FOSSE      = #6E696A;
int       PONT       = #A6A6A6;
int       FOND       = #D4D4D4;
int       NOIR       = #000000;
int       AQUA       = #00FFFF;
int       OR         = #FFD900;
int       OLIVE      = #556B2F;
int       SABLE      = #F4A460;
int       POURPRE    = #BA55D3;
int       VERT_FLUO  = #7CFC00;
int       VERT6019   = #b9ceac;
int       VERT6027   = #7ebab5;
int       VERTCF0    = #00CF00;
int       FOND_TRAIN = #454545;
int       FOND_VIDE  = #C5C7C4;
int       BLEU_CLAIR = #00DCFE;
int       BRUN       = #AF804F;

Decodeur     decodeur;
Onglet       onglet;
Gestion      gestion;
Zone         zone;
Vehicule     vehicule;
Infos_CV     infos_CV;
Bouton       bouton;
Bouton       bouton1;
Groupe       groupe;
Groupe       groupe1;
Groupe       groupe2;
Groupe       groupe3;
Groupe       groupe_confirmation;
Proprietaire proprietaire;

Groupe    groupes[]   = new Groupe[NB_GROUPES];

ArrayList<Decodeur>       tous_decodeurs         = new ArrayList<Decodeur>();
ArrayList<Onglet>         tous_onglets           = new ArrayList<Onglet>();
StringList                tous_fabricants        = new StringList();
StringList                toutes_familles        = new StringList();
StringList                tous_modeles           = new StringList();
StringList                toutes_marques         = new StringList();
IntList                   liste_CV               = new IntList();                                                             //  liste de tous les CV à lire ou écrire dans le décodeur
ArrayList<Proprietaire>   tous_proprietaires     = new ArrayList<Proprietaire>();
ArrayList<Composition>    toutes_compositions    = new ArrayList<Composition>();
ArrayList<Vehicule>       tous_vehicules_complet = new ArrayList<Vehicule>();                                                 //  liste de tous les véhicules, sans filtre
ArrayList<Vehicule>       tous_vehicules         = new ArrayList<Vehicule>();                                                 //  liste intermédiaire des véhicules filtrés
ArrayList<Vehicule>       tous_vehicules_filtres = new ArrayList<Vehicule>();                                                 //  liste de tous les véhicules après les filtres
ArrayList<Base_decodeurs> tous_decodeurs_base    = new ArrayList<Base_decodeurs>();
ArrayList<Vehicule>       compo_train            = new ArrayList<Vehicule>();
ArrayList<Infos_CV>       toutes_infos_CV        = new ArrayList<Infos_CV>();                                                 //  liste de toutes les infos des CV
String[] filenames;
String[] names;
//--------------------- PImage ----------------------
PImage  affiche_bleu;
PImage  affiche_vert;
PImage  aiguille_compteur;
PImage  aiguille_va;
PImage  bouton_bleu;
PImage  bouton_SNCF;
PImage  composition;
PImage  curseurH;
PImage  curseurV;
PImage  danger;
PImage  ecran;
PImage  ecran_fiche;
PImage  etiquette_adresse;
PImage  etiquette_cran;
PImage  etiquette_fonctions;
PImage  fond_alu;
PImage  fond_alu1;
PImage  glissiere;
PImage  gros_bleu;
PImage  gros_vert;
PImage  levier_axe;
PImage  levier_inverseur;
PImage  nc;
PImage  nixie_0;
PImage  nixie_1;
PImage  nixie_10;
PImage  nixie_2;
PImage  nixie_3;
PImage  nixie_4;
PImage  nixie_5;
PImage  nixie_6;
PImage  nixie_7;
PImage  nixie_8;
PImage  nixie_9;
PImage  parchemin;
PImage  pupitre_fond;
PImage  triangle_va;
PImage  validation;
PImage  validationB;
PImage  validationV;
PImage  validationVG;
PImage  validationVG650;
PImage  voyant_rouge;
PImage  voyant_rouge_eteint;
//--------------------------- charges_images() --------------
void charge_images() {
    affiche_bleu        = loadImage("data/Affiche bleu.png");
    affiche_vert        = loadImage("data/Affiche vert.png");
    bouton_bleu         = loadImage("data/Bouton bleu.png");    
    curseurH            = loadImage("data/CurseurH.png");
    curseurV            = loadImage("data/CurseurV.png");
    gros_bleu           = loadImage("data/Bouton bleu avec cadre.png");
    gros_vert           = loadImage("data/Bouton vert avec cadre.png");
    danger              = loadImage("data/Danger.png");
    validation          = loadImage("data/Bouton_validation30.png");
    validationV         = loadImage("data/Bouton_validation30V.png");
    validationVG        = loadImage("data/Bouton_validation30V130x40.png");
    validationVG650     = loadImage("data/Bouton_validation30V650x40.png");
    validationB         = loadImage("data/Bouton_validation30B.png");
    composition         = loadImage("data/Train5.png");
    pupitre_fond        = loadImage("data/TdB4.png");
    voyant_rouge        = loadImage("data/Voyant_rouge.png");
    voyant_rouge_eteint = loadImage("data/Voyant_rouge_eteint.png");
    nixie_10            = loadImage("data/Nixie_eteint.png");
    nixie_0             = loadImage("data/Nixie_0.png");
    nixie_1             = loadImage("data/Nixie_1.png");
    nixie_2             = loadImage("data/Nixie_2.png");
    nixie_3             = loadImage("data/Nixie_3.png");
    nixie_4             = loadImage("data/Nixie_4.png");
    nixie_5             = loadImage("data/Nixie_5.png");
    nixie_6             = loadImage("data/Nixie_6.png");
    nixie_7             = loadImage("data/Nixie_7.png");
    nixie_8             = loadImage("data/Nixie_8.png");
    nixie_9             = loadImage("data/Nixie_9.png");
    bouton_SNCF         = loadImage("data/Ecrou_poussoir.png");
    etiquette_fonctions = loadImage("data/Fonctions2.png");
    etiquette_adresse   = loadImage("data/Adresse.png");
    etiquette_cran      = loadImage("data/Cran.png");
    levier_axe          = loadImage("data/Levier_axe.png");
    levier_inverseur    = loadImage("data/Manette_reduite.png");
    aiguille_compteur   = loadImage("data/Aiguille_compteur_reduite.png");
    aiguille_va         = loadImage("data/Aiguille_va_reduite.png");
    glissiere           = loadImage("data/Glissiere.png");
    parchemin           = loadImage("data/Parchemin.png");
    triangle_va         = loadImage("data/Triangle_reduit.png");
    nc                  = loadImage("data/nc.png");
}
//--------------------------- ecrire_CV() -----------------------------
void ecrire_CV(int _CV) {
    if (!demo) {
        for (int i = 0; i < 3; i++) {
            port.write("<W "+str(_CV)+" "+str(infos_CV.CV[_CV])+" 1"+str(_CV)+" 1"+str(_CV)+">");
            delay(2000);
            chaine_lue = port.readStringUntil(SUPERIEUR).substring(2);
            texte_ecrire = "Chaîne envoyée = <W "+str(_CV)+" "+str(infos_CV.CV[_CV])+" 1"+str(_CV)+" 1"+str(_CV)+">"
               +char(10)+"Chaîne lue     = "+chaine_lue;
            decoupe_reponse(chaine_lue);
            if (CV_valide != null) {
                if (int(CV_valide) == int(infos_CV.CV[_CV])) {
                    break;
                }
            } else {
                texte_ecrire = texte_ecrire +char(10)+char(10)+"Valeur de CV mal transmise. Essai n° "+str(i+1);
            }
        }
        debut_comptage = millis();
    }
}
//--------------------------- lire_CV() -----------------------------
void lire_CV() {
    if (!demo) {
        fin_comptage = millis();
        if (fin_comptage-debut_comptage > 2000) {
            chaine_lue = port.readStringUntil(SUPERIEUR);
            chaine_lue = chaine_lue.substring(2);
            decoupe_reponse(chaine_lue);
            if (CV_valide == null) {
                CV_valide = "-1";
            }
            texte_lire = "Chaîne envoyée = <R "+str(appui_CV)+" 1"+str(appui_CV)+" 1"+str(appui_CV)+">"
               +char(10)+"Chaîne lue     = "+chaine_lue;
            appui_validation = true;
            debut_comptage = millis();
            CV_decodeur[appui_CV] = int(CV_valide);
            appui_CV = 0;
        }
    }
}
//-------------------------- decoupe_reponse() ------------------------------
void decoupe_reponse(String _reponse) {
    int longueur = _reponse.length();
    String x1 = "";
    String x2 = "";
    String x3 = "";
    CV_valide = null;
    if (_reponse.substring(0, 2).equals("<r")) {
        if (!(_reponse.substring(longueur-3, longueur-1)).equals("-1")) {
            int debut   = 3;
            int courant = 2;
            //------- cas normal -------
            for (int j = 0; j < 5; j++) {
                if ((_reponse.substring(courant, courant+1)).equals("|")) {
                    x1 = _reponse.substring(debut, courant);
                    debut = courant+2;
                    break;
                }
                courant++;
            }
            courant = courant+1;
            for (int j = 0; j < 5; j++) {
                if ((_reponse.substring(courant, courant+1)).equals("|")) {
                    x2 = _reponse.substring(debut, courant);
                    debut = courant+1;
                    break;
                }
                courant++;
            }
            courant++;
            if (x2.equals(x1)) {
                for (int j = 0; j < 5; j++) {
                    if ((_reponse.substring(courant, courant+1)).equals(" ")) {
                        x3 = _reponse.substring(debut, courant);
                        debut = courant+1;
                        break;
                    }
                    courant++;
                }
                if (x3.equals(x1)) {
                    courant++;
                    for (int j = 0; j < 5; j++) {
                        if ((_reponse.substring(courant, courant+1)).equals(">")) {
                            CV_valide = _reponse.substring(debut, courant);
                            break;
                        }
                        courant++;
                    }
                }
            }
        }
    }
}
//----------------------------- initialise_CV_decodeur() -------------------------------------
void initialise_CV_decodeur() {
    for (int i = 0; i < 121; i++) {
        CV_decodeur[i] = -2;
    }
}
//----------------------------- vehicule_CV() ----------------------------------------------
void vehicule_CV() {
    int compte_CV = -1;
    for (Infos_CV inf0 : toutes_infos_CV) {
        compte_CV++;
        if (inf0.ID_CV == vehicule.ID) {
            vehicule.ID_CV = compte_CV;
        } else {
            vehicule.ID_CV = 0;
        }
    }
    sauve_table_Vehicules();
}
//----------------------------- initialise_CV_decodeur() -------------------------------------
void initialise_prop() {
    for (int i = 0; i < 29; i++) {
        prop[i] = "";
    }
}
//********************************************************************************************
//****************************** sauvegardes *************************************************
//-------------------------- sauvegarde_vehicule() -------------------------------
void sauvegarde_vehicule() {
    //------------ sauvegarde véhicule I -------------
    vehicule.sauve_veh_I[0] = vehicule.htamp;
    vehicule.sauve_veh_I[1] = int(vehicule.moteur);
    vehicule.sauve_veh_I[2] = int(vehicule.CV106);
    //------------ sauvegarde véhicule S -------------                    
    vehicule.sauve_veh_S[0] = vehicule.nom;
    vehicule.sauve_veh_S[1] = vehicule.image_t;
    vehicule.sauve_veh_S[2] = vehicule.marque;
    vehicule.sauve_veh_S[3] = vehicule.ref;
    vehicule.sauve_veh_S[4] = "#"+hex(color(vehicule.couleur)).substring(2);
    vehicule.sauve_veh_S[5] = vehicule.echelle;
    vehicule.sauve_veh_S[6] = vehicule.date;
}
//-------------------------- sauvegarde_infos_CV() -------------------------------
void sauvegarde_infos_CV() {
    if (vehicule.ID_CV != 0) {
        //----------- sauvegarde CV I -----------
        infos_CV.sauve_CV_I[0] = infos_CV.v_reelle;
        infos_CV.sauve_CV_I[1] = int(infos_CV.frein*10000);
        infos_CV.sauve_CV_I[2] = int(infos_CV.elan*10000);
        for (int i = 0; i < 5; i++) {
            infos_CV.sauve_CV_I[3+i] = infos_CV.p[i];
        }
        for (int i = 1; i < 201; i++) {
            infos_CV.sauve_CV_I[7+i] = infos_CV.CV[i];
        }
        //----------- sauvegarde CV S -----------
        infos_CV.sauve_CV_S[0] = infos_CV.fabricant;
        infos_CV.sauve_CV_S[1] = infos_CV.famille;
        infos_CV.sauve_CV_S[2] = infos_CV.modele;
    }
}
//-------------------------- recuperation_fiche() -------------------------------
void recuperation_vehicule() {
    //---------------------- récupération sauvegarde véhicule I ----------------------
    vehicule.htamp    = vehicule.sauve_veh_I[0];
    vehicule.moteur   = boolean(vehicule.sauve_veh_I[1]);
    vehicule.CV106    = vehicule.sauve_veh_I[2];
    //---------------------- récupération sauvegarde véhicule S ----------------------
    vehicule.nom      = vehicule.sauve_veh_S[0];
    vehicule.image_t  = vehicule.sauve_veh_S[1];
    vehicule.marque   = vehicule.sauve_veh_S[2];
    vehicule.ref      = vehicule.sauve_veh_S[3];
    vehicule.couleur  = unhex("FF"+vehicule.sauve_veh_S[4].substring(1));
    vehicule.echelle  = vehicule.sauve_veh_S[5];
    vehicule.date     = vehicule.sauve_veh_S[6];
    sauve_table_Vehicules();
}
//--------------------------recuperation_infos_CV() -------------------------------------
void recuperation_infos_CV() {
    if (vehicule.ID_CV != 0) {
        //----------------------- récupération sauvegarde CV I --------------------------
        infos_CV.v_reelle = infos_CV.sauve_CV_I[0];
        infos_CV.frein    = float(infos_CV.sauve_CV_I[1]/10000);
        infos_CV.elan     = float(infos_CV.sauve_CV_I[2]/10000);
        for (int i = 0; i < 5; i++) {
            infos_CV.p[i] = infos_CV.sauve_CV_I[3+i];
        }
        for (int i = 1; i < 201; i++) {
            infos_CV.CV[i] = infos_CV.sauve_CV_I[7+i];
        }
        //----------- récupération sauvegarde CV S -----------
        infos_CV.fabricant = infos_CV.sauve_CV_S[0];
        infos_CV.famille   = infos_CV.sauve_CV_S[1];
        infos_CV.modele    = infos_CV.sauve_CV_S[2];
        sauve_table_Infos_CV();
    }
}

///////////////////////////////// Pour les répertoires ////////////////////////////////////////
// This function returns all the files in a directory as an array of Strings  
String[] listFileNames(String dir) {
  File file = new File(dir);
  if (file.isDirectory()) {
    String names[] = file.list();
    return names;
  } else {
    // If it's not a directory
    return null;
  }
}
