//****************************************** mouseClicked() *************************************
void mouseClicked() {
    //---------------------- choix_onglet ------------------------------------
    if (choix_onglet && affiche_en_tete && !affiche_proprietaire) {
        for (Decodeur dec0 : tous_decodeurs) {
            if (dec0 != null && dec0.nom_modele.equals(gestion.modele_choisi)) {
                for (Zone zon0 : dec0.toutes_zones) {
                    if (mouseX > zon0.x  && mouseX < zon0.x+zon0.l
                     && mouseY > zon0.y  && mouseY < zon0.y+zon0.h) {
                        dec0.onglet_choisi = zon0.nom_zone;
                        textFont(Courier14);
                        gestion.dessine_en_tete();
                        dec0.reordonne_onglets();
                        dec0.grand_onglet(zon0.nom_zone);
                        if (dec0.onglet_choisi.equals("Fiche")) {
                            gestion.dessine_rectangle_creux(vehicule.couleur, 20F, 640F, 300F, 90F);
                        } else {
                            gestion.dessine_rectangle_creux(GRIS, 20F, 640F, 300F, 90F);
                        }
                        imageMode(CENTER);
                        image(vehicule.image_cote, 20F+300F/2F, 630F+100F/2F, vehicule.image_cote.width/4F, vehicule.image_cote.height/4F);
                        gestion.copie_ecran();
                        break;
                    }
                }
            }
        }                                    
    }
}
//****************************************** mouseDragged() *************************************
void mouseDragged() {
    //--------------------- curseur vertical -----------------------------
    if (dans_curseurV) {
        for (Decodeur dec0 : tous_decodeurs) {
            if (dec0 != null && dec0.onglet_choisi != null) {
                for (Onglet ong0 : tous_onglets) {
                    if (ong0.nom_onglet.equals(dec0.onglet_choisi)) {
                        ong0.hauteur_curseur[ong0.numero_curseur] = max(0, min(ong0.maxi_curseur, ong0.maxi_curseur*((ong0.curseur_down-mouseY)/(ong0.curseur_down-ong0.curseur_up))));
                    }
                }  
            }
        }
    }
    //------------------- curseur horizontal vehicule ----------------------------
    if (dans_curseurH_vehicule && !pupitre) { 
        int identite = vehicule.rang;
        if (mouseY > gestion.y0-30 && mouseY < gestion.y0+30) {
            gestion.largeur_curseur[0] = int(max(0, min((width-240), (mouseX-gestion.curseur_left)))+.5);
            identite = int(map(gestion.largeur_curseur[0], 0, gestion.l0, 0, tous_vehicules_filtres.size()-1)+.5);
            vehicule = tous_vehicules_filtres.get(identite);
            sauvegarde_vehicule();
            infos_CV = toutes_infos_CV.get(vehicule.ID_CV);
            sauvegarde_infos_CV();
            if (copier_CV && !coller_CV) {
                vehicule_copie = identite;
            }
        }
    }
    //------------------- curseur horizontal composition ----------------------------
    if (dans_curseurH_compo) { 
        if (mouseY > gestion.y0+250F-30F && mouseY < gestion.y0+250F+30F) {
            gestion.largeur_curseur[1] = int(max(0, min((width-240), (mouseX-gestion.curseur_left)))+.5);
            choix_train = int(map(gestion.largeur_curseur[1], 0, gestion.l0, 0, toutes_compositions.size()-1)+.5);
        }
    }
}
//*******************************************************************************************
//****************************************** keyPressed() *************************************
//*******************************************************************************************
void keyPressed() {
    if (key != CODED) {
        if (key == BACKSPACE) {
            if (texte_saisi.length() > 0) {
                texte_saisi = texte_saisi.substring(0, texte_saisi.length()-1);
            }
        } else {
            if (key == RETURN || key ==  ENTER) {
                saisie_valide = true;
                if (texte_saisi.equals("nc") || texte_saisi.equals("NC")) {
                    texte_saisi = "n.c.";
                }
                if (onglet != null) {
                    if (onglet.Groupes[0].numero_groupe == 5) {
                        for (int i = 0; i < 28; i++) {
                            if (onglet.Groupes[0].Boutons[i].valide) {
                                if (texte_saisi.equals("n.c.")) {
                                    switch (i) {
                                        case 10:
                                            texte_saisi = "nc";
                                            break;
                                        case 11:
                                            texte_saisi = "808080";
                                            break;
                                        case 12:
                                            texte_saisi = "n";
                                            break;
                                        case 15:
                                            texte_saisi = "";
                                            break;
                                        case 16:
                                            texte_saisi = "0";
                                            break;
                                        case 17:
                                            texte_saisi = "999";
                                            break;
                                        case 18:
                                            texte_saisi = "1";
                                            break;
                                        case 19:
                                            texte_saisi = "1";
                                            break;
                                    }
                                }
                                onglet.Groupes[0].Boutons[i].texte_saisi_b = texte_saisi;
                                break;
                            }
                        }
                    }
                    if (onglet.Groupes[0].numero_groupe == 6) {                            
                        onglet.Groupes[0].Boutons[5].adresse_saisie = int(texte_saisi);
                    }
                    if (onglet.Groupes[0].numero_groupe == 13) {
                        for (int i = 0; i < 28; i++) {
                            if (onglet.Groupes[0].Boutons[i].valide) {
                                onglet.Groupes[0].Boutons[i].texte_saisi_b = texte_saisi;
                                break;
                            }
                        }
                    }
                    texte_saisi   = "";
                }
                texte_information = null;
            } else {
                if (key != ESC) {
                    texte_saisi +=key;
                    saisie_valide = false;
                    if (onglet != null) {
                        if (onglet.Groupes[0].numero_groupe == 5) {                            
                            onglet.Groupes[0].Boutons[0].texte_saisi_b  = "";
                        }
                        if (onglet.Groupes[0].numero_groupe == 6) { 
                            onglet.Groupes[0].Boutons[5].adresse_saisie = -1;
                        }
                    }
                }
            }
        }
    }
}
//*******************************************************************************************
//*************************************** Zone{} ********************************************
//*******************************************************************************************
class Zone {
    String nom_zone;
    float  x        = 0F;
    float  y        = 0F;
    float  l        = 0F;
    float  h        = 0F;
    int    ligne    = 0;
    String debut[]  = new String[10];                                                             //  il n'y a pas plus de 10 lignes dans la liste des onglets
}
