//*************************************** Onglet() ********************************************
class Onglet {
    Groupe[] Groupes;
  
    String nom_onglet;
    float  x1                = 0;
    float  y1                = 0;
    float  l1                = 0;
    float  h1                = 0;
    float  curseur_down      = 0;
    float  curseur_up        = 0;
    float  x_curseur         = 0F;
    float  y_curseur         = 0F;
    float  zoom_c            = 1F;
    float  largeur_curseur   = 0F;
    float  ecart_curseur     = 0F;
    float  hauteur_curseur[] = new float[35];
    float  course_curseur    = 0;
    int    numero_curseur    = 0;
    String nom_vehicule;
    String date;
    String nom_groupe;
    int    parametre         = -1;
    float  p[]               = new float[5];
    int    compteur          = 0;
    float  maxi_curseur      = 0;

    Onglet(Groupe[] g0) {
        Groupes = g0;
    }  //  constructeur
    //---------------------------------- calcule_pointsV() ---------------------------------------------------------
    void calcule_pointsV(int _numero_curseur) {                                                                                             //  démarre à 0
        course_curseur    = curseur_down-curseur_up;
        x1 = x_curseur-largeur_curseur/2F+_numero_curseur*ecart_curseur;
        y1 = y_curseur;
        l1 = largeur_curseur;
        h1 = course_curseur;
        if (mouseX > x1-5F  && mouseX < x1+l1+5F
         && mouseY > y1-5F  && mouseY < y1+h1+5F) {
            if (mousePressed) {
                dans_curseurV  = true;
                numero_curseur = _numero_curseur;
            }
        }
    }
    //---------------------------------- dessine_curseurV() ---------------------------------------------------------
    void dessine_curseurV(int _numero_curseur) {                                                                                             //  démarre à 0
        imageMode(CORNER);
        image(curseurV,
              x_curseur-10+(_numero_curseur*ecart_curseur)*zoom_c,
              y_curseur-15+(curseur_down-y_curseur-(course_curseur)*hauteur_curseur[_numero_curseur]/maxi_curseur)*zoom_c,                      
              zoom_c*(largeur_curseur),
              1.5F*zoom_c*largeur_curseur);                                                                                                      //  l'image du curseur suit exactement la position de la souris
    }
    //---------------------------------- dessine_digits() ---------------------------------------------------------
    void dessine_digits(int _numero_curseur) {                                                                                              //  c'est un dessin : le numero de pupitte démarre à 0        
        textFont(fontUnits);
        fill(AQUA);
        textAlign(CENTER, CENTER);
        textSize(10F);
        text(int(hauteur_curseur[_numero_curseur]+.5),
             x_curseur+2F+(_numero_curseur*ecart_curseur)*zoom_c,
             y_curseur-20F*zoom_c);
    }
    //---------------------------- methodes vides ------------------------------
    void description_onglet() {}
    void dessine_onglet() {}
    void dessine_onglet_detaille() {}
    void maj_curseurs() {}
    void validation_onglet() {}
    void sortir_onglet() {}
}
//***************************************************************************************************
//************************************* Onglets particuliers ****************************************
//***************************************************************************************************
class Fiche extends Onglet {
    Fiche() {
        super(new Groupe[] { new Boutons_onglet_fiche(), new Boutons_validation_onglet() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Fiche";
    }
    //---------------------------- dessine_onglet() ----------------------------------
    void dessine_onglet() {
        imageMode(CORNER);
        image(ecran, 0, 0, width, height);                                                                                                     //  redessine tout le réseau avant d'afficher le pupitre
        groupe = Groupes[0];
        groupe.choix_onglet_fiche();
        groupe1 = Groupes[1];
        groupe1.valide_onglet();
    }
}
//***************************************************************************************************
class Configuration extends Onglet {
    Configuration() {
        super(new Groupe[] { new Boutons_onglet_configuration(), new Boutons_validation_onglet() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Configuration";
    }
    //----------------------------- dessine_onglet() -----------------------------
    void dessine_onglet() {
        imageMode(CORNER);
        image(ecran, 0, 0, width, height);                                                                                                     //  redessine tout le réseau avant d'afficher le pupitre
        if (vehicule.ID_CV != 0) {
            groupe = Groupes[0];
            groupe.choix_onglet_configuration();
            groupe1 = Groupes[1];
            groupe1.valide_onglet();
        }
    }
}
//***************************************************************************************************
class Onglet_adresse extends Onglet {
    Onglet_adresse() {
        super(new Groupe[] { new Boutons_onglet_adresse(), new Boutons_validation_onglet() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Adresse";
    }
    //----------------------------- dessine_onglet() -----------------------------
    void dessine_onglet() {
        imageMode(CORNER);
        image(ecran, 0, 0, width, height);                                                                                                     //  redessine tout le réseau avant d'afficher le pupitre
        if (vehicule.ID_CV != 0) {
            groupe = Groupes[0];
            groupe.choix_onglet_adresse();
            groupe1 = Groupes[1];
            groupe1.valide_onglet();
        }
    }
}
//***************************************************************************************************
class Moteur extends Onglet {
    Moteur() {
        super(new Groupe[] { new Boutons_onglet_moteur(), new Boutons_validation_onglet() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet      = "Moteur";
        x_curseur       = width/10F;
        y_curseur       = 170F;
        largeur_curseur = 20F;
        curseur_up      = 175F;
        curseur_down    = 500F;
        ecart_curseur   = width/16F;
        maxi_curseur    = 60F/0.896F;
    }
    //----------------------------- maj_curseurs() ---------------------------------------------
    void maj_curseurs() {
        hauteur_curseur[0] = infos_CV.CV[3];
        hauteur_curseur[1] = infos_CV.CV[4];
    }
    //---------------------------- dessine_onglet --------------------------------
    void dessine_onglet() {
        imageMode(CORNER);
        image(ecran, 0, 0, width, height);                                                                                                     //  redessine tout le réseau avant d'afficher le pupitre
        if (vehicule.ID_CV != 0) {
            groupe = Groupes[0];
            //if (!appui_validation) {
                groupe.choix_onglet_moteur();
            //}
            groupe1 = Groupes[1];
            groupe1.valide_onglet();
        }
    }
}
//***************************************************************************************************
class ControleBasiqueVitesse extends Onglet {
    ControleBasiqueVitesse() {
        super(new Groupe[] { new Boutons_onglet_controle_basique_de_vitesse(), new Boutons_validation_onglet() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Contrôle basique des vitesses";
        x_curseur       = width/4F;
        y_curseur       = 180F;
        largeur_curseur = 20F;
        curseur_up      = 180F;
        curseur_down    = 530F;
        ecart_curseur   = width/4F;
        maxi_curseur    = 255;
    }
    //----------------------------- maj_curseurs() ---------------------------------------------
    void maj_curseurs() {
        hauteur_curseur[0] = infos_CV.CV[2];
        hauteur_curseur[1] = infos_CV.CV[6];
        hauteur_curseur[2] = infos_CV.CV[5];
    }
    //---------------------------- dessine_onglet --------------------------------
    void dessine_onglet() {
        imageMode(CORNER);
        image(ecran, 0, 0, width, height);                                                                                                     //  redessine tout le réseau avant d'afficher le pupitre
        if (vehicule.ID_CV != 0) {
            groupe  = Groupes[0];
            groupe.choix_onglet_controle_basique_vitesse();
            groupe1 = Groupes[1];
            groupe1.valide_onglet();
        }
    }
}
//***************************************************************************************************
class TableauVitesse extends Onglet {
    TableauVitesse() {
        super(new Groupe[] { new Boutons_onglet_tableau_vitesse(), new Boutons_validation_onglet(), new Boutons_modif_courbe() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Tableau des vitesses";
        x_curseur       = width/38F+70F;
        y_curseur       = 180F;
        largeur_curseur = 20F;
        curseur_up      = 180F;
        curseur_down    = 530F;
        ecart_curseur   = width/38F;
        maxi_curseur    = 255;
    }
    //----------------------------- maj_curseurs() ---------------------------------------------
    void maj_curseurs() {
        for (int i = 0; i < 28; i++) {
            hauteur_curseur[i] = infos_CV.CV[67+i];
        }
        for (int i = 30; i < 35; i++) {
            hauteur_curseur[i] = infos_CV.p[i-30];
        }
    }
    //---------------------------- dessine_onglet --------------------------------
    void dessine_onglet() {
        imageMode(CORNER);
        image(ecran, 0, 0, width, height);                                                                                                     //  redessine tout le réseau avant d'afficher le pupitre
        if (vehicule.ID_CV != 0) {
            groupe  = Groupes[0];
            groupe.choix_onglet_table_vitesse();
            groupe1 = Groupes[1];
            groupe1.valide_onglet();
            groupe2 = Groupes[2];
            groupe2.modif_courbe();
        }
    }
}
//***************************************************************************************************
class CarteFonctions extends Onglet {
    CarteFonctions() {
        super(new Groupe[] { new Boutons_onglet_carte_fonctions(), new Boutons_validation_onglet() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Carte des fonctions NMRA";
    }
    //---------------------------- dessine_onglet --------------------------------
    void dessine_onglet() {
        imageMode(CORNER);
        image(ecran, 0, 0, width, height);                                                                                                     //  redessine tout le réseau avant d'afficher le pupitre
        if (vehicule.ID_CV != 0) {
            groupe = Groupes[0];
            groupe.choix_carte_fonctions();
            groupe1 = Groupes[1];
            groupe1.valide_onglet();
        }
    }
}
//***************************************************************************************************
class TableauCV extends Onglet {
    TableauCV() {
        super(new Groupe[] { new Boutons_onglet_tableau_CV(), new Boutons_transfert_donnees() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Tableau des CVs";
        initialise_CV_decodeur();
    }
    //----------------------------- dessine_onglet() -----------------------------
    void dessine_onglet() {
        imageMode(CORNER);
        image(ecran, 0, 0, width, height);                                                                                                     //  redessine tout le réseau avant d'afficher le pupitre
        if (vehicule.ID_CV != 0) {
            groupe = Groupes[0];
            groupe.choix_onglet_tableau_CV();
            groupe1 = Groupes[1];
            groupe1.transferts();
        }
    }
}
//***************************************************************************************************
class Proprietaires extends Onglet {
    Proprietaires() {
        super(new Groupe[] { new Boutons_onglet_fonctions_proprietaires(), new Boutons_validation_onglet() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Fonctions/Proprietaires";
    }
    //----------------------------- dessine_onglet() -----------------------------
    void dessine_onglet() {
        imageMode(CORNER);
        image(ecran, 0, 0, width, height);                                                                                                     //  redessine tout le réseau avant d'afficher le pupitre
        if (vehicule.ID_CV != 0) {
            groupe = Groupes[0];
            groupe.choix_onglet_fonctions_proprietaires();
            groupe1 = Groupes[1];
            groupe1.valide_onglet();
        }
    }
}
//***************************************************************************************************
class Lumieres extends Onglet {
    Lumieres() {
        super(new Groupe[] { new Boutons_onglet_lumieres() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Lumières";
    }
}
//***************************************************************************************************
class ControleAnalogique extends Onglet {
    ControleAnalogique() {
        super(new Groupe[] { new Boutons_onglet_controle_analogique() });
        nom_onglet = "Contrôles en analogique";
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
    }
}
//***************************************************************************************************
class Convoi extends Onglet {
    Convoi() {
        super(new Groupe[] { new Boutons_onglet_convoi() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Convois";
    }
}
//***************************************************************************************************
class Avance extends Onglet {
    Avance() {
        super(new Groupe[] { new Boutons_onglet_avance() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Avancé";
    }
}
//***************************************************************************************************
class Sons extends Onglet {
    Sons() {
        super(new Groupe[] { new Boutons_onglet_sons() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Sons";
    }
}
//***************************************************************************************************
class VolumeSons extends Onglet {
    VolumeSons() {
        super(new Groupe[] { new Boutons_onglet_volume_sons() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Volume des sons";
    }
}
//***************************************************************************************************
class AccelDecel extends Onglet {
    AccelDecel() {
        super(new Groupe[] { new Boutons_onglet_accel_decel() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Accélération/décélération";
    }
}
//***************************************************************************************************
class ShuntUncouple extends Onglet {
    ShuntUncouple() {
        super(new Groupe[] { new Boutons_onglet_shunt_uncouple() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Shunt/Uncouple";
    }
}
//***************************************************************************************************
class AltFunctionMap extends Onglet {
    AltFunctionMap() {
        super(new Groupe[] { new Boutons_onglet_alt_fonctions_map() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Alt Function Map";
    }
}
//***************************************************************************************************
class FunctionOutput extends Onglet {
    FunctionOutput() {
        super(new Groupe[] { new Boutons_onglet_fonctions_output() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Function Output";
    }
}
//***************************************************************************************************
class ZimoSpecific extends Onglet {
    ZimoSpecific() {
        super(new Groupe[] { new Boutons_onglet_zimo_specific() });
        nom_onglet = "Zimo Specific";
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
    }
}
//***************************************************************************************************
class Railcom extends Onglet {
    Railcom() {
        super(new Groupe[] { new Boutons_onglet_railcom() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Railcom";
    }
}
//***************************************************************************************************
class ABC extends Onglet {
    ABC() {
        super(new Groupe[] { new Boutons_onglet_abc() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "ABC";
    }
}
//***************************************************************************************************
class SpeedRegulation extends Onglet {
    SpeedRegulation() {
        super(new Groupe[] { new Boutons_onglet_speed_regulation() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "SpeedRegulation";
    }
}
//***************************************************************************************************
class Servos extends Onglet {
    Servos() {
        super(new Groupe[] { new Boutons_onglet_servos() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Servos";
    }
}
